/**
 * @license
 * Copyright 2022 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import*as e from"@tensorflow/tfjs-core";import{env as t,backend_util as n,util as r,Fill as s,Reshape as i,broadcast_util as a,_FusedMatMul as o,Identity as u,Complex as l,upcastType as h,buffer as d,slice_util as c,TensorBuffer as p,Abs as f,Add as m,AddN as g,Transpose as b,ArgMax as x,ArgMin as w,AvgPool as I,BatchMatMul as y,Slice as k,BatchToSpaceND as S,NotEqual as v,Real as C,Cast as $,Ceil as R,ClipByValue as A,Imag as z,Concat as P,Conv2D as T,Conv2DBackpropInput as E,Cos as B,Cosh as N,CropAndResize as _,Cumprod as O,Cumsum as F,DepthToSpace as G,DepthwiseConv2dNative as U,Multiply as L,sumOutType as M,Sum as D,Einsum as W,Elu as V,Equal as H,Exp as X,ExpandDims as q,Expm1 as K,FlipLeftRight as Y,Floor as j,FloorDiv as Q,FromPixels as Z,FusedBatchNorm as J,FusedConv2D as ee,FusedDepthwiseConv2D as te,GatherNd as ne,GatherV2 as re,Greater as se,GreaterEqual as ie,LeakyRelu as ae,Less as oe,LessEqual as ue,Log as le,LogicalAnd as he,LogicalNot as de,Max as ce,Maximum as pe,MaxPool as fe,Mean as me,Min as ge,Minimum as be,MirrorPad as xe,Neg as we,NonMaxSuppressionV3 as Ie,kernel_impls as ye,NonMaxSuppressionV5 as ke,ZerosLike as Se,OnesLike as ve,Pack as Ce,PadV2 as $e,Pow as Re,Prelu as Ae,Prod as ze,Range as Pe,RealDiv as Te,Relu as Ee,Relu6 as Be,ResizeBilinear as Ne,ResizeNearestNeighbor as _e,RotateWithOffset as Oe,Rsqrt as Fe,ScatterNd as Ge,Select as Ue,Sigmoid as Le,Sin as Me,Sinh as De,Sub as We,Softmax as Ve,SpaceToBatchND as He,Tile as Xe,SparseToDense as qe,SplitV as Ke,Sqrt as Ye,Square as je,SquaredDifference as Qe,StridedSlice as Ze,StringNGrams as Je,Tanh as et,TopK as tt,Transform as nt,Unpack as rt,registerKernel as st,KernelBackend as it,DataStorage as at,engine as ot,registerBackend as ut}from"@tensorflow/tfjs-core";const lt=t();var ht;lt.registerFlag("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE",(()=>15)),lt.registerFlag("WEBGPU_CPU_FORWARD",(()=>!0)),lt.registerFlag("WEBGPU_MATMUL_WORK_PER_THREAD",(()=>4)),lt.registerFlag("WEBGPU_MATMUL_PROGRAM_TYPE",(()=>-1)),lt.registerFlag("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE",(()=>!1)),lt.registerFlag("WEBGPU_USE_LOW_POWER_GPU",(()=>!1)),lt.registerFlag("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD",(()=>1e3)),lt.registerFlag("WEBGPU_USE_PROFILE_TOOL",(()=>!1)),lt.registerFlag("WEBGPU_IMPORT_EXTERNAL_TEXTURE",(()=>!1)),function(e){e[e.MUL=0]="MUL",e[e.ADD=1]="ADD",e[e.SUB=2]="SUB",e[e.DIV=3]="DIV",e[e.EQUAL=4]="EQUAL",e[e.GREATER=5]="GREATER",e[e.GREATER_EQUAL=6]="GREATER_EQUAL",e[e.LESS=7]="LESS",e[e.LESS_EQUAL=8]="LESS_EQUAL",e[e.LOGICAL_AND=9]="LOGICAL_AND",e[e.NOT_EQUAL=10]="NOT_EQUAL",e[e.SQUARED_DIFFERENCE=11]="SQUARED_DIFFERENCE",e[e.INT_DIV=12]="INT_DIV",e[e.POW=13]="POW",e[e.PRELU=14]="PRELU",e[e.MAX=15]="MAX",e[e.MIN=16]="MIN",e[e.COMPLEX_MULTIPLY_REAL=17]="COMPLEX_MULTIPLY_REAL",e[e.COMPLEX_MULTIPLY_IMAG=18]="COMPLEX_MULTIPLY_IMAG"}(ht||(ht={}));const dt="\n  if (isNaN.r) {\n    resultTemp.r = uniforms.NAN;\n  }\n  if (isNaN.g) {\n    resultTemp.g = uniforms.NAN;\n  }\n  if (isNaN.b) {\n    resultTemp.b = uniforms.NAN;\n  }\n  if (isNaN.a) {\n    resultTemp.a = uniforms.NAN;\n  }\n  ",ct=`\n  let isModRound1Bool = vec4<i32>(round(abs(b) % vec4<f32>(2.0))) == vec4<i32>(1);\n  let isModRound1 = vec4<f32>(isModRound1Bool);\n  let multiplier = sign(a) * isModRound1 + (vec4<f32>(1.0) - isModRound1);\n  var resultTemp = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  let isExpZero = b == vec4<f32>(0.0);\n  if (isExpZero.r) {\n    resultTemp.r = 1.0;\n  }\n  if (isExpZero.g) {\n    resultTemp.g = 1.0;\n  }\n  if (isExpZero.b) {\n    resultTemp.b = 1.0;\n  }\n  if (isExpZero.a) {\n    resultTemp.a = 1.0;\n  }\n  let isNaN = a < vec4<f32>(0.0) & floor(b) < b;\n  ${dt}\n  return resultTemp;\n  `;function pt(e,t){const n=t?dt:"\n  if (isnan(a)) { return a; }\n  if (isnan(b)) { return b; }\n  ";return t?`\n    var resultTemp = vec4<f32>(${e}(a, b));\n    let isNaN = isnanVec4(a) | isnanVec4(b);\n    `+n+"\n    return resultTemp;\n  ":n+`\n    return ${e}(a, b);\n  `}function ft(e,t){switch(e){case ht.MUL:return"return a * b;";case ht.ADD:return"return a + b;";case ht.SUB:return"return a - b;";case ht.DIV:return"return a / b;";case ht.EQUAL:return t?"return vec4<f32>(a == b);":"return f32(a == b);";case ht.GREATER:return t?"return vec4<f32>(a > b);":"return f32(a > b);";case ht.GREATER_EQUAL:return t?"return vec4<f32>(a >= b);":"return f32(a >= b);";case ht.LESS:return t?"return vec4<f32>(a < b);":"return f32(a < b);";case ht.LESS_EQUAL:return t?"return vec4<f32>(a <= b);":"return f32(a <= b);";case ht.LOGICAL_AND:return t?"return (vec4<f32>(a >= vec4<f32>(1.0)) *\n  vec4<f32>(b >= vec4<f32>(1.0)));":"return f32(f32(a) >= 1.0 && f32(b) >= 1.0);";case ht.NOT_EQUAL:return t?"return vec4<f32>(a != b);":"return f32(a != b);";case ht.SQUARED_DIFFERENCE:return"return (a - b) * (a - b);";case ht.INT_DIV:return t?"\n  let ia = vec4<i32>(round(a));\n  let ib = vec4<i32>(round(b));\n  let cond = ib != vec4<i32>(0);\n  var resultTemp = vec4<i32>(0);\n  let s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    resultTemp[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    resultTemp[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    resultTemp[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    resultTemp[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4<f32>(resultTemp);\n  ":"\n  let s = sign(a) * sign(b);\n  let ia = i32(round(a));\n  let ib = i32(round(b));\n  return f32(idiv(ia, ib, s));\n  ";case ht.PRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (b * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n  ":"if (a < 0.0) { return b * a; }  return a;";case ht.MAX:return pt("max",t);case ht.MIN:return pt("min",t);case ht.POW:return t?ct:"\n  if(a < 0.0 && floor(b) < b) {\n    return uniforms.NAN;\n  }\n  if (b == 0.0) {\n    return 1.0;\n  }\n  if (round(abs(b) % 2.0) != 1.0) {\n    return pow(abs(a), b);\n  }\n  return sign(a) * pow(abs(a), b);\n  ";case ht.COMPLEX_MULTIPLY_REAL:return"return areal * breal - aimag * bimag;";case ht.COMPLEX_MULTIPLY_IMAG:return"return areal * bimag + aimag * breal;";default:throw new Error(`BinaryType ${e} is not implemented!`)}}var mt;!function(e){e[e.ABS=0]="ABS",e[e.CEIL=1]="CEIL",e[e.COS=2]="COS",e[e.COSH=3]="COSH",e[e.ELU=4]="ELU",e[e.EXP=5]="EXP",e[e.EXPM1=6]="EXPM1",e[e.FLOOR=7]="FLOOR",e[e.LINEAR=8]="LINEAR",e[e.LOG=9]="LOG",e[e.LOGICAL_NOT=10]="LOGICAL_NOT",e[e.NEG=11]="NEG",e[e.RELU=12]="RELU",e[e.RELU6=13]="RELU6",e[e.LEAKYRELU=14]="LEAKYRELU",e[e.RSQRT=15]="RSQRT",e[e.SIN=16]="SIN",e[e.SINH=17]="SINH",e[e.SIGMOID=18]="SIGMOID",e[e.SQRT=19]="SQRT",e[e.SQUARE=20]="SQUARE",e[e.TANH=21]="TANH",e[e.TO_INT=22]="TO_INT"}(mt||(mt={}));function gt(e,t){switch(e){case mt.ABS:return"return abs(a);";case mt.COS:return"return cos(a);";case mt.COSH:return"\n  let e2x = exp(-a);\n  return (e2x + 1.0 / e2x) / 2.0;\n";case mt.CEIL:return"return ceil(a);";case mt.ELU:return t?"\n  var resFloat = exp(a) - vec4<f32>(1.0);\n  if (a.r >= 0.0) {\n    resFloat.r = a.r;\n  }\n  if (a.g >= 0.0) {\n    resFloat.g = a.g;\n  }\n  if (a.b >= 0.0) {\n    resFloat.b = a.b;\n  }\n  if (a.a >= 0.0) {\n    resFloat.a = a.a;\n  }\n  return resFloat;\n":"if (a >= 0.0) { return a; }  return (exp(a) - 1.0);";case mt.EXP:return"return exp(a);";case mt.EXPM1:return"return exp(a) - 1.0;";case mt.FLOOR:return"return floor(a);";case mt.LINEAR:return"return a;";case mt.LOG:return"if (a < 0.0) { return 1.0/0.0; }\n  return log(a);";case mt.LOGICAL_NOT:return"return f32(!(a >= 1.0));";case mt.NEG:return"return -a;";case mt.LEAKYRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (uniforms.alpha * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return uniforms.alpha * a; } return a;";case mt.RELU:return t?"\n  return select(a, vec4<f32>(0.0), a < vec4<f32>(0.0));\n":"return select(a, 0.0, a < 0.0);";case mt.RELU6:return t?"return clamp(a, vec4<f32>(0.0, 0.0, 0.0, 0.0), vec4<f32>(6.0, 6.0, 6.0, 6.0));":"return clamp(a, 0.0, 6.0);";case mt.RSQRT:return"return 1.0/sqrt(a);";case mt.SIGMOID:return"return 1.0 / (1.0 + exp(-1.0 * a));";case mt.SIN:return"return sin(a);";case mt.SINH:return"\n  let e2x = exp(a);\n  return (e2x - 1.0 / e2x) / 2.0;\n";case mt.SQRT:return"return sqrt(a);";case mt.SQUARE:return"return a * a;";case mt.TANH:return"\n  let e2x = exp(-2.0 * abs(a));\n  return sign(a) * (1.0 - e2x) / (1.0 + e2x);\n";case mt.TO_INT:return"return f32(i32((a)));";default:throw new Error(`BinaryType ${e} is not implemented!`)}}const bt=e=>{switch(e){case 1:return"f32";case 2:return"vec2<f32>";case 3:return"vec3<f32>";case 4:return"vec4<f32>";default:throw new Error(`${e}-component is not supported.`)}};function xt(e,t=!1,n=!1,r=3){if(null===e)return"";let s="";if("linear"===e)s=gt(mt.LINEAR);else if("relu"===e)s=gt(mt.RELU,n);else if("elu"===e)s=gt(mt.ELU,n);else if("relu6"===e)s=gt(mt.RELU6,n);else if("prelu"===e)s=ft(ht.PRELU,n);else if("sigmoid"===e)s=gt(mt.SIGMOID,n);else{if("leakyrelu"!==e)throw new Error(`Activation ${e} has not been implemented for the WebGPU backend.`);s=gt(mt.LEAKYRELU,n)}const i=bt(n?4:1);let a="";return a=t?`\n      fn activation(a : ${i}, coords : vec${r}<i32>) -> ${i} {\n        let b = getPreluActivationWeightsByOutputCoords(coords);\n        ${s}\n      }`:`\n      fn activation(a : ${i}, coords : vec${r}<i32>) -> ${i} {\n        ${s}\n      }`,a}function wt(e,t){return`\n      ${e?"value = value + getBiasByOutputCoords(coords);":""}\n      ${t?"value = activation(value, coords);":""}\n      `}function It(e,t){if(Math.max(...e)>3)throw new Error("Cannot symbolically compute strides for rank > 4 tensor.");const n=e.length,r=e.map((e=>`${t}[${e}]`)),s=new Array(n-1);s[n-2]=r[n-1];for(let e=n-3;e>=0;--e)s[e]=`(${s[e+1]} * ${r[e+1]})`;return s}const yt=(e,t,s,i)=>{const a=function(e,t,s){const i=[];if(i.push(`\n      const workGroupSizeX = ${s.workGroupSize[0]}u;\n      const workGroupSizeY = ${s.workGroupSize[1]}u;\n      const workGroupSizeZ = ${s.workGroupSize[2]}u;\n\n      var<private> localId: vec3<u32>;\n      var<private> globalId: vec3<u32>;\n      var<private> numWorkgroups: vec3<u32>;\n\n      // Only used when the y/z dimension of workgroup size is 1.\n      fn getGlobalIndex() -> i32 {\n        ${Pt(s)?"  return i32(globalId.x);":"  let localInvocationIndex = localId.z * workGroupSizeX * workGroupSizeY +\n                   localId.y * workGroupSizeX + localId.x;\n               let workGroupID = (globalId - localId)/vec3<u32>(\n                   workGroupSizeX, workGroupSizeY, workGroupSizeZ);\n\n               return i32((workGroupID.z * numWorkgroups.x * numWorkgroups.y +\n                   workGroupID.y * numWorkgroups.x + workGroupID.x) *\n                   (workGroupSizeX * workGroupSizeY * workGroupSizeZ) +\n                   localInvocationIndex);\n        "}\n      }\n    `),s.isFromPixels)return i.push(`\n        struct Uniform {\n          size            : i32,\n          numChannels     : i32,\n          outShapeStrides : vec2<i32>,\n        };\n\n        @group(0) @binding(0) var<storage, read_write> result: array<${Tt(t.dtype,s.isVec4)}>;\n        @group(0) @binding(2) var<uniform> uniforms: Uniform;\n      `),[Rt,i.join("\n"),At(t.shape),s.getUserCode()].join("\n");let a=!1,o=!1,u="struct Uniforms { NAN : f32, ";s.variableNames.forEach(((t,n)=>{const r=kt(e[n].shape.length);"vec5"!==r&&"vec6"!==r||(o=!0),(a||o)&&(u+="@align(16) "),a=o,u+=`${t.charAt(0).toLowerCase()+t.slice(1)}Shape : ${r}, `}));const l=kt(t.shape.length);o="vec5"===l||"vec6"===l,(a||o)&&(u+="@align(16) ");a=o,u+=`outShape : ${l}, `;const h=kt(t.shape.length-1);o="vec5"===h||"vec6"===h,(a||o)&&(u+="@align(16) ");a=o,u+=`\n         outShapeStrides: ${h}, `,s.size&&(a&&(u+="@align(16) "),a=!1,u+="size : i32, ");s.uniforms&&(a&&(u+="@align(16) "),u+=s.uniforms);u+="};",i.push(u),s.atomic?i.push("\n      @group(0) @binding(0) var<storage, read_write> result: array<atomic<i32>>;\n    "):i.push(`\n      @group(0) @binding(0) var<storage, read_write> result: array<${Tt(t.dtype,s.isVec4)}>;\n    `);s.variableNames.forEach(((t,n)=>{i.push(`\n      @group(0) @binding(${1+n}) var<storage, read> ${t}: array<${s.variableTypes?s.variableTypes[n]:Tt(e[n].dtype,s.isVec4)}>;\n        `)})),""!==u&&i.push(`\n      @group(0) @binding(${1+s.variableNames.length}) var<uniform> uniforms: Uniforms;\n      `);const d=function(e,t){const{x:n,y:r=[],z:s=[]}=t,i=e.length;if(n.length===i){return`fn getOutputCoords() -> ${kt(i)}{\n    let globalIndex = getGlobalIndex();\n    return getCoordsFromIndex(globalIndex);\n  }\n  `}let a="";const o=[n,r,s];let u=0;for(let e=0;e<o.length;e++){const t=o[e];if(0!==t.length)if(u+=t.length,1===t.length)a+=`let d${t[0]} = i32(globalId[${e}]);`;else{const n=It(t,"uniforms.outShape");a+=`var index${e} = i32(globalId[${e}]);`;for(let r=0;r<n.length;r++)a+=`let d${t[r]} = index${e} / ${n[r]};`,r===n.length-1?a+=`let d${t[r+1]} = index${e} - d${t[r]} * ${n[r]};`:a+=`index${e} = index${e} - d${t[r]} * ${n[r]};`}}const l=[];for(let e=0;e<u;e++)l.push(`d${e}`);const h=kt(u);let d=`fn getOutputCoords() -> ${h} {\n  ${a}\n`;0===l.length?d+=`return ${h}(0); }`:d+=`return ${h}(${l.join(",")}); }`;return d}(t.shape,s.dispatchLayout),c=[Rt,i.join("\n"),At(t.shape),d,zt(t.shape.length)];s.atomic||c.push(function(e,t,n){const r=e.length,s=Tt(t,n);let i;i=n?`fn setOutputAtIndex(flatIndex : i32, value : vec4<f32>) {\n      result[flatIndex] = ${s}(value);\n    }\n    fn setOutputAtIndexI32(flatIndex : i32, value : vec4<i32>) {\n      result[flatIndex] = ${s}(value);\n    }`:`fn setOutputAtIndex(flatIndex : i32, value : f32) {\n      result[flatIndex] = ${s}(value);\n    }\n    fn setOutputAtIndexI32(flatIndex : i32, value : i32) {\n      result[flatIndex] = ${s}(value);\n    }`;if(r>=2){const e=["d0","d1","d2","d3","d4","d5"].slice(0,r),t=kt(r);i+=n?`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : vec4<f32>) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex / 4, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : vec4<i32>) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex / 4, value);\n      }\n    `:`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : f32) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : i32) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex, value);\n      }\n    `}return i}(t.shape,t.dtype,s.isVec4));const p=e.map(((e,i)=>function(e,t,s,i){let a=function(e,t){const n=e.name,r=e.shape.length,s=kt(r),i="get"+n.charAt(0).toUpperCase()+n.slice(1),a=["d0","d1","d2","d3","d4","d5"].slice(0,r),o=a.map((e=>`${e} : i32`)).join(", ");if(r<1)return t?`\n        fn ${i}() -> vec4<f32> {\n          return vec4<f32>(${n}[0]);\n        }\n      `:`\n      fn ${i}() ->f32 {\n        return f32(${n}[0]);\n      }\n    `;const u=`uniforms.${n.charAt(0).toLowerCase()+n.slice(1)}Shape`;let l=`${r}D`;0===r&&(l="1D");if(t)return`\n      fn ${i}(${o}) -> vec4<f32> {\n        return vec4<f32>(${n}[getIndexFromCoords${l}(${s}(${a.join(",")}),\n          ${u}) / 4]);\n      }\n      `;return`\n    fn ${i}(${o}) -> f32 {\n      return f32(${n}[getIndexFromCoords${l}(${s}(${a.join(",")}),\n        ${u})]);\n    }\n   `}(e,s);e.shape.length<=t.length&&(a+=function(e,t,s,i){const a=e.name,o=a.charAt(0).toUpperCase()+a.slice(1),u="get"+o+"ByOutput",l=e.shape.length,h=t.length,d=kt(h);if(r.arraysEqual(e.shape,t)&&i)return s?`\n      fn ${u}Index(globalIndex : i32) -> vec4<f32> {\n        return vec4<f32>(${a}[globalIndex]);\n      }\n\n      fn ${u}Coords(coords : ${d}) -> vec4<f32> {\n        return vec4<f32>(${a}[${h>1?"getOutputIndexFromCoords(coords)":"coords"} / 4]);\n      }\n      `:`\n    fn ${u}Index(globalIndex : i32) -> f32 {\n      return f32(${a}[globalIndex]);\n    }\n\n    fn ${u}Coords(coords : ${d}) -> f32 {\n      return f32(${a}[${h>1?"getOutputIndexFromCoords(coords)":"coords"}]);\n    }\n    `;const c=n.getBroadcastDims(e.shape,t),p=h-l;let f="";if(0===l)return s?`\n    fn ${u}Index(globalIndex : i32) -> vec4<f32> {\n      return get${o}();\n    }\n\n    fn ${u}Coords(coords : ${d}) -> vec4<f32> {\n      return get${o}();\n    }\n  `:`\n    fn ${u}Index(globalIndex : i32) -> f32{\n      return get${o}();\n    }\n\n    fn ${u}Coords(coords : ${d}) -> f32{\n      return get${o}();\n    }\n  `;f=h<2&&c.length>=1?"coords = 0;":c.map((e=>`coords.${St(e+p)} = 0;`)).join("\n");let m="";if(h<2&&l>0)m="coords";else if(h>1){const t=kt(l),n=e.shape.map(((e,t)=>`coords.${St(t+p)}`)).join(", ");m=`${t}(${n})`}else m="coords";const g=`uniforms.${a.charAt(0).toLowerCase()+a.slice(1)}Shape`,b=`${l}D`;if(s)return`\n    fn ${u}Index(globalIndex : i32) -> vec4<f32> {\n      var coords = getCoordsFromIndex(globalIndex);\n      ${f}\n      return ${a}[getIndexFromCoords${b}(${m}, ${g}) / 4];\n    }\n\n    fn ${u}Coords(coordsIn : ${d}) -> vec4<f32> {\n      var coords = coordsIn;\n      ${f}\n      return ${a}[getIndexFromCoords${b}(${m}, ${g}) / 4];\n    }\n  `;return`\n  fn ${u}Index(globalIndex : i32) -> f32 {\n    var coords = getCoordsFromIndex(globalIndex);\n    ${f}\n    return f32(${a}[getIndexFromCoords${b}(${m}, ${g})]);\n  }\n\n  fn ${u}Coords(coordsIn : ${d}) -> f32 {\n    var coords = coordsIn;\n    ${f}\n    return f32(${a}[getIndexFromCoords${b}(${m}, ${g})]);\n  }\n`}(e,t,s,i));return a}(e,t.shape,s.variableTypes?"vec4<f32>"===s.variableTypes[i]:s.isVec4,s.dispatchLayout.x.length===t.shape.length))).join("\n");c.push(p),c.push(s.getUserCode());return c.join("\n")}(s,{dtype:i.dtype,shape:i.shape},t),o=e.createShaderModule({code:a,label:t.constructor.name});return e.createComputePipeline({compute:{module:o,entryPoint:"main"},label:t.constructor.name,layout:"auto"})};function kt(e){if(e<=1)return"i32";if(2===e)return"vec2<i32>";if(3===e)return"vec3<i32>";if(4===e)return"vec4<i32>";if(5===e)return"vec5";if(6===e)return"vec6";throw Error(`GPU for rank ${e} is not yet supported`)}function St(e){if(0===e)return"x";if(1===e)return"y";if(2===e)return"z";if(3===e)return"w";if(4===e)return"u";if(5===e)return"v";throw Error(`Index ${e} is not yet supported`)}function vt(){return`\n    ${Ct()}\n      let index = getGlobalIndex();\n`}function Ct(){return`\n  ${$t()}\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n`}function $t(){return"\n  @compute @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n"}const Rt="\n  struct vec5 {x: i32, y: i32, z: i32, w: i32, u: i32};\n  struct vec6 {x: i32, y: i32, z: i32, w: i32, u: i32, v: i32};\n\n  // Checks whether coordinates lie within the bounds of the shape.\n  fn coordsInBounds2D(coord : vec2<i32>, shape : vec2<i32>) -> bool {\n    return all(coord >= vec2<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds3D(coord : vec3<i32>, shape : vec3<i32>) -> bool {\n    return all(coord >= vec3<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds4D(coord : vec4<i32>, shape : vec4<i32>) -> bool {\n    return all(coord >= vec4<i32>(0)) && all(coord < shape);\n  }\n\n  fn getIndexFromCoords1D(coord : i32, shape : i32) -> i32 {\n    return coord;\n  }\n  fn getIndexFromCoords2D(coords : vec2<i32>, shape : vec2<i32>) -> i32 {\n    return dot(coords, vec2<i32>(shape.y, 1));\n  }\n  fn getIndexFromCoords3D(coords : vec3<i32>, shape : vec3<i32>) -> i32 {\n    return dot(coords, vec3<i32>(shape.y * shape.z, shape.z, 1));\n  }\n  fn getIndexFromCoords4D(coords : vec4<i32>, shape : vec4<i32>) -> i32 {\n    return dot(coords, vec4<i32>(\n        shape.y * shape.z * shape.w, shape.z * shape.w, shape.w, 1));\n  }\n  fn getIndexFromCoords5D(coords : vec5, shape : vec5) -> i32 {\n    let shapeStrides: vec5 = vec5(shape.y * shape.z * shape.w * shape.u, shape.z * shape.w * shape.u, shape.w * shape.u, shape.u, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u;\n  }\n  fn getIndexFromCoords6D(coords : vec6, shape : vec6) -> i32 {\n    let shapeStrides: vec6 = vec6(shape.y * shape.z * shape.w * shape.u * shape.v, shape.z * shape.w * shape.u * shape.v, shape.w * shape.u * shape.v, shape.u * shape.v, shape.v, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u + coords.v*shapeStrides.v;\n  }\n\n  fn idiv(a: i32, b: i32, sign: f32) -> i32 {\n    var res: i32 = a / b;\n    let mod: i32 = a % b;\n    if (sign < 0. && mod != 0) {\n      res = res - 1;\n    }\n    return res;\n  }\n\n  // NaN defination in IEEE 754-1985 is :\n  //   - sign = either 0 or 1.\n  //   - biased exponent = all 1 bits.\n  //   - fraction = anything except all 0 bits (since all 0 bits represents infinity).\n  // https://en.wikipedia.org/wiki/IEEE_754-1985#Representation_of_non-numbers\n  fn isnan(val: f32) -> bool {\n    let floatToUint: u32 = bitcast<u32>(val);\n    return (floatToUint & 0x7fffffffu) > 0x7f800000u;\n  }\n  fn isnanVec4(val : vec4<f32>) -> vec4<bool> {\n    return vec4<bool>(isnan(val[0]), isnan(val[1]), isnan(val[2]), isnan(val[3]));\n  }\n";function At(e){const t=e.length;if(t<=1)return"fn getCoordsFromIndex(index : i32) -> i32 { return index; }";const n=r.computeStrides(e),s=kt(t),i=[];for(let e=0;e<t;e++)i.push(`d${e}`);if(1===n.length)return"    fn getCoordsFromIndex(index : i32) -> vec2<i32> {\n      let d0 = index / uniforms.outShapeStrides; let d1 = index - d0 * uniforms.outShapeStrides;\n      return vec2<i32>(d0, d1);\n    }";let a;return a="var index2 = index;"+n.map(((e,t)=>`${`let ${i[t]} = index2 / uniforms.outShapeStrides.${St(t)}`}; ${t===n.length-1?`let ${i[t+1]} = index2 - ${i[t]} * uniforms.outShapeStrides.${St(t)}`:`index2 = index2 - ${i[t]} * uniforms.outShapeStrides.${St(t)}`};`)).join(""),`\n    fn getCoordsFromIndex(index : i32) -> ${s} {\n      ${a}\n      return ${s}(${i.join(",")});\n    }\n  `}function zt(e){let t="";switch(e){case 0:case 1:t+="\n        fn getOutputIndexFromCoords(coords : i32) -> i32 {\n          return coords;\n        }\n        ";break;case 2:t+="\n        fn getOutputIndexFromCoords(coords : vec2<i32>) -> i32 {\n          return dot(coords, vec2<i32>(uniforms.outShapeStrides, 1));\n        }\n        ";break;case 3:t+="\n        fn getOutputIndexFromCoords(coords : vec3<i32>) -> i32 {\n          return dot(coords, vec3<i32>(uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, 1));\n        }\n        ";break;case 4:t+="\n        fn getOutputIndexFromCoords(coords : vec4<i32>) -> i32 {\n          return dot(coords, vec4<i32>(\n            uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, uniforms.outShapeStrides.z, 1));\n        }\n        ";break;case 5:t+="\n        fn getOutputIndexFromCoords(coords : vec5) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u;\n        }\n        ";break;case 6:t+="\n        fn getOutputIndexFromCoords(coords : vec6) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u * uniforms.outShapeStrides.u +\n              coords.v;\n        }\n        ";break;default:r.assert(!1,(()=>`Unsupported ${e}D shape`))}return t}function Pt(e){return 1===e.dispatch[1]&&1===e.dispatch[2]}function Tt(e,t){return"float32"===e?t?"vec4<f32>":"f32":"int32"===e||"bool"===e?t?"vec4<i32>":"i32":e}const Et=e=>{let t=1;for(let n=0;n<e.length;n++)t*=e[n];return t};function Bt(e,t,n=[1,1,1],r=[1,1,1]){const[s,i,a]=[Math.ceil(Et(e.x.map((e=>t[e])))/(n[0]*r[0])),e.y?Math.ceil(Et(e.y.map((e=>t[e])))/(n[1]*r[1])):1,e.z?Math.ceil(Et(e.z.map((e=>t[e])))/(n[2]*r[2])):1];return[s,i,a]}function Nt(e,t,n=!1){if(n)return[8,8,1];const r=Et(e.x.map((e=>t[e]))),s=Et(e.y.map((e=>t[e])));return r<=4?[4,16,1]:s<=4?[16,4,1]:[16,16,1]}function _t(e,t,n){return 1===e?[32,1,1]:1===n?[1,32,1]:[8,8,1]}function Ot(e,t,n=!1){if(n)return[4,4,1];const r=Et(e.x.map((e=>t[e]))),s=Et(e.y.map((e=>t[e])));return r<=4?[1,2,1]:s<=4?[2,1,1]:[2,2,1]}function Ft(e){return{x:e.map(((e,t)=>t))}}function Gt(e){if("float32"===e||"int32"===e||"bool"===e||"string"===e)return 4;if("complex64"===e)return 8;throw new Error(`Unknown dtype ${e}`)}function Ut(e,t){if("float32"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t||"string"===t)return Uint8Array.from(new Int32Array(e));throw new Error(`Unknown dtype ${t}`)}function Lt(){return("undefined"!=typeof window||"undefined"!=typeof WorkerGlobalScope)&&!!navigator.gpu}var Mt;!function(e){e[e.MatMulPackedVec4Program=0]="MatMulPackedVec4Program",e[e.MatMulReduceProgram=1]="MatMulReduceProgram",e[e.MatMulSplitKProgram=2]="MatMulSplitKProgram",e[e.MatMulSmallOutputSizeProgram=3]="MatMulSmallOutputSizeProgram",e[e.MatMulPackedProgram=4]="MatMulPackedProgram",e[e.MatMulMax=5]="MatMulMax"}(Mt||(Mt={}));var Dt={__proto__:null,tilesFitEvenlyIntoShape:function(e,t){if(e.length!==t.length)throw new Error(`Cannot compute whether rank ${e.length} tiles fit evenly into rank ${t.length} shape - ranks must match.`);return t.every(((t,n)=>t%e[n]==0))},computeDispatch:Bt,computeWorkGroupSizeForConv2d:Nt,computeWorkGroupSizeForMatMul:_t,computeWorkPerThreadForConv2d:Ot,flatDispatchLayout:Ft,GPUBytesPerElement:Gt,ArrayBufferToTypedArray:Ut,isWebGPUSupported:Lt,get MatMulProgramType(){return Mt}};function Wt(e,t,n,s,i=!1,a=!1,o=!1,u=1){r.assert(n&&1===u||!n,(()=>`transposeA ${n} is not compatible with component size ${u}`));const l=`\n      let batch = ${e?"0":"batchIn"};\n      let batchASize = uniforms.aShape[1] * uniforms.aShape[2];\n      ${n?`value = A[(batch * batchASize + col * uniforms.aShape[2] + row) / ${u}];`:`value = A[(batch * batchASize + row * uniforms.aShape[2] + col) / ${u}];`}\n\n    `;let h;return h=!1===s?`value = B[(batch * batchBSize + row * uniforms.bShape[2] + col) / ${u}];`:`value = B[(batch * batchBSize + col * uniforms.bShape[2] + row) / ${u}];`,`\n  fn mm_readA(batchIn: i32, row: i32, colIn: i32) -> ${bt(u)} {\n    var value = ${bt(u)}(0.0);\n    let col = colIn * ${u};\n    ${i&&o?l:`\n    ${n?"if(row < uniforms.dimAOuter && col < uniforms.dimInner)":"if(row < uniforms.aShape[1] && col < uniforms.aShape[2])"}\n    {\n      ${l}\n    }\n    `}\n    return value;\n  }\n\n  fn mm_readB(batchIn: i32, row: i32, colIn: i32) -> ${bt(u)} {\n    let col = colIn * ${u};\n    let batch = ${t?"0":"batchIn"};\n    let batchBSize = uniforms.bShape[1] * uniforms.bShape[2];\n    var value = ${bt(u)}(0.0);\n    ${h}\n    return value;\n  }\n  `}function Vt(e,t,n,r,s,i,a=!1,o=!1,u=!1,l=1){return`\n  ${Wt(n,r,s,i,a,o,u,l)}\n  fn mm_write(batch: i32, row: i32, colIn: i32, valueIn: ${bt(l)}) {\n    let col = colIn * ${l};\n    ${a&&o?"":"if (row < uniforms.dimAOuter && col < uniforms.dimBOuter)"}\n    {\n      var value = valueIn;\n      let coords = vec3<i32>(batch, row, col);\n      ${wt(e,t)}\n      setOutputAtCoords(coords[0], coords[1], coords[2], value);\n    }\n  }\n  `}function Ht(e,t,n=!1,s=32){const i=e[1]*t[1],a=e[0]*t[0],o=n?i:s,u=n?s:i;r.assert(u%t[1]==0&&o%t[0]==0&&s%t[1]==0,(()=>`tileAHight ${u} must be divisible by workGroupSize[1]${t[1]}, tileAWidth ${o} must be divisible by workGroupSize[0]${t[0]}, tileInner ${s} must be divisible by workGroupSize[1]${t[1]}`));const l=u/t[1],h=o/t[0],d=s/t[1];return`\n    var<workgroup> mm_Asub : array<array<f32, ${o}>, ${u}>;\n    var<workgroup> mm_Bsub : array<array<f32, ${a}>, ${s}>;\n    const RowPerThread = ${e[1]};\n    const ColPerThread = ${e[0]};\n    const TileInner = ${s};\n\n    @compute @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n    fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n            @builtin(global_invocation_id) GlobalId : vec3<u32>,\n            @builtin(num_workgroups) NumWorkgroups: vec3<u32>,\n            @builtin(workgroup_id) workgroupId: vec3<u32>) {\n      localId = LocalId;\n      globalId = GlobalId;\n      numWorkgroups = NumWorkgroups;\n\n      let tileRow = i32(localId.y) * RowPerThread;\n      let tileCol = i32(localId.x) * ColPerThread;\n\n      let globalRow = i32(globalId.y) * RowPerThread;\n      let globalCol = i32(globalId.x) * ColPerThread;\n      let batch = i32(globalId.z);\n      let globalRowStart = i32(workgroupId.y) * ${i};\n\n      let numTiles = (uniforms.dimInner - 1) / TileInner + 1;\n\n      var acc : array<array<f32, ColPerThread>, RowPerThread>;\n\n      // Without this initialization strange values show up in acc.\n      for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n        for (var innerCol = 0; innerCol < ColPerThread; innerCol = innerCol + 1) {\n          acc[innerRow][innerCol] = 0.0;\n        }\n      }\n\n      let tileRowA = i32(localId.y) * ${l};\n      let tileColA = i32(localId.x) * ${h};\n      let tileRowB = i32(localId.y) * ${d};\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < ${l}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ${h}; innerCol = innerCol + 1) {\n            let inputRow = tileRowA + innerRow;\n            let inputCol = tileColA + innerCol;\n            ${(e=>e?"\n        mm_Asub[inputRow][inputCol] = mm_readA(batch,\n          t * TileInner + inputRow,\n          globalRowStart + inputCol);\n        ":"\n        mm_Asub[inputRow][inputCol] = mm_readA(batch,\n          globalRowStart + inputRow,\n          t * TileInner + inputCol);\n        ")(n)}\n          }\n        }\n\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < ${d}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ColPerThread; innerCol = innerCol + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol + innerCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(batch,\n              t * TileInner + inputRow,\n              globalCol + innerCol);\n          }\n        }\n\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        var BCached : array<f32, ColPerThread>;\n        for (var k = 0; k < TileInner; k = k + 1) {\n          for (var inner = 0; inner < ColPerThread; inner = inner + 1) {\n            BCached[inner] = mm_Bsub[k][tileCol + inner];\n          }\n\n          for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n            ${(e=>e?"let ACached = mm_Asub[k][tileRow + innerRow];":"let ACached = mm_Asub[tileRow + innerRow][k];")(n)}\n            for (var innerCol = 0; innerCol < ColPerThread; innerCol = innerCol + 1) {\n              acc[innerRow][innerCol] = acc[innerRow][innerCol] + ACached * BCached[innerCol];\n            }\n          }\n        }\n\n        workgroupBarrier();\n      }\n\n      for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n        for (var innerCol = 0; innerCol < ColPerThread; innerCol = innerCol + 1) {\n          mm_write(batch, globalRow + innerRow, globalCol + innerCol,\n              acc[innerRow][innerCol]);\n        }\n      }\n    }\n  `}class Xt{constructor(e,t,n,s,i,a=!1,o=!1,u=null,l=null,h=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[16,16,1],this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]};const d=a?e[1]:e[2];this.workGroupSize=_t(t[1],0,t[2]),1!==t[1]&&1!==t[2]||(n=1),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[n,n,1]),r.arraysEqual(this.dispatch,[1,1,1])&&(n=1,this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[n,n,1]));const c=null!=u,p=null!=h;c&&this.variableNames.push("bias"),p&&this.variableNames.push("preluActivationWeights"),this.workPerThread=n,this.transposeA=a,this.transposeB=o,this.addBias=c,this.activation=l,this.hasPreluActivationWeights=p,this.batchAEqualOne=s,this.batchBEqualOne=i,[this.fitAOuter,this.fitBOuter,this.fitInner]=this.getShapeFit(t[1],t[2],d),this.shaderKey=`matMulPacked_${this.workPerThread}_${a}_${o}_${this.activation}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.outputShape[1]>1}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getShapeFit(e,t,n){const r=this.workGroupSize[1]*this.workPerThread,s=this.workGroupSize[0]*this.workPerThread;this.tileInner=32,1===this.outputShape[1]&&(this.tileInner=4*this.workGroupSize[0]);return[e%r==0,t%s==0,n%this.tileInner==0]}getUserCode(){const e=`\n      ${xt(this.activation,this.hasPreluActivationWeights)}\n      ${Vt(this.addBias,this.activation,this.batchAEqualOne,this.batchBEqualOne,!1,this.transposeB,this.fitAOuter,this.fitBOuter,this.fitInner)}\n      ${this.outputShape[1]>1?Ht([this.workPerThread,this.workPerThread,1],this.workGroupSize,this.transposeA,this.tileInner):function(e,t=!1){return r.assert(1===e[1]&&1===e[2],(()=>`A linear work group size is required. But got ${e}.`)),`\n    const TileSize = ${4*e[0]};\n    var<workgroup> mm_Asub : array<vec4<f32>, ${e[0]}>;\n\n    ${Ct()}\n      let tileCol = i32(localId.x);\n      let globalCol = i32(globalId.x);\n      let globalRow = i32(globalId.y);\n\n      let numTiles = (uniforms.dimInner - 1) / TileSize + 1;\n      let batch = i32(globalId.z);\n      // Without this initialization strange values show up in acc.\n      var acc = 0.0;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        let colA = t * TileSize + tileCol * 4;\n        mm_Asub[tileCol] = vec4<f32>(${(e=>e?"\n      mm_readA(batch, colA, globalRow),\n      mm_readA(batch, colA + 1, globalRow),\n      mm_readA(batch, colA + 2, globalRow),\n      mm_readA(batch, colA + 3, globalRow)\n  ":"\n      mm_readA(batch, globalRow, colA),\n      mm_readA(batch, globalRow, colA + 1),\n      mm_readA(batch, globalRow, colA + 2),\n      mm_readA(batch, globalRow, colA + 3)\n  ")(t)});\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < TileSize / 4; k = k + 1) {\n          let rowB = t * TileSize + k * 4;\n          let BCached = vec4<f32>(mm_readB(batch, rowB, globalCol),\n                              mm_readB(batch, rowB + 1, globalCol),\n                              mm_readB(batch, rowB + 2, globalCol),\n                              mm_readB(batch, rowB + 3, globalCol));\n\n          let ACached = mm_Asub[k];\n          acc = acc + dot(ACached, BCached);\n        }\n\n        workgroupBarrier();\n      }\n\n      mm_write(batch, globalRow, globalCol, acc);\n    }\n  `}(this.workGroupSize,this.transposeA)}\n    `;return e}}function qt(e,t,n,s,i=4,a=!1){const o=a?t:s,u=a?s:t,l=a?e[1]:i;return r.assert((a&&t===n||s%4==0||s%3==0)&&4===e[0]&&(3===i||4===i),(()=>`tileInner ${s} must be divisible by 4|3. ColPerThread ${e[0]} must be 4.\n           innerElementSize ${i} must be 3|4.`)),`\n  var<workgroup> mm_Asub : array<array<vec${l}<f32>, ${o/l}>, ${u}>;\n  var<workgroup> mm_Bsub : array<array<vec4<f32>, ${n/e[0]}>, ${s}>;\n\n  const RowPerThread = ${e[1]};\n  const ColPerThread = ${e[0]};\n  const InnerElementSize = ${i};\n  const TileInner = ${s};\n\n  @compute @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n  fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n          @builtin(global_invocation_id) GlobalId : vec3<u32>,\n          @builtin(num_workgroups) NumWorkgroups: vec3<u32>,\n          @builtin(workgroup_id) workgroupId: vec3<u32>) {\n    localId = LocalId;\n    globalId = GlobalId;\n    numWorkgroups = NumWorkgroups;\n\n    let localRow = i32(localId.y);\n    let tileRow = ${1===t?"0":"localRow * RowPerThread"};\n    let tileCol = i32(localId.x);\n\n    let globalRow = ${1===t?"0":"i32(globalId.y) * RowPerThread"};\n    let globalCol = i32(globalId.x);\n    let batch = i32(globalId.z);\n    let globalRowStart = i32(workgroupId.y) * ${t};\n\n    let numTiles = (uniforms.dimInner - 1) / TileInner + 1;\n\n    var acc: array<vec4<f32>, RowPerThread>;\n    var BCached : array<vec4<f32>, 4>;\n\n    // Loop over shared dimension.\n    let RowPerThreadB = TileInner / i32(workGroupSizeY);\n    let tileRowB = localRow * RowPerThreadB;\n    for (var t = 0; t < numTiles; t = t + 1) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileCol;\n            ${((e,t)=>e?`\n        mm_Asub[inputRow][inputCol] = mm_readA(batch,\n          t * TileInner + inputRow,\n          globalRowStart / ${t} + inputCol);\n        `:`\n        mm_Asub[inputRow][inputCol] = mm_readA(batch,\n          globalRow + innerRow,\n          t * TileInner / ${t} + inputCol);\n        `)(a,l)}\n        }\n\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < RowPerThreadB; innerRow = innerRow + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(batch, t * TileInner + inputRow, globalCol);\n        }\n\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < TileInner / InnerElementSize; k = k + 1) {\n            BCached[0] = mm_Bsub[k * InnerElementSize][tileCol];\n            BCached[1] = mm_Bsub[k * InnerElementSize + 1][tileCol];\n            BCached[2] = mm_Bsub[k * InnerElementSize + 2][tileCol];\n            ${3===i?"":"BCached[3] = mm_Bsub[k * InnerElementSize + 3][tileCol];"}\n\n            ${((e,t)=>e?`\n        let ACached0 = mm_Asub[k * InnerElementSize][localRow];\n        let ACached1 = mm_Asub[k * InnerElementSize + 1][localRow];\n        let ACached2 = mm_Asub[k * InnerElementSize + 2][localRow];\n        ${3===t?"":"let ACached3 = mm_Asub[k * InnerElementSize + 3][localRow];"}\n        for (var i = 0; i < RowPerThread; i = i + 1) {\n          acc[i] = BCached[0] * ACached0[i] + acc[i];\n          acc[i] = BCached[1] * ACached1[i] + acc[i];\n          acc[i] = BCached[2] * ACached2[i] + acc[i];\n          ${3===t?"":"acc[i] = BCached[3] * ACached3[i] + acc[i];"}\n        }`:`\n        for (var i = 0; i < RowPerThread; i = i + 1) {\n          let ACached = mm_Asub[tileRow + i][k];\n          acc[i] = BCached[0] * ACached.x + acc[i];\n          acc[i] = BCached[1] * ACached.y + acc[i];\n          acc[i] = BCached[2] * ACached.z + acc[i];\n          ${3===t?"":"acc[i] = BCached[3] * ACached.w + acc[i];"}\n        }`)(a,i)}\n        }\n\n        workgroupBarrier();\n    }\n\n    for (var innerRow = 0; innerRow < RowPerThread; innerRow = innerRow + 1) {\n        mm_write(batch, globalRow + innerRow, globalCol, acc[innerRow]);\n    }\n  }`}class Kt{constructor(e,t,n,r,s=!1,i=null,a=null,o=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,8,1],this.isVec4=!0,this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]},1!==t[1]||s?this.elementsPerThread=[4,4,1]:this.elementsPerThread=[4,1,1],this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread);const u=null!=i,l=null!=o;u&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.tileAOuter=1!==t[1]||s?this.workGroupSize[1]*this.elementsPerThread[1]:1,this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=this.tileBOuter,this.aShape=e,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=n,this.batchBEqualOne=r,this.transposeA=s;const h=s?e[1]:e[2];this.fitAOuter=t[1]%this.tileAOuter==0,this.fitBOuter=t[2]%this.tileBOuter==0,this.fitInner=h%this.tileInner==0,this.shaderKey=`matMulPackedVec4_${this.activation}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.elementsPerThread}_${this.batchAEqualOne}_${this.batchBEqualOne}_${this.transposeA}`}getUserCode(){return`\n      ${xt(this.activation,this.hasPreluActivationWeights,!0)}\n      ${Vt(this.addBias,this.activation,this.batchAEqualOne,this.batchBEqualOne,!1,!1,this.fitAOuter,this.fitBOuter,this.fitInner,4)}\n      ${qt(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner,4,this.transposeA)}\n    `}}class Yt{constructor(e,t,n,r=!1,s=!1,i=null,a=null,o=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout={x:[],y:[1,2],z:[0]},this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize);const u=null!=i,l=null!=o;u&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.transposeA=r,this.transposeB=s,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=t,this.batchBEqualOne=n,this.shaderKey=`matMulReduce_${this.activation}_${r}_${s}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getUserCode(){return`\n      ${xt(this.activation,this.hasPreluActivationWeights)}\n      ${Vt(this.addBias,this.activation,this.batchAEqualOne,this.batchBEqualOne,this.transposeA,this.transposeB)}\n      \n    var<workgroup> sumValues : array<f32, workGroupSizeX>;\n    ${Ct()}\n      let coords = getOutputCoords();\n      let batch = coords[0];\n      let row = coords[1];\n      let col = coords[2];\n      var sum = 0.0;\n      let Length = uniforms.dimInner;\n      for (var k = i32(localId.x); k < Length; k = k + i32(workGroupSizeX)) {\n        let dataA = mm_readA(batch, row, k);\n        let dataB = mm_readB(batch, k, col);\n        sum = sum + dataA * dataB;\n      }\n      sumValues[localId.x] = sum;\n      workgroupBarrier();\n\n      for(var currentSize = workGroupSizeX / 2u; currentSize > 1u;\n          currentSize = currentSize / 2u) {\n        if (localId.x < currentSize)\n        {\n          sumValues[localId.x] = sumValues[localId.x] + sumValues[localId.x + currentSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (localId.x == 0u) {\n        sum = sumValues[0] + sumValues[1];\n        mm_write(batch, row, col, sum);\n      }\n    }\n  \n    `}}class jt{constructor(e,t,n,r=!1,s=!1,i=null,a=null,o=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[16,8,1],this.outputShape=n,this.dispatchLayout={x:[2],y:[1],z:[0]},this.dispatch=[Math.ceil(n[2]/this.workGroupSize[0]),Math.ceil(n[1]/this.workGroupSize[1]),n[0]];const u=null!=i;u&&this.variableNames.push("bias");const l=null!=o;l&&this.variableNames.push("preluActivationWeights"),this.transposeA=r,this.transposeB=s,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=l,this.batchAEqualOne=1===e[0],this.batchBEqualOne=1===t[0],this.shaderKey=`matMulSmallOutputSize_${this.activation}_${r}_${s}_${this.batchAEqualOne}_${this.batchBEqualOne}`}getUserCode(){return`\n      ${xt(this.activation,this.hasPreluActivationWeights)}\n      ${Vt(this.addBias,this.activation,this.batchAEqualOne,this.batchBEqualOne,this.transposeA,this.transposeB)}\n      ${function(e){const t=e[1],n=e[0],r=t>n?t:n;return`\n  var<workgroup> mm_Asub : array<array<f32, ${r}>, ${t}>;\n  var<workgroup> mm_Bsub : array<array<f32, ${n}>, ${r}>;\n\n  // If the output size is small for matrix multiplication, avoid to use vec4\n  // and handle some elements per thread to optimally utilize the ALU.\n  // Read data from global memory to registers firstly, then store them into\n  // shared memory, so it is instruction-Level parallelism for arithmetic\n  // operations and others handle IO operations between barrier api, makes ALU\n  // and load/store units work simultaneously, could improves the performance.\n  ${Ct()}\n    let tileRow = i32(localId.y);\n    let tileCol = i32(localId.x);\n    let globalRow = i32(globalId.y);\n    let globalCol = i32(globalId.x);\n    let batch = i32(globalId.z);\n\n    // uniforms.dimInner should be greater than 0.\n    let numTiles = (uniforms.dimInner - 1) / ${r} + 1;\n    var acc = 0.0;\n\n    var globalColA = tileCol;\n    var globalRowB = 0;\n    var regA = mm_readA(batch, globalRow, globalColA);\n    var regB0 = mm_readB(batch, globalRowB + 2 * tileRow, globalCol);\n    var regB1 = mm_readB(batch, globalRowB + 2 * tileRow + 1, globalCol);\n    globalColA = globalColA + ${r};\n    globalRowB = globalRowB + ${r};\n\n    for (var t = 0; t < numTiles; t = t + 1) {\n      mm_Asub[tileRow][tileCol] = regA;\n      mm_Bsub[2 * tileRow][tileCol] = regB0;\n      mm_Bsub[2 * tileRow + 1][tileCol] = regB1;\n\n      workgroupBarrier();\n\n      regA = mm_readA(batch, globalRow, globalColA);\n      regB0 = mm_readB(batch, globalRowB + 2 * tileRow, globalCol);\n      regB1 = mm_readB(batch, globalRowB + 2 * tileRow + 1, globalCol);\n      globalColA = globalColA + ${r};\n      globalRowB = globalRowB + ${r};\n\n      for (var k = 0; k < ${r}; k = k + 1) {\n        acc = acc + mm_Asub[tileRow][k] * mm_Bsub[k][tileCol];\n      }\n      workgroupBarrier();\n    }\n\n    mm_write(batch, globalRow, globalCol, acc);\n  }\n  `}(this.workGroupSize)}\n    `}}class Qt{constructor(e,t,n,s,i=!1,a=!1){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workGroupSize=[8,8,1],this.atomic=!0,this.tileInner=32,r.assert(1===e[0],(()=>"MatMulSplitKProgram only supports batch = 1.")),this.outputShape=e,this.dispatchLayout={x:[2],y:[1],z:[0,3]},this.elementsPerThread=[4,4,this.tileInner],this.outputShape[1]<16&&(this.elementsPerThread[1]=1),this.outputShape[2]<16&&(this.elementsPerThread[0]=1),this.dispatch=Bt(this.dispatchLayout,[this.outputShape[0],this.outputShape[1],this.outputShape[2],t],this.workGroupSize,this.elementsPerThread),this.transposeA=i,this.transposeB=a,this.batchAEqualOne=n,this.batchBEqualOne=s,this.shaderKey=`matMulSplitK_${i}_${a}_${n}_${s}_${this.elementsPerThread}`}getUserCode(){return`\n      ${Wt(this.batchAEqualOne,this.batchBEqualOne,this.transposeA,this.transposeB)}\n      fn mm_write(batch: i32, row : i32, col : i32, valueIn : f32) {\n        if (row < uniforms.dimAOuter && col < uniforms.dimBOuter) {\n          let coords = vec3<i32>(batch, row, col);\n          let flatIndex = getOutputIndexFromCoords(coords);\n          var value = valueIn;\n          // The problem is that we should initialize output to zero before using.\n          // Otherwise, the original value will be added to the result.\n          \n     var oldValue = atomicLoad(&(result[flatIndex]));\n     var exchanged = false;\n     for (; !exchanged;) {\n       let newValueF32 = bitcast<f32>(oldValue) + value;\n       let newValue = bitcast<i32>(newValueF32);\n       let res = atomicCompareExchangeWeak(&(result[flatIndex]), oldValue, newValue);\n       oldValue = res.old_value;\n       exchanged = res.exchanged;\n     }\n     \n        }\n      }\n\n      ${this.makeMatMulSplitKSource()}\n    `}makeMatMulSplitKSource(){const e=this.workGroupSize[1]*this.elementsPerThread[1],t=this.workGroupSize[0]*this.elementsPerThread[0],n=this.elementsPerThread[1],s=this.elementsPerThread[0],i=this.tileInner/this.workGroupSize[0],a=this.tileInner/this.workGroupSize[1];return r.assert(this.tileInner%this.workGroupSize[0]==0&&this.tileInner%this.workGroupSize[1]==0,(()=>`tileInner ${this.tileInner} must be divisible by workGroupSize[0]${this.workGroupSize[0]} and workGroupSize[1]${this.workGroupSize[1]}`)),`\n      var<workgroup> mm_Asub : array<array<f32, ${this.tileInner}>, ${e}>;\n      var<workgroup> mm_Bsub : array<array<f32, ${t}>, ${this.tileInner}>;\n      ${Ct()}\n        let tileRow = i32(localId.y) * ${n};\n        let tileCol = i32(localId.x) * ${s};\n\n        let globalRow = i32(globalId.y) * ${n};\n        let globalCol = i32(globalId.x) * ${s};\n        let batch = 0;\n        let kStart = i32(globalId.z) * ${this.tileInner};\n\n        // Load one tile of A into local memory.\n        let tileColA = i32(localId.x) * ${i};\n        for (var innerRow = 0; innerRow < ${n}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ${i}; innerCol = innerCol + 1) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileColA + innerCol;\n            mm_Asub[inputRow][inputCol] = mm_readA(${this.batchAEqualOne?0:"batch"},\n                globalRow + innerRow,\n                kStart + inputCol);\n          }\n        }\n        // Load one tile of B into local memory.\n        let tileRowB = i32(localId.y) * ${a};\n        for (var innerRow = 0; innerRow < ${a}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ${s}; innerCol = innerCol + 1) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol + innerCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(${this.batchBEqualOne?0:"batch"},\n                kStart + inputRow,\n                globalCol + innerCol);\n          }\n        }\n\n        workgroupBarrier();\n\n        var acc : array<array<f32, ${s}>, ${n}>;\n        // Loop over shared dimension. Compute acc values for a single thread.\n        for (var k = 0; k < ${this.tileInner}; k = k + 1) {\n          var BCached : array<f32, ${s}>;\n          for (var inner = 0; inner < ${s}; inner = inner + 1) {\n            BCached[inner] = mm_Bsub[k][tileCol + inner];\n          }\n\n          for (var innerRow = 0; innerRow < ${n}; innerRow = innerRow + 1) {\n            let ACached = mm_Asub[tileRow + innerRow][k];\n            for (var innerCol = 0; innerCol < ${s}; innerCol = innerCol + 1) {\n              acc[innerRow][innerCol] = acc[innerRow][innerCol] + ACached * BCached[innerCol];\n            }\n          }\n        }\n\n        for (var innerRow = 0; innerRow < ${n}; innerRow = innerRow + 1) {\n          for (var innerCol = 0; innerCol < ${s}; innerCol = innerCol + 1) {\n            mm_write(batch, globalRow + innerRow, globalCol + innerCol, acc[innerRow][innerCol]);\n          }\n        }\n      }\n    `}}class Zt{constructor(e,t=null,n=null,r=null){this.uniforms="",this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.addBias=null!=t,this.hasPreluActivationWeights=null!=r,this.activation=n,this.addBias&&this.variableNames.push("bias"),this.hasPreluActivationWeights&&this.variableNames.push("preluActivationWeights"),this.shaderKey=`biasActivation_${n}`}getUserCode(){return`\n    ${xt(this.activation,this.hasPreluActivationWeights)}\n    ${vt()}\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        var value = getXByOutputIndex(index);\n        ${wt(this.addBias,this.activation)}\n        setOutputAtIndex(index, value);\n      }\n    }\n    `}}class Jt{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="value : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="fill"}getUserCode(){return`\n    ${vt()}\n      if (index < uniforms.size) {\n        setOutputAtIndex(index, uniforms.value);\n      }\n    }\n  `}}function en(e){const{backend:t,attrs:n}=e,{shape:s,value:i}=n;let{dtype:a}=n;if(a=a||r.inferDtype(i),"string"===a){const e=r.getArrayFromDType(a,r.sizeFromShape(s));return e.fill(i),t.makeTensorInfo(s,a,e)}{const e=new Jt(s),n=[{type:"float32",data:[i]}];return t.runWebGPUProgram(e,[],a,n)}}const tn={kernelName:s,backendName:"webgpu",kernelFunc:en};function nn(e){const{inputs:t,attrs:n}=e,{x:s}=t,{shape:i}=n,a=r.sizeFromShape(s.shape),o=r.inferFromImplicitShape(i,a),u=r.sizeFromShape(o);return r.assert(a===u,(()=>`The new shape (${o}) has ${u} elements and the old shape (${s.shape}) has ${a} elements. The new shape and old shape must have the same number of elements.`)),e.backend.incRef(s.dataId),{dataId:s.dataId,shape:o,dtype:s.dtype}}const rn={kernelName:i,backendName:"webgpu",kernelFunc:nn};function sn({a:e,b:n,transposeA:s,transposeB:i,backend:o,bias:u=null,preluActivationWeights:l=null,leakyreluAlpha:h=0,activation:d=null}){const c=e.shape.length,p=n.shape.length,f=s?e.shape[c-2]:e.shape[c-1],m=i?n.shape[p-1]:n.shape[p-2],g=s?e.shape[c-1]:e.shape[c-2],b=i?n.shape[p-2]:n.shape[p-1],x=e.shape.slice(0,-2),w=n.shape.slice(0,-2),I=r.sizeFromShape(x),y=r.sizeFromShape(w),k=a.assertAndGetBroadcastShape(e.shape.slice(0,-2),n.shape.slice(0,-2)).concat([g,b]);r.assert(f===m,(()=>`Error in matMul: inner shapes (${f}) and (${m}) of Tensors with shapes ${e.shape} and ${n.shape} and transposeA=${s} and transposeB=${i} must match.`));const S=s?[I,f,g]:[I,g,f],v=i?[y,b,m]:[y,m,b],C=nn({inputs:{x:e},backend:o,attrs:{shape:S}}),$=nn({inputs:{x:n},backend:o,attrs:{shape:v}}),R=[C,$],A=Math.max(I,y),z=1===I,P=1===y,T=(f%4==0&&!s||g%4==0&&s)&&b%4==0&&!i,E=[C,$],B=[{type:"int32",data:[g]},{type:"int32",data:[b]},{type:"int32",data:[f]}];let N,_;const O=[A,g,b];let F=t().get("WEBGPU_MATMUL_PROGRAM_TYPE");switch(F<0&&(F=g*b<=128?Mt.MatMulReduceProgram:1===A&&g<=128&&b<=48&&m>=2e3?Mt.MatMulSplitKProgram:g<=16&&(b<=512||m>=2*b)||b<=16&&(g<=512||f>=2*g)?Mt.MatMulSmallOutputSizeProgram:T?Mt.MatMulPackedVec4Program:Mt.MatMulPackedProgram),F){case Mt.MatMulPackedVec4Program:N=new Kt(S,O,z,P,s,u,d,l);break;case Mt.MatMulReduceProgram:N=new Yt(O,z,P,s,i,u,d,l);break;case Mt.MatMulSplitKProgram:if(_=en({backend:o,attrs:{shape:O,value:0,dtype:e.dtype}}),N=new Qt(O,m,z,P,s,i),u||d){_=o.runWebGPUProgram(N,E,e.dtype,B,_);const t=new Zt(_.shape,u,d,l);let n=null;const r=[_];u&&r.push(u),l&&r.push(l),"leakyrelu"===d&&(n=[{type:"float32",data:[h]}],t.uniforms+=" alpha : f32,");const s=o.runWebGPUProgram(t,r,_.dtype,n);R.push(_);const i=nn({inputs:{x:s},backend:o,attrs:{shape:k}});R.push(s);for(const e of R)o.disposeData(e.dataId);return i}break;case Mt.MatMulSmallOutputSizeProgram:N=new jt(S,v,O,s,i,u,d,l);break;case Mt.MatMulPackedProgram:N=new Xt(S,O,t().get("WEBGPU_MATMUL_WORK_PER_THREAD"),z,P,s,i,u,d,l);break;default:throw new Error(`Unsupported MatMulProgramType ${F}.`)}u&&E.push(u),l&&E.push(l),"leakyrelu"===d&&(B.push({type:"float32",data:[h]}),N.uniforms+=" alpha : f32,"),_=o.runWebGPUProgram(N,E,e.dtype,B,_);const G=nn({inputs:{x:_},backend:o,attrs:{shape:k}});R.push(_);for(const e of R)o.disposeData(e.dataId);return G}const an={kernelName:o,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{a:s,b:i,bias:a,preluActivationWeights:o}=t,{transposeA:u,transposeB:l,activation:h,leakyreluAlpha:d}=r;return sn({a:s,b:i,transposeA:u,transposeB:l,backend:n,bias:a,preluActivationWeights:o,leakyreluAlpha:d,activation:h})}};class on{constructor(e,t,r){this.variableNames=["AReal","AImag","BReal","BImag"],this.workGroupSize=[128,1,1],this.size=!0,this.outputShape=n.assertAndGetBroadcastShape(t,r),this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`binaryOpComplex_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOpComplex(\n          areal : f32, aimag : f32, breal : f32, bimag : f32) -> f32 {\n        ${ft(this.op,!1)}\n      }\n\n      ${vt()}\n        if(index < uniforms.size) {\n          let areal = getARealByOutputIndex(index);\n          let aimag = getAImagByOutputIndex(index);\n          let breal = getBRealByOutputIndex(index);\n          let bimag = getBImagByOutputIndex(index);\n          setOutputAtIndex(index, binaryOpComplex(areal, aimag, breal, bimag));\n        }\n      }\n    `}}class un{constructor(e,t,s){this.size=!0,this.variableNames=["A","B"],this.outputShape=n.assertAndGetBroadcastShape(t,s),this.dispatchLayout=Ft(this.outputShape),this.op=e,this.useSharedMemoryWithA=1===t.length&&s.length>1&&t[0]<1024,this.useSharedMemoryWithB=1===s.length&&t.length>1&&s[0]<1024,this.useSharedMemoryWithA||this.useSharedMemoryWithB?(this.isVec4=!1,this.lastDimensionSize=this.useSharedMemoryWithB?s[0]:t[0],this.shaderKey=`binary_${this.type}_${e}_${this.lastDimensionSize}_${this.useSharedMemoryWithB}`,this.type="shared",this.workGroupSize=[256,1,1],this.lastDimensionSize<256?this.workPerThread=1:this.lastDimensionSize<512?this.workPerThread=2:this.workPerThread=4):(r.arraysEqual(t,s)&&r.sizeFromShape(t)%4==0?(this.isVec4=!0,this.type="vec4",this.workPerThread=4):(this.isVec4=!1,this.type="plain",this.workPerThread=1),this.shaderKey=`binary_${this.type}_${e}`,this.workGroupSize=[128,1,1]),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1])}getUserCode(){let e;if("shared"===this.type){const t=this.lastDimensionSize>1?`coords[${this.outputShape.length-1}]`:"0",n=this.useSharedMemoryWithB?`let a = getAByOutputCoords(coords);\n          let b = sharedBuf[${t}];`:`let a = sharedBuf[${t}];\n          let b = getBByOutputCoords(coords);`;e=`\n        fn binaryOperation(a : f32, b : f32) -> f32 {\n          ${ft(this.op,this.isVec4)}\n        }\n        var<workgroup> sharedBuf : array<f32, ${this.lastDimensionSize}>;\n        ${vt()}\n\n          // Fill in the shared memory buffer. Here we need a loop to make sure\n          // that all data in A|B are uploaded when |sharedMemorySize| is larger\n          // than work group size.\n          for(var localIndex = i32(localId.x); localIndex < ${this.lastDimensionSize}; localIndex = localIndex + ${this.workGroupSize[0]}) {\n            sharedBuf[localIndex] = f32(${this.useSharedMemoryWithB?"B":"A"}[localIndex]);\n          }\n          workgroupBarrier();\n\n          for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n            let flatIndex = index * ${this.workPerThread} + i;\n            if(flatIndex < uniforms.size) {\n              let coords = getCoordsFromIndex(flatIndex);\n\n              ${n}\n              setOutputAtIndex(flatIndex, binaryOperation(a, b));\n            }\n          }\n        }\n        `}else{const t="vec4"===this.type?"vec4<f32>":"f32";e=`\n       fn binaryOperation(a : ${t}, b : ${t}) -> ${t} {\n         ${ft(this.op,this.isVec4)}\n       }\n       ${vt()}\n         if (index < uniforms.size) {\n           let a = getAByOutputIndex(index);\n           let b = getBByOutputIndex(index);\n           setOutputAtIndex(index, binaryOperation(a, b));\n         }\n       }\n       `}return e}}function ln(e){const{inputs:t}=e,{x:n}=t;return e.backend.incRef(n.dataId),{dataId:n.dataId,shape:n.shape,dtype:n.dtype}}const hn={kernelName:u,backendName:"webgpu",kernelFunc:ln};function dn(e){const{inputs:t,backend:n}=e,{real:r,imag:s}=t,i=n.makeTensorInfo(r.shape,"complex64"),a=n.tensorMap.get(i.dataId),o=ln({inputs:{x:r},backend:n}),u=ln({inputs:{x:s},backend:n});return a.complexTensorInfos={real:o,imag:u},i}const cn={kernelName:l,backendName:"webgpu",kernelFunc:dn};class pn{constructor(e,t){this.variableNames=["A"],this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.op=t,this.shaderKey=`unary_${t}`}getUserCode(){return`\n      fn unaryOperation(a : f32) -> f32 {\n        ${gt(this.op,!1)}\n      }\n      ${vt()}\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          setOutputAtIndex(index, unaryOperation(a));\n        }\n      }\n      `}}function fn({opType:e,cpuKernelImpl:t,dtype:n}){return({inputs:r,backend:s})=>{const{x:i}=r,a=s,o=n||i.dtype;if(a.shouldExecuteOnCPU([i])&&null!=t){const e=a.tensorMap.get(i.dataId),n=t(e.values,o);return a.makeTensorInfo(i.shape,o,n)}const u=new pn(i.shape,e);return a.runWebGPUProgram(u,[i],o)}}function mn({opType:e,cpuKernelImpl:t,supportsComplex:r=!1,dtype:s}){return({inputs:i,backend:a})=>{const{a:o,b:u}=i,l=a;if(r&&"complex64"===o.dtype){const t=l.tensorMap.get(o.dataId),n=l.tensorMap.get(u.dataId);let r,s;if(e!==ht.MUL)[r,s]=[[t.complexTensorInfos.real,n.complexTensorInfos.real],[t.complexTensorInfos.imag,n.complexTensorInfos.imag]].map((t=>{const[n,r]=t,s={dataId:n.dataId,dtype:n.dtype,shape:o.shape},i={dataId:r.dataId,dtype:r.dtype,shape:u.shape},a=new un(e,o.shape,u.shape);return l.runWebGPUProgram(a,[s,i],h(n.dtype,r.dtype))}));else{const e=new on(ht.COMPLEX_MULTIPLY_REAL,o.shape,u.shape),i=new on(ht.COMPLEX_MULTIPLY_IMAG,o.shape,u.shape),a=[{dataId:t.complexTensorInfos.real.dataId,dtype:t.complexTensorInfos.real.dtype,shape:o.shape},{dataId:t.complexTensorInfos.imag.dataId,dtype:t.complexTensorInfos.imag.dtype,shape:o.shape},{dataId:n.complexTensorInfos.real.dataId,dtype:n.complexTensorInfos.real.dtype,shape:u.shape},{dataId:n.complexTensorInfos.imag.dataId,dtype:n.complexTensorInfos.imag.dtype,shape:u.shape}];r=l.runWebGPUProgram(e,a,"float32"),s=l.runWebGPUProgram(i,a,"float32")}const i=dn({inputs:{real:r,imag:s},backend:l});return l.disposeData(r.dataId),l.disposeData(s.dataId),i}const d=s||h(o.dtype,u.dtype);if(("string"===o.dtype||"string"===u.dtype||l.shouldExecuteOnCPU([o,u]))&&null!=t){const e=l.tensorMap.get(o.dataId).values,r=l.tensorMap.get(u.dataId).values,s="string"===o.dtype?n.fromUint8ToStringArray(e):e,i="string"===o.dtype?n.fromUint8ToStringArray(r):r,[a,h]=t(o.shape,u.shape,s,i,d);return l.makeTensorInfo(h,d,a)}const c=new un(e,o.shape,u.shape);return l.runWebGPUProgram(c,[o,u],d)}}function gn(e){return(t,s,i,a,o)=>{const u=n.assertAndGetBroadcastShape(t,s),l=u.length,h=r.computeStrides(u),d=r.sizeFromShape(u),c=r.getTypedArrayFromDType(o,d),p=t.length,f=s.length,m=r.computeStrides(t),g=r.computeStrides(s),b=n.getBroadcastDims(t,u),x=n.getBroadcastDims(s,u);if(b.length+x.length===0)for(let t=0;t<c.length;++t)c[t]=e(i[t%i.length],a[t%a.length]);else for(let t=0;t<c.length;++t){const n=r.indexToLoc(t,l,h),s=n.slice(-p);b.forEach((e=>s[e]=0));const o=r.locToIndex(s,p,m),u=n.slice(-f);x.forEach((e=>u[e]=0));const d=r.locToIndex(u,f,g);c[t]=e(i[o],a[d])}return[c,u]}}const bn=gn(((e,t)=>e+t));function xn(e){return(t,n,s)=>{const i=r.getTypedArrayFromDType(n,t.length);for(let n=0;n<t.length;++n)i[n]=e(t[n],s);return i}}const wn=xn((e=>Math.ceil(e)));const In=gn(((e,t)=>e===t?1:0)),yn=xn((e=>Math.exp(e))),kn=xn((e=>Math.expm1(e))),Sn=xn((e=>Math.floor(e)));const vn=gn(((e,t)=>e>t?1:0)),Cn=gn(((e,t)=>e>=t?1:0)),$n=gn(((e,t)=>e<t?1:0)),Rn=gn(((e,t)=>e<=t?1:0));const An=xn((e=>Math.log(e)));const zn=gn(((e,t)=>Math.max(e,t))),Pn=gn(((e,t)=>Math.min(e,t))),Tn=gn(((e,t)=>e*t));const En=gn(((e,t)=>e!==t?1:0));const Bn=xn((e=>1/Math.sqrt(e)));const Nn=xn((e=>1/(1+Math.exp(-e))));const _n=xn((e=>Math.sqrt(e))),On=gn(((e,t)=>{const n=e-t;return n*n}));class Fn{constructor(e,t,n,s,i,a){this.separator=r.encodeString(e),this.nGramWidths=t,this.leftPad=r.encodeString(n),this.rightPad=r.encodeString(s),this.padWidth=i,this.preserveShort=a}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,r,s,i){for(let a=0;a<s;++a){const o=this.getPadWidth(i),u=Math.max(0,o-a),l=Math.max(0,o-(s-(a+1))),h=i-(u+l),d=t+(u>0?0:a-o);let c=0;c+=u*this.leftPad.length;for(let t=0;t<h;++t)c+=e[d+t].length;c+=l*this.rightPad.length;c+=(u+l+h-1)*this.separator.length,n[r+a]=new Uint8Array(c);const p=n[r+a];let f=0;const m=e=>e.forEach((e=>p[f++]=e));for(let e=0;e<u;++e)m(this.leftPad),m(this.separator);for(let t=0;t<h-1;++t)m(e[d+t]),m(this.separator);if(h>0){m(e[d+h-1]);for(let e=0;e<l;++e)m(this.separator),m(this.rightPad)}else{for(let e=0;e<l-1;++e)m(this.rightPad),m(this.separator);m(this.rightPad)}}}compute(e,t){const n=e.length,s=t.length;if(s>0){let e=t[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let r=1;r<s;++r){let s=t[r]>=e;if(s=s&&t[r]<=n,!s)throw new Error(`Invalid split value ${t[r]}, must be in [${e}, ${n}]`);e=t[r]}if(e!==n)throw new Error(`Last split value must be data size. Expected ${n}, got ${e}`)}const i=s-1,a=r.getArrayFromDType("int32",s);if(0===n||0===s){const e=new Array(n);for(let e=0;e<=i;++e)a[e]=0;return[e,a]}a[0]=0;for(let e=1;e<=i;++e){const n=t[e]-t[e-1];let r=0;this.nGramWidths.forEach((e=>{r+=this.getNumNGrams(n,e)})),this.preserveShort&&n>0&&0===r&&(r=1),a[e]=a[e-1]+r}const o=new Array(a[i]);for(let n=0;n<i;++n){const r=t[n];let s=a[n];if(this.nGramWidths.forEach((i=>{const a=t[n+1]-t[n],u=this.getNumNGrams(a,i);this.createNGrams(e,r,o,s,u,i),s+=u})),this.preserveShort&&s===a[n]){const i=t[n+1]-t[n];if(0===i)continue;const a=i+2*this.padWidth,u=1;this.createNGrams(e,r,o,s,u,a)}}return[o,a]}}function Gn(e,t,n,r){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)r.push(e.subarray(t,t+1));return}if(1===t.length){const s=t[0];let i=e.indexOf(s);for(;-1!==i;){const t=e.subarray(0,i);n&&0===t.length||r.push(t),i=(e=e.subarray(i+1)).indexOf(s)}return void(n&&0===e.length||r.push(e))}let s=0;for(let i=0;i<e.length+1;i++)if(i===e.length||-1!==t.indexOf(e[i])){const t=e.subarray(s,i);n&&0===t.length||r.push(t),s=i+1}}const Un=gn(((e,t)=>e-t));const Ln=(e,t)=>{const n=t.value-e.value;return 0===n?e.index-t.index:n};function Mn(e,t,n=0,s=e.length-1){for(;s>n;){if(s-n>600){const r=s-n+1,i=t-n+1,a=Math.log(r),o=.5*Math.exp(2*a/3),u=.5*Math.sqrt(a*o*(r-o)/r)*Math.sign(i-r/2);Mn(e,t,Math.max(n,Math.floor(t-i*o/r+u)),Math.min(s,Math.floor(t+(r-i)*o/r+u)))}const i=e[t];let a=n,o=s;for(r.swap(e,n,t),Ln(e[s],i)>0&&r.swap(e,n,s);a<o;){for(r.swap(e,a,o),a++,o--;Ln(e[a],i)<0;)a+=1;for(;Ln(e[o],i)>0;)o-=1}0===Ln(e[n],i)?r.swap(e,n,o):(o+=1,r.swap(e,o,s)),o<=t&&(n=o+1),t<=o&&(s=o-1)}}var Dn={__proto__:null,simpleAbsImpl:function(e){const t=new Float32Array(e.length);for(let n=0;n<e.length;++n)t[n]=Math.abs(e[n]);return t},addImpl:bn,bincountImpl:function(e,t,n,s,i){const a=r.sizeFromShape(s),o=r.makeZerosTypedArray(i,n);for(let n=0;n<e.length;n++){const r=e[n];if(r<0)throw new Error("Input x must be non-negative!");r>=i||(o[r]+=a>0?t[n]:1)}return o},bincountReduceImpl:function(e,t,n,r=!1){const s=e.shape[0],i=e.shape[1],a=d([s,n],t.dtype);for(let o=0;o<s;o++)for(let s=0;s<i;s++){const i=e.get(o,s);if(i<0)throw new Error("Input x must be non-negative!");i>=n||(r?a.set(1,o,i):t.size>0?a.set(a.get(o,i)+t.get(o,s),o,i):a.set(a.get(o,i)+1,o,i))}return a},ceilImpl:wn,concatImpl:function(e,t,s,i){const a=r.getArrayFromDType(s,r.sizeFromShape(t));if(i&&"string"!==s){let t=0;e.forEach((e=>{const n=r.sizeFromShape(e.shape);a.set(e.vals,t),t+=n}))}else{let r=0;e.forEach((e=>{const i="string"===s?n.fromUint8ToStringArray(e.vals):e.vals;let o=0;for(let n=0;n<e.shape[0];++n){const s=n*t[1]+r;for(let t=0;t<e.shape[1];++t)a[s+t]=i[o++]}r+=e.shape[1]}))}return a},equalImpl:In,expImpl:yn,expm1Impl:kn,floorImpl:Sn,gatherNdImpl:function(e,t,n,r,s,i,a,o,u){const l=d([r,i],n);for(let n=0;n<r;n++){const r=[];let h=0;for(let t=0;t<s;t++){const i=e[n*s+t];h+=i*a[t],r.push(i)}if(h<0||h>=u/i)throw new Error(`Invalid indices: ${r} does not index into ${o}`);for(let e=0;e<i;e++)l.values[n*i+e]=t.get(...t.indexToLoc(h*i+e))}return l},gatherV2Impl:function(e,t,n){const r=d(n,e.dtype);for(let n=0;n<r.size;++n){const s=r.indexToLoc(n).slice(),i=s[0],a=s[2],o=t.locToIndex([i,a]);s[2]=t.values[o];const u=e.locToIndex(s);0<=u&&u<e.values.length&&(r.values[n]=e.values[u])}return r},greaterImpl:vn,greaterEqualImpl:Cn,lessImpl:$n,lessEqualImpl:Rn,linSpaceImpl:function(e,t,n){const s=(t-e)/(n-1),i=r.makeZerosTypedArray(n,"float32");i[0]=e;for(let e=1;e<i.length;e++)i[e]=i[e-1]+s;return i},logImpl:An,maxImpl:function(e,t,n,s){const i=r.getTypedArrayFromDType(s,r.sizeFromShape(n));for(let n=0;n<i.length;++n){const r=n*t;let s=e[r];for(let n=0;n<t;++n){const t=e[r+n];(Number.isNaN(t)||t>s)&&(s=t)}i[n]=s}return i},maximumImpl:zn,minimumImpl:Pn,multiplyImpl:Tn,negImpl:function(e,t,n){const s=r.createScalarValue(-1,n);return Tn([],t,s,e,n)},notEqualImpl:En,prodImpl:function(e,t,s,i){const[a,o]=n.computeOutAndReduceShapes(e,i),u=h(t,"int32"),l=r.makeZerosTypedArray(r.sizeFromShape(a),u),d=r.sizeFromShape(o);for(let e=0;e<l.length;++e){const t=e*d;let n=1;for(let e=0;e<d;++e)n*=s[t+e];l[e]=n}return{outVals:l,outShape:a,outDtype:u}},rangeImpl:function(e,t,n,s){if(e===t||e<t&&n<0||t<e&&n>1)return r.makeZerosTypedArray(0,s);const i=Math.abs(Math.ceil((t-e)/n)),a=r.makeZerosTypedArray(i,s);t<e&&1===n&&(n=-1),a[0]=e;for(let e=1;e<a.length;e++)a[e]=a[e-1]+n;return a},rsqrtImpl:Bn,scatterImpl:function(e,t,n,r,s,i,a,o,u,l){const h=[r/s,s],c=e.values,p=t.values;if(0===r)return d(n,t.dtype);const f=d(h,t.dtype);"string"==typeof u||"number"==typeof u?f.values.fill(u):"boolean"==typeof u&&f.values.fill(+u);for(let e=0;e<i;e++){const i=[];let u=0;for(let t=0;t<a;t++){const n=c[e*a+t];i.push(n),u+=n*o[t]}if(u<0||u>=r/s)throw new Error(`Invalid indices: ${i} does not index into ${n}`);for(let n=0;n<s;n++)l?f.values[u*s+n]+=p[e*s+n]:f.values[u*s+n]=0===t.rank?p[0]:p[e*s+n]}return f},sigmoidImpl:Nn,sliceImpl:function(e,t,s,i,a){const o=c.isSliceContinous(i,t,s),u=r.sizeFromShape(s),l=r.computeStrides(i);if(o){const n=c.computeFlatOffset(t,l);return"string"===a?e.slice(n,n+u):e.subarray(n,n+u)}const h="string"===a?n.fromUint8ToStringArray(e):e,p=d(i,a,h),f=d(s,a);for(let e=0;e<f.size;++e){const n=f.indexToLoc(e),r=n.map(((e,n)=>e+t[n]));f.set(p.get(...r),...n)}return"string"===a?n.fromStringArrayToUint8(f.values):f.values},sparseFillEmptyRowsImpl:function(e,t,s,i,a,o,u){const l=t[0],h=o[0],d=new Array(h),c=new Array(l),p=t[1];if(0===h){if(0!==l)throw new Error(n.getSparseFillEmptyRowsIndicesDenseShapeMismatch(l));return[r.getArrayFromDType(s,0),[0,p],r.getArrayFromDType(a,0),d,c]}let f=!0,m=0;const g=new Array(h).fill(0);for(let t=0;t<l;++t){const r=e[t*p];if(r<0)throw new Error(n.getSparseFillEmptyRowsNegativeIndexErrorMessage(t,r));if(r>=h)throw new Error(n.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(t,r,h));++g[r],f=f&&r>=m,m=r}let b=!0;for(let e=0;e<h;++e){const t=0===g[e];d[e]=t,b=b&&!t,g[e]=Math.max(g[e],1),e>0&&(g[e]+=g[e-1])}if(b&&f){const t=e,n=i;for(let e=0;e<l;++e)c[e]=e;return[t,[l,p],n,d,c]}{const t=g[h-1],n=r.getArrayFromDType(s,t*p),o=r.getArrayFromDType(a,t),f=new Array(h).fill(0);for(let t=0;t<l;++t){const r=e[t*p],s=f[r],a=(0===r?0:g[r-1])+s;f[r]++;for(let r=0;r<p;++r)n[a*p+r]=e[t*p+r];o[a]=i[t],c[t]=a}for(let e=0;e<h;++e){if(0===f[e]){const t=0===e?0:g[e-1];n[t*p+0]=e;for(let e=1;e<p;++e)n[t*p+e]=0;o[t]=u}}return[n,[t,p],o,d,c]}},sparseReshapeImpl:function(e,t,s,i,a){const o=r.sizeFromShape(i),u=t[0],l=a.length,h=[];let d=1,c=-1;for(let e=0;e<l;++e){const t=a[e];if(-1===t){if(-1!==c)throw new Error(n.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(c,e));c=e,h.push(1)}else{if(t<0)throw new Error(n.getSparseReshapeNegativeOutputDimErrorMessage(e,t));d*=t,h.push(t)}}if(-1!==c){if(d<=0)throw new Error(n.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage());const e=Math.trunc(o/d);if(d*e!==o)throw new Error(n.getSparseReshapeInputOutputMultipleErrorMessage(i,h));h[c]=e}if(r.sizeFromShape(h)!==o)throw new Error(n.getSparseReshapeInputOutputMismatchErrorMessage(i,h));const p=i.length,f=[];if(p>0){f[p-1]=1;for(let e=p-2;e>=0;--e)f[e]=f[e+1]*i[e+1]}const m=[];if(l>0){m[l-1]=1;for(let e=l-2;e>=0;--e)m[e]=m[e+1]*h[e+1]}const g=r.getArrayFromDType(s,u*l);for(let t=0;t<u;++t){let n=0;for(let r=0;r<p;++r)n+=e[t*p+r]*f[r];for(let e=0;e<l;++e)g[t*l+e]=Math.trunc(n/m[e]),n%=m[e]}return[g,[u,l],h]},sparseSegmentReductionImpl:function(e,t,s,i,a,o=!1,u=0){const l=i.length,h=[t[0],e.length/t[0]],d=h[1],c=l>0?a[l-1]+1:0;if(c<0)throw new Error(n.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const p=t.slice();p[0]=c;const f=p.reduce(((e,t)=>e*t),1),m=r.getArrayFromDType(s,f);if(0===l)return c>0&&m.fill(u),[m,p];if(c<=0)throw new Error(n.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());let g=0,b=1,x=0,w=a[g];for(;;){let t=0;if(b<l){if(t=a[b],w===t){++b;continue}if(w>=t)throw new Error(n.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage())}if(w<0||w>=c)throw new Error(n.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(w,c));w>x&&m.fill(u,x*d,w*d);for(let t=g;t<b;++t){const r=i[t];if(r<0||r>=h[0])throw new Error(n.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(t,i[t],h[0]));for(let t=0;t<d;t++)m[w*d+t]+=e[r*d+t]}if(o)for(let e=0;e<d;e++)m[w*d+e]/=b-g;if(g=b,++b,x=w+1,w=t,b>l)break}return x<c&&m.fill(u,x*d,c*d),[m,p]},sqrtImpl:_n,squaredDifferenceImpl:On,stridedSliceImpl:function(e,t,n,r){const s=d(e,t.dtype);for(let e=0;e<s.size;e++){const i=s.indexToLoc(e),a=new Array(i.length);for(let e=0;e<a.length;e++)a[e]=i[e]*n[e]+r[e];s.set(t.get(...a),...i)}return s},stringNGramsImpl:function(e,t,n,r,s,i,a,o){return new Fn(n,r,s,i,a,o).compute(e,t)},stringSplitImpl:function(e,t,n){const s=e.length,i=[];let a=0,o=0;const u=new Array(s);for(let r=0;r<s;++r){const s=i.length;Gn(e[r],t,n,i);const l=i.length-s;u[r]=l,a+=l,o=Math.max(o,l)}const l=r.getArrayFromDType("int32",2*a),h=new Array(a),d=[s,o];let c=0;for(let e=0;e<s;++e)for(let t=0;t<u[e];++t)l[2*c]=e,l[2*c+1]=t,h[c]=i[c],++c;return[l,h,d]},stringToHashBucketFastImpl:function(e,t){const n=r.getArrayFromDType("int32",e.length);for(let s=0;s<e.length;++s)n[s]=r.fingerPrint64(e[s]).modulo(t).getLowBitsUnsigned();return n},subImpl:Un,tileImpl:function(e,t){const n=new Array(e.rank);for(let r=0;r<n.length;r++)n[r]=e.shape[r]*t[r];const r=d(n,e.dtype);for(let t=0;t<r.values.length;++t){const n=r.indexToLoc(t),s=new Array(e.rank);for(let t=0;t<s.length;t++)s[t]=n[t]%e.shape[t];const i=e.locToIndex(s);r.values[t]=e.values[i]}return r},topKImpl:function(e,t,n,s,i){const a=t[t.length-1],[o,u]=[e.length/a,a],l=r.getTypedArrayFromDType(n,o*s),h=r.getTypedArrayFromDType("int32",o*s);for(let t=0;t<o;t++){const n=t*u,r=e.subarray(n,n+u);let a=new Array(r.length);r.forEach(((e,t)=>a[t]={value:e,index:t})),s<a.length&&(Mn(a,s),a=a.slice(0,s)),i&&a.sort(Ln);const o=t*s,d=l.subarray(o,o+s),c=h.subarray(o,o+s);for(let e=0;e<s;e++)d[e]=a[e].value,c[e]=a[e].index}const c=t.slice();return c[c.length-1]=s,[d(c,n,l),d(c,"int32",h)]},transposeImpl:function(e,t,n,s,i){const a=t.length,o=r.sizeFromShape(t),u=r.computeStrides(t),l=r.computeStrides(i),h=r.getTypedArrayFromDType(n,r.sizeFromShape(i));for(let t=0;t<o;++t){const n=r.indexToLoc(t,a,u),i=new Array(n.length);for(let e=0;e<i.length;e++)i[e]=n[s[e]];h[r.locToIndex(i,a,l)]=e[t]}return h},uniqueImpl:function(e,t,n,s){const i=r.parseAxisParam(t,n)[0],a=[1,n[0],1];for(let e=0;e<i;e++)a[0]*=n[e];a[1]=n[i];for(let e=i+1;e<n.length;e++)a[2]*=n[e];const o={},u=new Int32Array(n[i]),l=new p(a,s,e),h=[],d=1===a[0]&&1===a[2];for(let t=0;t<n[i];t++){let n;if(d)n=e[t].toString();else{const e=[];for(let n=0;n<a[0];n++)for(let r=0;r<a[2];r++)e.push(l.get(n,t,r));n=e.join(",")}if(void 0!==o[n])u[t]=o[n];else{const e=Object.keys(o).length;o[n]=e,u[t]=e,h.push(t)}}const c=a.slice();c[1]=Object.keys(o).length;const f=new p(c,s);h.forEach(((e,t)=>{for(let n=0;n<a[0];n++)for(let r=0;r<a[2];r++)f.set(l.get(n,e,r),n,t,r)}));const m=n.slice();return m[i]=c[1],{outputValues:f.values,outputShape:m,indices:u}}};const{addImpl:Wn,ceilImpl:Vn,concatImpl:Hn,equalImpl:Xn,expImpl:qn,expm1Impl:Kn,floorImpl:Yn,gatherNdImpl:jn,gatherV2Impl:Qn,greaterEqualImpl:Zn,greaterImpl:Jn,lessEqualImpl:er,lessImpl:tr,logImpl:nr,maxImpl:rr,maximumImpl:sr,minimumImpl:ir,multiplyImpl:ar,negImpl:or,notEqualImpl:ur,prodImpl:lr,rangeImpl:hr,rsqrtImpl:dr,scatterImpl:cr,simpleAbsImpl:pr,sliceImpl:fr,stridedSliceImpl:mr,stringNGramsImpl:gr,subImpl:br,tileImpl:xr,topKImpl:wr,transposeImpl:Ir,uniqueImpl:yr}=Dn,kr={kernelName:f,backendName:"webgpu",kernelFunc:fn({opType:mt.ABS,cpuKernelImpl:pr})},Sr={kernelName:m,backendName:"webgpu",kernelFunc:mn({opType:ht.ADD,cpuKernelImpl:Wn,supportsComplex:!0})};class vr{constructor(e){this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e[0],this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.shaderKey="addN"}getUserCode(){const e=[];this.variableNames.forEach((t=>{e.push(`let v${t} = get${t}ByOutputCoords(coords);`)}));const t=this.variableNames.map((e=>`v${e}`)).join(" + ");return`\n      ${vt()}\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            ${e.join("\n        ")}\n            setOutputAtIndex(flatIndex, ${t});\n          }\n        }\n      }\n    `}}const Cr={kernelName:g,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,r=t;if(1===r.length)return ln({inputs:{x:r[0]},backend:n});const s=r.map((e=>e.dtype)).reduce(((e,t)=>h(e,t))),i=r.map((e=>e.shape)),a=new vr(i);return n.runWebGPUProgram(a,r,s)}};class $r{constructor(e,t,r){this.workGroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="infinityValue : f32,",this.size=!0;const s=[t];n.assertAxesAreInnerMostDims("arg"+r.charAt(0).toUpperCase()+r.slice(1),s,e.length),this.op="min"===r?"<":">";const[i]=n.computeOutAndReduceShapes(e,s);this.outputShape=0===i.length?[1]:i,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,[1,1,1]),this.inputShape=e,this.shaderKey=`argMinMax${this.op}`}getUserCode(){return`\n      fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n      }\n\n      ${`\n      var<workgroup> xBestIndices : array<i32, ${this.workGroupSize[0]}>;\n      var<workgroup> xBestValues : array<f32, ${this.workGroupSize[0]}>;\n    `}\n\n      ${vt()}\n        let outputIndex = index / i32(workGroupSizeX);\n        let reduceLength = ${(()=>1===this.inputShape.length?"uniforms.xShape":`uniforms.xShape.${St(this.inputShape.length-1)}`)()};\n\n        var bestIndex = i32(localId.x);\n        var bestValue = uniforms.infinityValue;\n        let outputCoords = getCoordsFromIndex(outputIndex);\n        for (var k = i32(localId.x); k < reduceLength && outputIndex < uniforms.size;\n            k = k + i32(workGroupSizeX)) {\n          let candidate = getX(${(()=>{let e="";if(1===this.outputShape.length)1!==this.inputShape.length&&(e+="outputCoords,");else for(let t=0;t<this.outputShape.length;t++)e+=`outputCoords.${St(t)},`;return e})()} k);\n          if (!isnan(candidate) && candidate ${this.op} bestValue) {\n            bestValue = candidate;\n            bestIndex = k;\n          }\n        }\n        xBestValues[localId.x] = bestValue;\n        xBestIndices[localId.x] = bestIndex;\n        workgroupBarrier();\n\n        var reduceSize = min(u32(reduceLength), workGroupSizeX);\n        for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n            currentSize = reduceSize / 2u) {\n          let interval = DIV_CEIL(reduceSize, 2u);\n          if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              xBestValues[localId.x] = bestValue;\n              xBestIndices[localId.x] = xBestIndices[localId.x + interval];\n            }\n          }\n          reduceSize = interval;\n          workgroupBarrier();\n        }\n\n        if (localId.x == 0u && outputIndex < uniforms.size) {\n          setOutputAtIndexI32(outputIndex, xBestIndices[localId.x]);\n        }\n      }\n    `}}class Rr{constructor(e,t){this.variableNames=["A"],this.workGroupSize=[16,16,1];const n=new Array(e.length);for(let r=0;r<n.length;r++)n[r]=e[t[r]];this.outputShape=n,this.dispatchLayout={x:[0],y:[1]},this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[1,1,1]),this.shaderKey="transposeShared"}getUserCode(){return`\n      const TILE_DIM = ${this.workGroupSize[0]};\n      var<workgroup> tile : array<array<f32, ${this.workGroupSize[0]+1}>, ${this.workGroupSize[0]}>;\n      \n  @compute @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(local_invocation_id) localId : vec3<u32>,\n              @builtin(workgroup_id) workgroupId : vec3<u32>) {\n        var x = i32(workgroupId.x) * TILE_DIM + i32(localId.x);\n        var y = i32(workgroupId.y) * TILE_DIM + i32(localId.y);\n        let width = uniforms.outShape[0];\n        let height = uniforms.outShape[1];\n        if (x < width && y < height) {\n          tile[localId.y][localId.x] = A[y * width + x];\n        }\n        workgroupBarrier();\n\n        x = i32(workgroupId.y) * TILE_DIM + i32(localId.x);\n        y = i32(workgroupId.x) * TILE_DIM + i32(localId.y);\n        if (x < height && y < width) {\n          setOutputAtIndex((y * height + x), tile[localId.x]\n            [localId.y]);\n        }\n      }\n    `}}class Ar{constructor(e,t){this.variableNames=["A"],this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let r=0;r<n.length;r++)n[r]=e[t[r]];this.outputShape=n,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.newDim=t,this.shaderKey=`transpose_${t}`}getUserCode(){const e=kt(this.outputShape.length),t=function(e){const t=e.length;if(t>6)throw Error(`Transpose for rank ${t} is not yet supported`);const n=new Array(t);for(let t=0;t<e.length;t++)n[e[t]]=`resRC.${St(t)}`;return n.join()}(this.newDim);return`\n      ${vt()}\n\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let resRC = getCoordsFromIndex(flatIndex);\n            setOutputAtIndex(flatIndex, A[getIndexFromCoords${this.outputShape.length}D(\n              ${e}(${t}), uniforms.aShape)]);\n          }\n        }\n      }\n    `}}function zr(e){const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{perm:a}=s,o=n,u=i.shape.length,l=new Array(u);for(let e=0;e<l.length;e++)l[e]=i.shape[a[e]];if(n.shouldExecuteOnCPU([i])){const e=o.tensorMap.get(i.dataId).values,t=Ir(e,i.shape,i.dtype,a,l);return n.makeTensorInfo(l,i.dtype,t)}if(2===i.shape.length&&r.arraysEqual(a,[1,0])){const e=new Rr(i.shape,a);return o.runWebGPUProgram(e,[i],i.dtype)}const h=new Ar(i.shape,a);return o.runWebGPUProgram(h,[i],i.dtype)}const Pr={kernelName:b,backendName:"webgpu",kernelFunc:zr};const Tr={kernelName:x,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{axis:o}=i;let u=r.parseAxisParam(o,a.shape);const l=n.getAxesPermutation(u,a.shape.length);let h=a;const d=[];null!=l&&(h=zr({inputs:{x:a},backend:s,attrs:{perm:l}}),d.push(h),u=n.getInnerMostAxes(u.length,h.shape.length)),n.assertAxesAreInnerMostDims("argMax",[u[0]],h.shape.length);const c=new $r(h.shape,u[0],"max"),p=[{type:"float32",data:[Number.NEGATIVE_INFINITY]}],f=s.runWebGPUProgram(c,[h],"int32",p);return d.forEach((e=>s.disposeData(e.dataId))),f}};const Er={kernelName:w,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{axis:o}=i;let u=r.parseAxisParam(o,a.shape);const l=n.getAxesPermutation(u,a.shape.length);let h=a;const d=[];null!=l&&(h=zr({inputs:{x:a},backend:s,attrs:{perm:l}}),d.push(h),u=n.getInnerMostAxes(u.length,h.shape.length)),n.assertAxesAreInnerMostDims("argMin",[u[0]],h.shape.length);const c=new $r(h.shape,u[0],"min"),p=[{type:"float32",data:[Number.POSITIVE_INFINITY]}],f=s.runWebGPUProgram(c,[h],"int32",p);return d.forEach((e=>s.disposeData(e.dataId))),f}};class Br{constructor(e,t){this.variableNames=["x"],this.uniforms="stride : vec2<i32>, pad : vec2<i32>, dilation : vec2<i32>, convDims : vec2<i32>, filterDims : vec2<i32>,",this.workGroupSize=[128,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`pool2D_${t}`,this.poolType=t}getUserCode(){let e="resultValue = max(value, resultValue);";"avg"===this.poolType&&(e="resultValue = resultValue + value; count = count + 1.0;");let t="resultValue";"avg"===this.poolType&&(t="resultValue / count");return`\n      ${vt()}\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let xRCCorner = vec2<i32>(coords.yz) * uniforms.stride - uniforms.pad;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};\n          var count = 0.0;\n\n          for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + uniforms.dilation.x) {\n            let xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + uniforms.dilation.y) {\n              let xC = xCCorner + wC;\n              if (xC < 0 || xC >= uniforms.convDims.y) {\n                continue;\n              }\n\n              let value = getX(batch, xR, xC, coords[3]);\n              ${e}\n            }\n          }\n\n          setOutputAtIndex(index, ${t});\n        }\n      }\n    `}}class Nr{constructor(e){this.variableNames=["x"],this.uniforms="stride : vec2<i32>,",this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="poolWithFilterSizeEqualsOne"}getUserCode(){return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n\n          let xRCCorner = coords.yz * uniforms.stride;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          let value = getX(batch, xRCorner, xCCorner, d);\n          setOutputAtIndex(index, value);\n        }\n      }\n    `}}const _r={kernelName:I,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{filterSize:o,strides:u,pad:l,dimRoundingMode:h}=i,d=n.computePool2DInfo(a.shape,o,u,1,l,h);if(1===d.filterWidth&&1===d.filterHeight&&r.arraysEqual(d.inShape,d.outShape))return ln({inputs:{x:a},backend:s});let c;const p=[{type:"int32",data:[d.strideHeight,d.strideWidth]}];return 1===d.filterHeight&&1===d.filterWidth?c=new Nr(d):(c=new Br(d,"avg"),p.push({type:"int32",data:[d.padInfo.top,d.padInfo.left]},{type:"int32",data:[d.dilationHeight,d.dilationWidth]},{type:"int32",data:[d.inHeight,d.inWidth]},{type:"int32",data:[d.effectiveFilterHeight,d.effectiveFilterWidth]})),s.runWebGPUProgram(c,[a],a.dtype,p)}};const Or={kernelName:y,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{a:s,b:i}=t,{transposeA:a,transposeB:o}=r;return sn({a:s,b:i,transposeA:a,transposeB:o,backend:n})}};class Fr{constructor(e,t){this.variableNames=["source"],this.workPerThread=1,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.rank=t.length,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.start=e,this.uniforms=`start : ${kt(e.length)}, `,this.shaderKey="slice"}getUserCode(){const e=kt(this.rank),t=function(e){if(1===e)return"sourceLoc";if(e<=6)return Gr.slice(0,e).map((e=>`sourceLoc.${e}`)).join(",");throw Error(`Slicing for rank ${e} is not yet supported`)}(this.rank);let n;n=1===this.start.length?this.outputShape.map(((e,t)=>"sourceLoc = uniforms.start + coords;")):this.outputShape.map(((e,t)=>`sourceLoc.${Gr[t]} = uniforms.start[${t}] + coords.${Gr[t]};`));return`\n      ${vt()}\n        if (index < uniforms.size) {\n          var sourceLoc : ${e};\n          let coords = getCoordsFromIndex(index);\n          ${n.join("\n")}\n          setOutputAtIndex(index, getSource(${t}));\n        }\n      }\n    `}}const Gr=["x","y","z","w","u","v"];function Ur(e){const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{begin:a,size:o}=s,[u,l]=c.parseSliceParams(i,a,o);if(c.assertParamsValid(i,u,l),n.shouldExecuteOnCPU([i])||"string"===i.dtype){const e=n.tensorMap.get(i.dataId),t=fr(e.values,u,l,i.shape,i.dtype);return n.makeTensorInfo(l,i.dtype,t)}if(0===r.sizeFromShape(l))return n.makeTensorInfo(l,i.dtype,[]);const h=new Fr(u,l),d=[{type:"int32",data:u}];return n.runWebGPUProgram(h,[i],i.dtype,d)}const Lr={kernelName:k,backendName:"webgpu",kernelFunc:Ur},Mr={kernelName:S,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{blockShape:o,crops:u}=i;r.assert(a.shape.length<=4,(()=>"batchToSpaceND for rank > 4 with a WebGPU backend not implemented yet"));const l=o.reduce(((e,t)=>e*t)),h=n.getReshaped(a.shape,o,l),d=n.getPermuted(h.length,o.length),c=n.getReshapedPermuted(a.shape,o,l),p=n.getSliceBeginCoords(u,o.length),f=n.getSliceSize(c,u,o.length),m=[],g=nn({inputs:{x:a},backend:s,attrs:{shape:h}}),b=zr({inputs:{x:g},backend:s,attrs:{perm:d}}),x=nn({inputs:{x:b},backend:s,attrs:{shape:c}}),w=Ur({inputs:{x:x},backend:s,attrs:{begin:p,size:f}});return m.push(g),m.push(b),m.push(x),m.forEach((e=>s.disposeData(e.dataId))),w}},Dr=mn({opType:ht.NOT_EQUAL,dtype:"bool",cpuKernelImpl:ur}),Wr={kernelName:v,backendName:"webgpu",kernelFunc:Dr};function Vr(e){const{inputs:t,backend:n}=e,{input:r}=t;return ln({inputs:{x:n.tensorMap.get(r.dataId).complexTensorInfos.real},backend:n})}const Hr={kernelName:C,backendName:"webgpu",kernelFunc:Vr};const Xr={kernelName:$,backendName:"webgpu",kernelFunc:function t(n){const{inputs:s,backend:i,attrs:a}=n,{x:o}=s,{dtype:u}=a;if("complex64"===u){if("complex64"===o.dtype)return ln({inputs:{x:o},backend:i});const n=e.zeros(o.shape),r=t({inputs:{x:o},backend:i,attrs:{dtype:"float32"}}),s=dn({inputs:{real:r,imag:n},backend:i});return n.dispose(),i.disposeData(r.dataId),s}if("complex64"===o.dtype){const e=Vr({inputs:{input:o},backend:i}),n=t({inputs:{x:e},backend:i,attrs:{dtype:u}});return i.disposeData(e.dataId),n}if(!r.hasEncodingLoss(o.dtype,u)){const e=ln({inputs:{x:o},backend:i});return{dataId:e.dataId,shape:e.shape,dtype:u}}if("int32"===u)return function(e,t){const n=new pn(e.shape,mt.TO_INT),r=t.runWebGPUProgram(n,[e],"int32");return{dataId:r.dataId,shape:r.shape,dtype:r.dtype}}(o,i);if("bool"===u){const e=i.makeTensorInfo([],"bool",r.getTypedArrayFromDType("bool",1)),t=Dr({inputs:{a:o,b:e},backend:i});return i.disposeData(e.dataId),t}throw new Error(`Error in Cast: failed to cast ${o.dtype} to ${u}`)}},qr={kernelName:R,backendName:"webgpu",kernelFunc:fn({opType:mt.CEIL,cpuKernelImpl:Vn})};class Kr{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workPerThread=4,this.workGroupSize=[64,1,1],this.isVec4=!0,this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.shaderKey="clipVec4"}getUserCode(){return`\n      ${vt()}\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          var clampedValue : vec4<f32>;\n          for (var i = 0; i < 4; i = i + 1) {\n            if (isnan(value[i])) {\n              clampedValue[i] = value[i];\n            } else {\n              clampedValue[i] = clamp(value[i], uniforms.minVal, uniforms.maxVal);\n            }\n          }\n\n          setOutputAtIndex(index, clampedValue);\n        }\n      }\n    `}}class Yr{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="clip"}getUserCode(){return`\n      ${vt()}\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          if (isnan(value)) {\n            setOutputAtIndex(index, value);\n            return;\n          }\n          setOutputAtIndex(index, clamp(value, uniforms.minVal, uniforms.maxVal));\n        }\n      }\n    `}}const jr={kernelName:A,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{clipValueMin:a,clipValueMax:o}=s;let u;const l=[{type:"float32",data:[a]},{type:"float32",data:[o]}];return u=r.sizeFromShape(i.shape)%4==0?new Kr(i.shape):new Yr(i.shape),n.runWebGPUProgram(u,[i],i.dtype,l)}};class Qr{constructor(e){this.uniforms="",this.workPerThread=4,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=n.computeOutShape(e,1),this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]),this.offsetLength=e.length-1;for(let e=0;e<this.offsetLength;e++)this.uniforms+=`offset${e} : i32,`;this.shaderKey="concat"}getUserCode(){const e=[];if(this.offsetLength>0){e.push("if (yC < uniforms.offset0){ setOutputAtCoords(coords.x, coords.y, getT0(yR, yC)); }");for(let t=1;t<this.offsetLength;t++)e.push(`else if (yC < uniforms.offset${[t]}){ setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${t-1})); }`);const t=this.offsetLength,n=this.offsetLength-1;e.push(`else { setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${n})); }`)}else e.push("setOutputAtCoords(coords.x, coords.y, getT0(yR, yC));");return`\n      ${vt()}\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            let yR = coords.x;\n            let yC = coords.y;\n\n            ${e.join("\n        ")}\n          }\n        }\n      }\n    `}}function Zr(e){const{inputs:t,backend:n}=e,{input:r}=t;return ln({inputs:{x:n.tensorMap.get(r.dataId).complexTensorInfos.imag},backend:n})}const Jr={kernelName:z,backendName:"webgpu",kernelFunc:Zr};function es(e,t,s){const i=e[0].dtype;if("complex64"===i){const n=e.map((e=>Vr({inputs:{input:e},backend:s}))),r=e.map((e=>Zr({inputs:{input:e},backend:s}))),i=es(n,t,s),a=es(r,t,s),o=dn({inputs:{real:i,imag:a},backend:s});return n.forEach((e=>s.disposeData(e.dataId))),r.forEach((e=>s.disposeData(e.dataId))),s.disposeData(i.dataId),s.disposeData(a.dataId),o}let a=s.shouldExecuteOnCPU(e);if("string"===i&&(a=!0),a){const a=e.map((e=>{const n=r.sizeFromShape(e.shape.slice(t));return nn({inputs:{x:e},backend:s,attrs:{shape:[-1,n]}})})),o=a.map((e=>({vals:s.readSync(e.dataId),shape:e.shape}))),u=n.computeOutShape(a.map((e=>e.shape)),1),l=1===a[0].shape[0],h=Hn(o,u,i,l),d=n.computeOutShape(e.map((e=>e.shape)),t),c=s.makeTensorInfo(d,i,h);return a.forEach((e=>s.disposeData(e.dataId))),c}const o=s.device.limits.maxStorageBuffersPerShaderStage-1;if(e.length>o){const n=[];for(let r=0;r<e.length;r+=o){const i=e.slice(r,r+o);n.push(es(i,t,s))}const r=es(n,t,s);for(const e of n)s.disposeData(e.dataId);return r}const{tensors2D:u,outShape:l}=function(e,t,s){const i=n.computeOutShape(e.map((e=>e.shape)),t);return{tensors2D:e.map((e=>nn({inputs:{x:e},backend:s,attrs:{shape:[r.sizeFromShape(e.shape.slice(0,t)),r.sizeFromShape(e.shape.slice(t))]}}))),outShape:i}}(e,t,s),h=u.map((e=>e.shape)),d=new Qr(h),c=[],p=new Array(h.length-1);if(p.length>0){p[0]=h[0][1],c.push({type:"int32",data:[p[0]]});for(let e=1;e<p.length;e++)p[e]=p[e-1]+h[e][1],c.push({type:"int32",data:[p[e]]})}const f=s.runWebGPUProgram(d,u,u[0].dtype,c);u.forEach((e=>s.disposeData(e.dataId)));const m=nn({inputs:{x:f},backend:s,attrs:{shape:l}});return s.disposeData(f.dataId),m}function ts(e){const{inputs:t,backend:s,attrs:i}=e,{axis:a}=i,o=r.parseAxisParam(a,t[0].shape)[0],u=n.computeOutShape(t.map((e=>e.shape)),o);if(0===r.sizeFromShape(u))return s.makeTensorInfo(u,t[0].dtype,[]);const l=t.filter((e=>r.sizeFromShape(e.shape)>0));if(1===l.length)return ln({inputs:{x:l[0]},backend:s});const h=l.map((e=>e.shape));return n.assertParamsConsistent(h,o),es(l,o,s)}const ns={kernelName:P,backendName:"webgpu",kernelFunc:ts};class rs{constructor(e,t,n,r,s=!1,i=null,a=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pad : vec2<i32>, stride : vec2<i32>, dilation : vec2<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.isVec4=((e.inChannels%4==0||e.inChannels%3==0)&&this.isChannelsLast||e.outWidth%4==0&&!this.isChannelsLast)&&e.outChannels%4==0,this.dispatchLayout=this.isChannelsLast?{x:[3],y:[1,2],z:[0]}:{x:[2,3],y:[1],z:[0]},this.workGroupSize=Nt(this.dispatchLayout,this.outputShape,this.isVec4),this.elementsPerThread=Ot(this.dispatchLayout,this.outputShape,this.isVec4),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),this.isVec4?(this.isChannelsLast&&e.inChannels%4!=0?(this.innerElementSize=3,this.variableTypes=["f32","vec4<f32>"]):(this.innerElementSize=4,this.variableTypes=["vec4<f32>","vec4<f32>"]),s&&(this.variableNames.push("bias"),this.variableTypes.push("vec4<f32>")),a&&(this.variableNames.push("preluActivationWeights"),this.variableTypes.push("vec4<f32>"))):(this.innerElementSize=this.elementsPerThread[0],s&&this.variableNames.push("bias"),a&&this.variableNames.push("preluActivationWeights")),this.addBias=s,this.activation=i,this.hasPreluActivationWeights=a,this.tileAOuter=this.workGroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=Math.max(this.workGroupSize[0]*this.innerElementSize,this.workGroupSize[1]),this.fitAOuter=t%this.tileAOuter==0,this.fitBOuter=n%this.tileBOuter==0,this.fitInner=r%this.tileInner==0,this.shaderKey=`conv2DMM_${this.elementsPerThread}_${this.activation}}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.isVec4}_${this.innerElementSize}_${this.isChannelsLast}`}getUserCode(){const e=this.isVec4?qt(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner,this.innerElementSize,!this.isChannelsLast):Ht(this.elementsPerThread,this.workGroupSize,!this.isChannelsLast,this.tileInner),t=this.isVec4?[this.isChannelsLast?this.innerElementSize:4,4,4]:[1,1,1];return`\n    ${function(e,t,n,r,s=!1,i=null,a=!1,o=4,u=4,l=4){const h=e?"\n      let coord = vec4<i32>(batch, xRow, xCol, xCh);\n      ":"\n      let coord = vec4<i32>(batch, xCh, xRow, xCol);\n      ",d=e?"\n      let coords = vec4<i32>(\n        batch,\n        row / outWidth,\n        row % outWidth,\n        col);\n      ":"\n      let coords = vec4<i32>(\n        batch,\n        row,\n        col / outWidth,\n        col % outWidth);\n      ",c=e?"uniforms.xShape[1]":"uniforms.xShape[2]",p=e?"uniforms.xShape[2]":"uniforms.xShape[3]",f=e?"row":"col",m=e?"col":"row",g=`\n      let inChannels = uniforms.wShape[2];\n      let outWidth = ${e?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n      let outRow = ${f} / outWidth;\n      let outCol = ${f} % outWidth;\n\n      let WRow = ${m} / (uniforms.filterDims[1] * inChannels);\n      let WCol = ${m} / inChannels % uniforms.filterDims[1];\n      let xRow = outRow * uniforms.stride[0] + uniforms.dilation[0] * WRow - uniforms.pad[0];\n      let xCol = outCol * uniforms.stride[1] + uniforms.dilation[1] * WCol - uniforms.pad[1];\n      let xCh = ${m} % inChannels;\n      var resData = ${bt(o)}(0.0);\n      // The bounds checking is always needed since we use it to pad zero for\n      // the 'same' padding type.\n      if (xRow >= 0 && xRow < ${c} && xCol >= 0 && xCol < ${p}) {\n        ${h}\n        let xIndex = getIndexFromCoords4D(coord, uniforms.xShape);\n        ${(e=>{switch(e){case 1:return"resData = x[xIndex];";case 3:return"resData = vec3<f32>(x[xIndex], x[xIndex + 1], x[xIndex + 2]);";case 4:return"resData = x[xIndex / 4];";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(o)}\n      }\n      return resData;`,b=e?t&&r?`\n      let col = colIn * ${o};\n      ${g}`:`\n      let col = colIn * ${o};\n      if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n        ${g}\n      }\n      return ${bt(o)}(0.0);`:r&&n?`\n      let col = colIn * ${o};\n      ${g}`:`\n      let col = colIn * ${o};\n      if (row < uniforms.dimInner && col < uniforms.dimBOuter) {\n        ${g}\n      }\n      return ${bt(o)}(0.0);`,x=`${(e=>{switch(e){case 1:return"return W[row * uniforms.wShape[3] + colIn];";case 4:return"return W[row * uniforms.wShape[3] / 4 + colIn];";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(u)}`,w=bt(l),I=bt(e?o:u),y=bt(e?u:o);return`\n      ${xt(i,a,4===l,4)}\n      fn mm_readA(batch: i32, row : i32, colIn : i32) -> ${I} {\n        ${e?b:x}\n      }\n\n      fn mm_readB(batch: i32, row : i32, colIn : i32) -> ${y} {\n        ${e?x:b}\n      }\n\n      fn mm_write(batch: i32, row : i32, colIn : i32, valueIn : ${w}) {\n        let col = colIn * ${l};\n        if (row < uniforms.dimAOuter && col < uniforms.dimBOuter)\n        {\n        var value = valueIn;\n        let outWidth = ${e?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n        ${d}\n        ${wt(s,i)}\n        setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }`}(this.isChannelsLast,this.fitAOuter,this.fitBOuter,this.fitInner,this.addBias,this.activation,this.hasPreluActivationWeights,t[0],t[1],t[2])}\n    ${e}\n  `}}function ss(e,t){const n=e.length;return n>=3?t?[...e.slice(0,-3),e[n-3]*e[n-2],e[n-1]]:[...e.slice(0,-3),e[n-3],e[n-2]*e[n-1]]:!t&&1===n&&e[0]>1?[e[0],1]:null}function is({x:e,filter:t,convInfo:n,backend:r,bias:s=null,preluActivationWeights:i=null,leakyreluAlpha:a=0,activation:o=null}){const u=null!=s,l=null!=i,h="channelsLast"===n.dataFormat;if(h&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type||1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return function({x:e,filter:t,convInfo:n,backend:r,bias:s=null,preluActivationWeights:i=null,leakyreluAlpha:a=0,activation:o=null}){const u="channelsLast"===n.dataFormat,l=!u,h=[];let d,c;if(u&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type){const s=n.inHeight*n.inWidth*n.inChannels;d=nn({inputs:{x:e},backend:r,attrs:{shape:[1,n.batchSize,s]}}),c=nn({inputs:{x:t},backend:r,attrs:{shape:[1,s,n.outChannels]}})}else d=nn({inputs:{x:e},backend:r,attrs:{shape:u?[n.batchSize,n.inHeight*n.inWidth,n.inChannels]:[n.batchSize,n.inChannels,n.inHeight*n.inWidth]}}),c=nn({inputs:{x:t},backend:r,attrs:{shape:[1,n.inChannels,n.outChannels]}});if(h.push(d),h.push(c),null!=i){const e=ss(i.shape,u);null!=e&&(i=nn({inputs:{x:i},backend:r,attrs:{shape:e}}),h.push(i))}if(null!=s){const e=ss(s.shape,u);null!=e&&(s=nn({inputs:{x:s},backend:r,attrs:{shape:e}}),h.push(s))}const p=sn({a:u?d:c,b:u?c:d,transposeA:l,transposeB:!1,backend:r,bias:s,activation:o,preluActivationWeights:i,leakyreluAlpha:a}),f=nn({inputs:{x:p},backend:r,attrs:{shape:n.outShape}});h.push(p);for(const e of h)r.disposeData(e.dataId);return f}({x:e,filter:t,convInfo:n,backend:r,bias:s,activation:o,preluActivationWeights:i,leakyreluAlpha:a});const d=h?n.outHeight*n.outWidth:n.outChannels,c=h?n.outChannels:n.outHeight*n.outWidth,p=n.filterHeight*n.filterWidth*n.inChannels,f=[n.padInfo.top,n.padInfo.left],m=[{type:"int32",data:[n.filterHeight,n.filterWidth]},{type:"int32",data:[...f]},{type:"int32",data:[n.strideHeight,n.strideWidth]},{type:"int32",data:[n.dilationHeight,n.dilationWidth]},{type:"int32",data:[d]},{type:"int32",data:[c]},{type:"int32",data:[p]}],g=new rs(n,d,c,p,u,o,l),b=[],x=[e,t];u&&(h||1!==s.shape.length||(s=nn({inputs:{x:s},backend:r,attrs:{shape:[s.shape[0],1,1]}}),b.push(s)),x.push(s)),l&&(h||1!==i.shape.length||(i=nn({inputs:{x:i},backend:r,attrs:{shape:[i.shape[0],1,1]}}),b.push(i)),x.push(i)),"leakyrelu"===o&&(m.push({type:"float32",data:[a]}),g.uniforms+=" alpha : f32,");const w=r.runWebGPUProgram(g,x,e.dtype,m);for(const e of b)r.disposeData(e.dataId);return w}const as={kernelName:T,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,attrs:r,backend:s}=e,{x:i,filter:a}=t,{strides:o,pad:u,dataFormat:l,dilations:h,dimRoundingMode:d}=r,c=n.convertConv2DDataFormat(l);return is({x:i,filter:a,convInfo:n.computeConv2DInfo(i.shape,a.shape,o,h,u,d,!1,c),backend:s})}};class os{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, stride : vec2<i32>, outBackprop : vec4<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.inShape,r.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.isVec4=e.inChannels%4==0&&e.outChannels%4==0,this.dispatchLayout={x:[3],y:[1,2],z:[0]},this.workGroupSize=Nt(this.dispatchLayout,this.outputShape,this.isVec4),this.elementsPerThread=Ot(this.dispatchLayout,this.outputShape,this.isVec4),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,this.elementsPerThread),this.isVec4?(this.innerElementSize=4,this.variableTypes=["vec4<f32>","f32"]):this.innerElementSize=this.elementsPerThread[0],this.tileAOuter=this.workGroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workGroupSize[0]*this.elementsPerThread[0],this.tileInner=Math.max(this.workGroupSize[0]*this.innerElementSize,this.workGroupSize[1]),this.shaderKey=`conv2DDerInputMM_${this.isVec4}_${this.elementsPerThread}_${this.innerElementSize}`}getUserCode(){const e=this.isVec4?qt(this.elementsPerThread,this.tileAOuter,this.tileBOuter,this.tileInner,this.innerElementSize):Ht(this.elementsPerThread,this.workGroupSize);return`\n    ${function(e=4){const t=`if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n        \n      let outRow = row / uniforms.outShape[2];\n      let outCol = row % uniforms.outShape[2];\n\n      let WRow = col / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n      let WCol = col / uniforms.outBackprop[3] % uniforms.filterDims[1];\n      let xR = f32(outRow - uniforms.pads[0] + WRow) / f32(uniforms.stride[0]);\n      let xC = f32(outCol - uniforms.pads[1] + WCol) / f32(uniforms.stride[1]);\n      if (xR < 0.0 || xR >= f32(uniforms.outBackprop[1]) || fract(xR) > 0.0) {\n        return ${bt(e)}(0.0);\n      }\n      if (xC < 0.0 || xC >= f32(uniforms.outBackprop[2]) || fract(xC) > 0.0) {\n        return ${bt(e)}(0.0);\n      }\n      let coord = vec4<i32>(\n          batch,\n          i32(xR),\n          i32(xC),\n          col % uniforms.outBackprop[3]);\n      return x[getIndexFromCoords4D(coord, uniforms.xShape)/${e}];\n      }\n      return ${bt(e)}(0.0);`;return`\n  fn mm_readA(batch: i32, row : i32, colIn : i32) -> ${bt(e)} {\n    let col = colIn * ${e};\n    ${t}\n  }\n\n  fn mm_readB(batch: i32, row : i32, colIn : i32) -> ${bt(e)} {\n    let col = colIn * ${e};\n    let coordX = uniforms.filterDims.x - 1 -\n        row / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n    let coordY = uniforms.filterDims.y - 1 -\n        (row / uniforms.outBackprop[3]) % uniforms.filterDims[1];\n    if (row < uniforms.dimInner && col < uniforms.dimBOuter &&\n        coordX >= 0 && coordY >= 0) {\n      let rowInner = row % uniforms.outBackprop[3];\n      let coord = vec4<i32>(coordX, coordY, col, rowInner);\n      ${(e=>{switch(e){case 1:return"return W[getIndexFromCoords4D(coord, uniforms.wShape)];";case 4:return"\n            let coord1 = vec4<i32>(coordX, coordY, col + 1, rowInner);\n            let coord2 = vec4<i32>(coordX, coordY, col + 2, rowInner);\n            let coord3 = vec4<i32>(coordX, coordY, col + 3, rowInner);\n            let v0 = W[getIndexFromCoords4D(coord, uniforms.wShape)];\n            let v1 = W[getIndexFromCoords4D(coord1, uniforms.wShape)];\n            let v2 = W[getIndexFromCoords4D(coord2, uniforms.wShape)];\n            let v3 = W[getIndexFromCoords4D(coord3, uniforms.wShape)];\n            return vec4<f32>(v0, v1, v2, v3);\n            ";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(e)}\n    }\n    return ${bt(e)}(0.0);\n  }\n\n  fn mm_write(batch: i32, row : i32, colIn : i32, valueInput : ${bt(e)}) {\n    let col = colIn * ${e};\n    if (row < uniforms.dimAOuter && (col + ${e-1}) < uniforms.dimBOuter) {\n      var value = valueInput;\n      let outCoord = vec4<i32>(\n          batch,\n          row / uniforms.outShape[2],\n          row % uniforms.outShape[2],\n          col);\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)/${e}] = value;\n    }\n  }`}(this.isVec4?4:1)}\n    ${e}\n    `}}class us{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, stride : vec2<i32>, outBackprop : vec4<i32>,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,this.shaderKey=`conv2DDerInput_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3,n=this.isChannelsLast?3:1;return`\n    ${vt()} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[${n}];\n\n        let dyCorner = vec2<i32>(coords[${e}]), coords[${t}]) - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n          let dyR = (f32(dyRCorner) + f32(wR)) / f32(uniforms.stride.x);\n          let wRPerm = uniforms.filterDims.x - 1 - wR;\n          if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) || fract(dyR) > 0.0 ||\n              wRPerm < 0) {\n            continue;\n          }\n          let idyR = dyR;\n\n          for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n            let dyC = (f32(dyCCorner) + f32(wC)) / f32(uniforms.stride.y);\n            let wCPerm = uniforms.filterDims.y - 1 - wC;\n            if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n                fract(dyC) > 0.0 || wCPerm < 0) {\n              continue;\n            }\n            let idyC = dyC;\n\n            for (var d2 = 0; d2 < uniforms.outBackprop[3]; d2 = d2 + 1) {\n              if (${this.isChannelsLast}) {\n                let xValue = getDy(batch, idyR, idyC, d2);\n                let wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd = dotProd + xValue * wValue;\n              } else {\n                let xValue = getDy(batch, d2, idyR, idyC);\n                let wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd = dotProd + xValue * wValue;\n              }\n\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}const ls={kernelName:E,backendName:"webgpu",kernelFunc:function(e){const{inputs:r,backend:s,attrs:i}=e,{dy:a,filter:o}=r,{inputShape:u,strides:l,pad:h,dataFormat:d,dimRoundingMode:c}=i,p=n.convertConv2DDataFormat(d),f=n.computeConv2DInfo(u,o.shape,l,1,h,c,!1,p),m=[{type:"int32",data:[f.filterHeight,f.filterWidth]},{type:"int32",data:[f.filterHeight-1-f.padInfo.top,f.filterWidth-1-f.padInfo.left]},{type:"int32",data:[f.strideHeight,f.strideWidth]},{type:"int32",data:[f.batchSize,f.outHeight,f.outWidth,f.outChannels]}];let g;if(t().getBool("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE"))g=new us(f);else{g=new os(f);const e=f.inShape[1]*f.inShape[2],t=f.inShape[3],n=f.filterHeight*f.filterWidth*f.outChannels;m.push({type:"uint32",data:[e]},{type:"uint32",data:[t]},{type:"uint32",data:[n]})}return s.runWebGPUProgram(g,[a,o],"float32",m)}},hs={kernelName:B,backendName:"webgpu",kernelFunc:fn({opType:mt.COS})},ds={kernelName:N,backendName:"webgpu",kernelFunc:fn({opType:mt.COSH})};class cs{constructor(e,t,n,r){this.variableNames=["Image","Boxes","BoxInd"],this.uniforms="extrapolationValue : f32,",this.workGroupSize=[64,1,1],this.size=!0;const[s]=t;this.outputShape=[s,n[0],n[1],e],this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.methodId="bilinear"===r?1:0,this.cropHeightBiggerThan1=this.outputShape[1]>1,this.cropWidthBiggerThan1=this.outputShape[2]>1,this.shaderKey=`cropAndResize_${this.methodId}_${this.cropHeightBiggerThan1}_${this.cropWidthBiggerThan1}`}getUserCode(){const[e,t]=["f32(uniforms.imageShape[1] - 1)","f32(uniforms.imageShape[2] - 1)"],[n,r,s]=this.cropHeightBiggerThan1?[`(${e} / f32(uniforms.outShape[1] - 1))`,"(y2-y1) * height_ratio",`y1*${e} + f32(y)*(height_scale)`]:["0.0","0.0",`0.5 * (y1+y2) * ${e}`],[i,a,o]=this.cropWidthBiggerThan1?[`(${t} / f32(uniforms.outShape[2] - 1))`,"(x2-x1) * width_ratio",`x1*${t} + f32(x)*(width_scale)`]:["0.0","0.0",`0.5 * (x1+x2) * ${t}`];return`\n      ${vt()}\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let height_ratio = f32(${n});\n        let width_ratio = f32(${i});\n        let b = coords[0];\n        let y = coords[1];\n        let x = coords[2];\n        let d = coords[3];\n        // get box vals\n        let y1 = getBoxes(b, 0);\n        let x1 = getBoxes(b, 1);\n        let y2 = getBoxes(b, 2);\n        let x2 = getBoxes(b, 3);\n        // get image in batch index\n        let bInd = i32(round(getBoxInd(b)));\n        if(bInd < 0 || bInd >= uniforms.outShape[0]) {\n          return;\n        }\n        let height_scale = ${r};\n        let width_scale = ${a};\n        let in_y = ${s};\n        if( in_y < 0.0 || in_y > ${e} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let in_x = ${o};\n        if( in_x < 0.0 || in_x > ${t} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let sourceFracIndexCR = vec2<f32>(in_x,in_y);\n        if(${this.methodId} == 1) {\n          // Compute the four integer indices.\n          let sourceFloorCR = vec2<i32>(sourceFracIndexCR);\n          let sourceCeilCR = vec2<i32>(ceil(sourceFracIndexCR));\n          let topLeft = getImage(bInd, sourceFloorCR.y, sourceFloorCR.x, d);\n          let bottomLeft = getImage(bInd, sourceCeilCR.y, sourceFloorCR.x, d);\n          let topRight = getImage(bInd, sourceFloorCR.y, sourceCeilCR.x, d);\n          let bottomRight = getImage(bInd, sourceCeilCR.y, sourceCeilCR.x, d);\n          let fracCR = sourceFracIndexCR - vec2<f32>(sourceFloorCR);\n          let top = topLeft + (topRight - topLeft) * fracCR.x;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          let newValue = top + (bottom - top) * fracCR.y;\n          setOutputAtIndex(index, newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          let sourceNearestCR = vec2<i32>(floor(\n            sourceFracIndexCR + vec2<f32>(0.5,0.5)));\n          let newValue = getImage(\n            bInd, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    }\n    `}}const ps={kernelName:_,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n,attrs:r}=e,{image:s,boxes:i,boxInd:a}=t,{cropSize:o,method:u,extrapolationValue:l}=r,h=new cs(s.shape[3],i.shape,o,u),d=[{type:"float32",data:[l]}];return n.runWebGPUProgram(h,[s,i,a],"float32",d)}};var fs;!function(e){e.Prod="*",e.Sum="+"}(fs||(fs={}));class ms{constructor(e,t,n,r){this.variableNames=["x"],this.uniforms="index : f32,",this.size=!0;this.workGroupSize=[128,1,1],this.outputShape=t,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.exclusive=n,this.reverse=r,this.op=e,this.shaderKey=`cum_${this.op}_${this.exclusive}_${this.reverse}`}getUserCode(){const e=this.outputShape.length,t=this.op===fs.Prod?"1.0":"0.0",n=this.exclusive?t:`getX(${gs(e,"coords",this.op)})`,r=this.outputShape[this.outputShape.length-1];let s="",i="";return this.exclusive?(s=this.reverse?"end != "+(r-1):"end != 0",i=this.reverse?"end + 1":"end - 1"):(s=this.reverse?`end + pow2 < ${r}`:"end >= pow2",i=this.reverse?"end + pow2":"end - pow2"),`\n      ${vt()}\n       if (index < uniforms.size) {\n         var coords = getCoordsFromIndex(index);\n\n         let end = ${bs(e,"coords",this.op)};\n         var val = ${n};\n         let pow2 = i32(pow(2.0, uniforms.index));\n         if (${s}) {\n           let idx = ${i};\n           ${bs(e,"coords",this.op)} = idx;\n           val ${this.op}= getX(${gs(e,"coords",this.op)});\n         }\n         setOutputAtIndex(index, val);\n       }\n      }\n    `}}function gs(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.x, ${t}.y`;if(3===e)return`${t}.x, ${t}.y, ${t}.z`;if(4===e)return`${t}.x, ${t}.y, ${t}.z, ${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function bs(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.y`;if(3===e)return`${t}.z`;if(4===e)return`${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function xs(e,t,r,s,i,a){const o=t.shape.length,u=n.getAxesPermutation([s],o);let l=t;null!=u&&(l=zr({inputs:{x:t},backend:r,attrs:{perm:u}}));const h=n.getInnerMostAxes(1,o)[0];if(h!==o-1)throw new Error(`WebGPU cumprod shader expects an inner-most axis=${t.shape.length-1} but got axis=${s}`);const d=l.shape[h];let c=ln({inputs:{x:l},backend:r});for(let t=0;t<=Math.ceil(Math.log2(d))-1;t++){const n=new ms(e,l.shape,!1,a),s=c,i=[{type:"float32",data:[t]}];c=r.runWebGPUProgram(n,[c],c.dtype,i),r.disposeData(s.dataId)}if(i){const t=new ms(e,l.shape,i,a),n=c,s=[{type:"float32",data:[0]}];c=r.runWebGPUProgram(t,[c],c.dtype,s),r.disposeData(n.dataId)}if(null!=u){const e=zr({inputs:{x:c},backend:r,attrs:{perm:n.getUndoAxesPermutation(u)}});return r.disposeData(c.dataId),r.disposeData(l.dataId),e}return c}const ws={kernelName:O,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{axis:i,exclusive:a,reverse:o}=r;return xs(fs.Prod,s,n,i,a,o)}};const Is={kernelName:F,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{axis:i,exclusive:a,reverse:o}=r;return xs(fs.Sum,s,n,i,a,o)}};class ys{constructor(e,t){this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.uniforms="blockSize : i32,",this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`depthToSpace_${t}`,this.dataFormat=t}getUserCode(){return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let h = ${this.getHeightCoordString()};\n          let w = ${this.getWidthCoordString()};\n          let d = ${this.getDepthCoordString()};\n\n          let in_h = h / uniforms.blockSize;\n          let offset_h = h % uniforms.blockSize;\n          let in_w = w / uniforms.blockSize;\n          let offset_w = w % uniforms.blockSize;\n          let offset_d = (offset_h * uniforms.blockSize + offset_w) *\n            ${this.getOutputDepthSize()};\n          let in_d = d + offset_d;\n\n          let rlt = ${this.getInputSamplingString()};\n          setOutputAtIndex(index, rlt);\n        }\n      }`}getHeightCoordString(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"}getWidthCoordString(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"}getDepthCoordString(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"}getOutputDepthSize(){return"NHWC"===this.dataFormat?"uniforms.outShape[3]":"uniforms.outShape[1]"}getInputSamplingString(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"}}const ks={kernelName:G,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{blockSize:i,dataFormat:a}=r,o=s.shape[0],u=("NHWC"===a?s.shape[1]:s.shape[2])*i,l=("NHWC"===a?s.shape[2]:s.shape[3])*i,h=("NHWC"===a?s.shape[3]:s.shape[1])/(i*i),d=[{type:"int32",data:[i]}],c=new ys("NHWC"===a?[o,u,l,h]:[o,h,u,l],a);return n.runWebGPUProgram(c,[s],s.dtype,d)}};class Ss{constructor(e,t,n,r=!1,s=null,i=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, inDims : vec2<i32>,",this.workGroupSize=[16,16,1],this.outputShape=e,this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),r&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.addBias=r,this.activation=s,this.hasPreluActivation=i,this.filterHeight=t,this.filterWidth=n,this.shaderKey=`depthwiseNCHW_${this.activation}_${this.filterHeight}_${this.filterWidth}`}getUserCode(){const e=this.filterWidth*this.filterHeight,t=this.workGroupSize[0]*this.workGroupSize[1]*this.workGroupSize[2],n=this.workGroupSize[1]+this.filterHeight-1,r=this.workGroupSize[0]+this.filterWidth-1;return`\n      ${xt(this.activation,this.hasPreluActivation,!1,4)}\n\n      var<workgroup> mm_Asub : array<array<f32, ${r}>, ${n}>;\n      var<workgroup> mm_Bsub : array<array<f32, ${this.filterWidth}>, ${this.filterHeight}>;\n      fn readX(batch : i32, channel : i32, row : i32, col : i32) -> f32 {\n        var value = 0.0;\n        if (row >=0 && row < uniforms.inDims[0] && col >=0 && col < uniforms.inDims[1])\n        {\n          value = getX(batch, channel, row, col);\n        }\n        return value;\n      }\n\n      \n  @compute @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(local_invocation_id) LocalId : vec3<u32>,\n              @builtin(global_invocation_id) GlobalId : vec3<u32>,\n              @builtin(local_invocation_index) LocalIndex: u32,\n              @builtin(num_workgroups) NumWorkgroups: vec3<u32>) {\n        localId = LocalId;\n        globalId = GlobalId;\n        let localIndex = i32(LocalIndex);\n        numWorkgroups = NumWorkgroups;\n        let coords = getOutputCoords();\n        let batch = coords[0];\n        let xRCCorner = vec2<i32>(coords.zw) - uniforms.pad;\n        let channelMul = uniforms.wShape[3];\n        let d1 = coords[1] / channelMul;\n        let q = coords[1] % channelMul;\n\n        let inputRowStart = xRCCorner.x;\n        let inputColStart = xRCCorner.y;\n\n        let localRow = i32(localId.y);\n        let localCol = i32(localId.x);\n\n        // Load one tile of X into local memory.\n        for (var inputRow = localRow; inputRow < ${n}; inputRow = inputRow + ${this.workGroupSize[1]}) {\n          for (var inputCol = localCol; inputCol < ${r}; inputCol = inputCol + ${this.workGroupSize[0]}) {\n            let rowOffset = inputRow - localRow;\n            let colOffset = inputCol - localCol;\n            mm_Asub[inputRow][inputCol] = readX(batch, d1, inputRowStart + rowOffset, inputColStart + colOffset);\n          }\n        }\n\n        // Load one tile of W into local memory.\n        var wIndex = localIndex;\n        ${e<t?`if (wIndex < ${e})`:`for(; wIndex < ${e}; wIndex = wIndex + ${t})`}\n\n        {\n          let wRow = wIndex / ${this.filterWidth};\n          let wCol = wIndex % ${this.filterWidth};\n          mm_Bsub[wRow][wCol] = getW(wRow, wCol, d1, q);\n        }\n\n        workgroupBarrier();\n\n        var value = 0.0;\n        for (var wR = 0; wR < ${this.filterHeight}; wR = wR + 1) {\n          for (var wC = 0; wC < ${this.filterWidth}; wC = wC + 1) {\n            let xVal = mm_Asub[localRow + wR][localCol + wC];\n            let wVal = mm_Bsub[wR][wC];\n            value = fma(xVal, wVal, value);\n          }\n        }\n        ${wt(this.addBias,this.activation)}\n        if (coordsInBounds4D(coords, uniforms.outShape)) {\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }\n    `}}class vs{constructor(e,t=!1,n=null,s=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, inDims : vec2<i32>,",this.workGroupSize=[4,4,4],this.isVec4=!0,this.outputShape=e.outShape,this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[4,4,1]),r.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),t&&this.variableNames.push("bias"),s&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivation=s,this.shaderKey=`depthwiseVec4_${n}_${this.convInfo.filterHeight}_${this.convInfo.filterWidth}`}getUserCode(){const e=4+this.convInfo.filterWidth-1;return`\n      ${xt(this.activation,this.hasPreluActivation,!0,4)}\n      fn readX(batch : i32, row : i32, col : i32, channel : i32) -> vec4<f32> {\n        var value = vec4<f32>(0.0);\n        if (row >=0 && row < uniforms.inDims[0] && col >=0 && col < uniforms.inDims[1])\n        {\n          value = getX(batch, row, col, channel);\n        }\n        return value;\n      }\n      \n  @compute @workgroup_size(workGroupSizeX, workGroupSizeY, workGroupSizeZ)\n\n      fn main(@builtin(global_invocation_id) globalId: vec3<u32>) {\n        let batch = i32(globalId.z) / uniforms.outShape[1];\n        let r = i32(globalId.z) % uniforms.outShape[1];\n        let c = i32(globalId.y) * 4;\n        let d1 = i32(globalId.x) * 4;\n        let xRCCorner = vec2<i32>(r, c) - uniforms.pad;\n\n        let xRCorner = xRCCorner.x;\n        let xCCorner = xRCCorner.y;\n        var xVals : array<vec4<f32>, ${e}>;\n        var dotProd : array<vec4<f32>, 4>;\n        dotProd[0] = vec4<f32>(0.0);\n        dotProd[1] = vec4<f32>(0.0);\n        dotProd[2] = vec4<f32>(0.0);\n        dotProd[3] = vec4<f32>(0.0);\n\n        // Use constant instead of uniform can give better performance.\n        for (var wR = 0; wR < ${this.convInfo.filterHeight}; wR = wR + 1) {\n          let xR = xRCorner + wR;\n          for (var i = 0; i < ${e}; i++)\n          {\n            xVals[i] = readX(batch, xR, xCCorner + i, d1);\n          }\n          for (var wC = 0; wC < ${this.convInfo.filterWidth}; wC = wC + 1) {\n            let wValue = getW(wR, wC, d1, 0);\n            dotProd[0] = dotProd[0] + xVals[0 + wC] * wValue;\n            dotProd[1] = dotProd[1] + xVals[1 + wC] * wValue;\n            dotProd[2] = dotProd[2] + xVals[2 + wC] * wValue;\n            dotProd[3] = dotProd[3] + xVals[3 + wC] * wValue;\n          }\n        }\n\n        for (var i = 0; i < 4; i = i + 1) {\n          let coords = vec4<i32>(batch, r, c + i, d1);\n          if (coordsInBounds4D(coords, uniforms.outShape)) {\n            var value = dotProd[i];\n            ${wt(this.addBias,this.activation)}\n            setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n          }\n        }\n      }\n    `}}class Cs{constructor(e,t=!1,n=null,r=!1){this.variableNames=["x","W"],this.uniforms="pad : vec2<i32>, inDims : vec2<i32>, filterHeight : i32,\n      filterWidth : i32, stride : vec2<i32>, dilation : vec2<i32>,",this.workGroupSize=[256,1,1],this.outputShape=e.outShape,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,t&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivation=r,this.shaderKey=`depthwise_${this.activation}_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?"getX(batch, xR, xC, d1);":"getX(batch, d1, xR, xC);";return`\n      ${xt(this.activation,this.hasPreluActivation,!1,4)}\n\n      ${Ct()}\n        let coords = getOutputCoords();\n        let batch = coords[0];\n        let xRCCorner = vec2<i32>(coords.${this.isChannelsLast?"yz":"zw"}) * uniforms.stride - uniforms.pad;\n        let d2 = coords[${this.isChannelsLast?3:1}];\n        let channelMul = uniforms.wShape[3];\n        let d1 = d2 / channelMul;\n        let q = d2 % channelMul;\n\n        let inputRowStart = xRCCorner.x;\n        let inputColStart = xRCCorner.y;\n        let inputRowEnd = inputRowStart + uniforms.filterHeight *\n            uniforms.dilation[0];\n        let inputColEnd = inputColStart + uniforms.filterWidth *\n            uniforms.dilation[1];\n\n        // Convolve x(?, ?, d1)|x(d1, ?, ?) with w(:, :, d1, q) to get\n        // y(yR, yC, d2)|y(d2, yR, yC). ? = to be determined. : = across all\n        // values in that axis. x(?, ?, d1) and y(yR, yC, d2) is for NHWC.\n        // x(d1, ?, ?) and y(d2, yR, yC) is for NCHW.\n        var value = 0.0;\n\n        // Extract if checking out of for loop for performance.\n        if (inputRowStart >= 0 && inputColStart >= 0 &&\n          inputRowEnd < uniforms.inDims[0] &&\n              inputColEnd < uniforms.inDims[1]) {\n            for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n              let xR = inputRowStart + wR * uniforms.dilation[0];\n\n              for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                let xC = inputColStart + wC * uniforms.dilation[1];\n\n                let xVal = ${e};\n                let wVal = getW(wR, wC, d1, q);\n                value = value + xVal * wVal;\n              }\n            }\n          } else {\n            for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n              let xR = inputRowStart + wR * uniforms.dilation[0];\n\n              if (xR < 0 || xR >= uniforms.inDims[0]) {\n                continue;\n              }\n\n              for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                let xC = inputColStart + wC * uniforms.dilation[1];\n\n                if (xC < 0 || xC >= uniforms.inDims[1]) {\n                  continue;\n                }\n\n                let xVal = ${e};\n                let wVal = getW(wR, wC, d1, q);\n                value = value + xVal * wVal;\n              }\n            }\n          }\n          ${wt(this.addBias,this.activation)}\n        if (coordsInBounds4D(coords, uniforms.outShape)) {\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }\n    `}}const $s={kernelName:U,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:i,filter:a}=t,{strides:o,pad:u,dataFormat:l,dilations:h,dimRoundingMode:d}=s,c=n.convertConv2DDataFormat(l);let p=h;null==p&&(p=[1,1]);const f=n.computeConv2DInfo(i.shape,a.shape,o,p,u,d,!0,c),m=[{type:"int32",data:[f.padInfo.top,f.padInfo.left]},{type:"int32",data:[f.inHeight,f.inWidth]}],g="channelsLast"===f.dataFormat;let b;return!g&&f.inHeight>16&&f.inWidth>16&&1===f.strideHeight&&1===f.strideWidth&&1===f.dilationWidth&&1===f.dilationHeight&&f.inChannels===f.outChannels?b=new Ss(f.outShape,f.filterHeight,f.filterWidth):g&&f.inHeight>4&&f.inWidth>4&&1===f.strideHeight&&1===f.strideWidth&&f.inChannels===f.outChannels&&1===f.dilationHeight&&1===f.dilationWidth&&f.inChannels%4==0?b=new vs(f):(b=new Cs(f),m.push({type:"int32",data:[f.filterHeight]},{type:"int32",data:[f.filterWidth]},{type:"int32",data:[f.strideHeight,f.strideWidth]},{type:"int32",data:[f.dilationHeight,f.dilationWidth]})),r.runWebGPUProgram(b,[i,a],i.dtype,m)}},Rs=mn({opType:ht.MUL,cpuKernelImpl:ar,supportsComplex:!0}),As={kernelName:L,backendName:"webgpu",kernelFunc:Rs};class zs{constructor(e,t){this.workGroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="reduceSize : i32,",this.size=!0,this.inputShape=[e.batchSize,e.inSize];const[r]=n.computeOutAndReduceShapes(this.inputShape,[1]);this.outputShape=0===r.length?[1]:r,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,[1,1,1]),this.reduceType=t,this.shaderKey=`reduce_${t}`}getUserCode(){let e="",t="0.0";"min"===this.reduceType||"max"===this.reduceType?(e=`\n         if (isnan(candidate)) {\n          bestValue = uniforms.NAN;\n         } else if (!isnan(bestValue) && candidate ${"min"===this.reduceType?"<":">"} bestValue)\n           {  bestValue = candidate; }`,t="f32(x[offset])"):"sum"===this.reduceType||"mean"===this.reduceType?e=" bestValue = bestValue + candidate; ":"prod"===this.reduceType&&(e=" bestValue = bestValue * candidate; ",t="1.0");const n="mean"===this.reduceType?"setOutputAtIndex(outputIndex, bestValue / f32(uniforms.reduceSize));":"setOutputAtIndex(outputIndex, bestValue);";return`\n       fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n       }\n\n       ${`\n         var<workgroup> xBestValues : array<f32, ${this.workGroupSize[0]}>;\n       `}\n       fn getOffset(outputIndex : i32) -> i32 {\n         let outputCoords = getCoordsFromIndex(outputIndex);\n         let offset = ${1===this.outputShape.length?"outputCoords":"outputCoords[0]"} * uniforms.reduceSize;\n          return offset;\n       }\n       ${vt()}\n         let outputIndex = index / i32(workGroupSizeX);\n         let offset = getOffset(outputIndex);\n         var bestValue = ${t};\n         let Length = uniforms.reduceSize;\n         let WorkPerThread = DIV_CEIL(u32(Length), workGroupSizeX);\n         for (var k = i32(localId.x); k < Length && outputIndex < uniforms.size;\n             k = k + i32(workGroupSizeX)) {\n           let candidate = f32(x[offset + k]);\n           ${e}\n         }\n         xBestValues[localId.x] = bestValue;\n         workgroupBarrier();\n\n         var reduceSize = min(u32(Length), workGroupSizeX);\n         for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n             currentSize = reduceSize / 2u) {\n           let interval = DIV_CEIL(reduceSize, 2u);\n           if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            ${e}\n            xBestValues[localId.x] = bestValue;\n           }\n           reduceSize = interval;\n           workgroupBarrier();\n         }\n\n         if (localId.x == 0u && outputIndex < uniforms.size) {\n          ${n}\n        }\n       }\n     `}}function Ps(e,t,s,i,a){const o=e.shape.length,u=[],l=r.parseAxisParam(t,e.shape);let h=l;const d=n.getAxesPermutation(h,o);let c=e;null!=d&&(c=zr({inputs:{x:e},attrs:{perm:d},backend:a}),h=n.getInnerMostAxes(h.length,o),u.push(c)),n.assertAxesAreInnerMostDims(i,h,o);const[p,f]=n.computeOutAndReduceShapes(c.shape,h);let m,g=p;if(s&&(g=n.expandShapeToKeepDim(p,l)),"max"!==i&&"prod"!==i||!a.shouldExecuteOnCPU([c])){const t=r.sizeFromShape(f),n={windowSize:t,inSize:t,batchSize:r.sizeFromShape(c.shape)/t,outSize:1},s="mean"===i?"float32":M(e.dtype),o=[{type:"int32",data:[t]}],l=new zs(n,i),h=a.runWebGPUProgram(l,[c],s,o);u.push(h),m=nn({inputs:{x:h},attrs:{shape:g},backend:a})}else{const t=a.tensorMap.get(c.dataId).values;switch(i){case"max":const n=rr(t,r.sizeFromShape(f),g,e.dtype);m=a.makeTensorInfo(g,e.dtype,n);break;case"prod":const{outVals:s,outShape:o,outDtype:u}=lr(c.shape,c.dtype,t,h);m=a.makeTensorInfo(o,u,s);break;default:throw new Error(`${i} CPU implementation is not yet supported.`)}}return u.forEach((e=>a.disposeData(e.dataId))),m}function Ts(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{axis:i,keepDims:a}=r;return Ps(s,i,a,"sum",n)}const Es={kernelName:D,backendName:"webgpu",kernelFunc:Ts};const Bs={kernelName:W,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{equation:a}=i,o=t,{allDims:u,summedDims:l,idDims:h}=n.decodeEinsumEquation(a,o.length);n.checkEinsumDimSizes(u.length,h,o);const{path:d,steps:c}=n.getEinsumComputePath(l,h),p=c.length;let f=null,m=u.length;const g=[];for(let e=0;e<p;++e){for(const t of c[e]){const{permutationIndices:e,expandDims:i}=n.getEinsumPermutation(m,h[t]);let a;n.isIdentityPermutation(e)?a=o[t]:(a=zr({inputs:{x:o[t]},backend:s,attrs:{perm:e}}),g.push(a));const u=a.shape.slice();for(let e=0;e<i.length;++e)u.splice(i[e],0,1);r.arraysEqual(a.shape,u)||(a=nn({inputs:{x:a},backend:s,attrs:{shape:u}}),g.push(a)),null===f?f=a:(f=Rs({inputs:{a:a,b:f},backend:s}),g.push(f))}e<p-1&&(d[e]>=0&&(f=Ts({inputs:{x:f},backend:s,attrs:{axis:d[e]-(u.length-m),keepDims:!1}}),g.push(f)),m--)}for(const e of g)e!==f&&s.disposeData(e.dataId);return f}},Ns={kernelName:V,backendName:"webgpu",kernelFunc:fn({opType:mt.ELU})},_s={kernelName:H,backendName:"webgpu",kernelFunc:mn({opType:ht.EQUAL,dtype:"bool",cpuKernelImpl:Xn})},Os=fn({opType:mt.EXP,cpuKernelImpl:qn,dtype:"float32"}),Fs={kernelName:X,backendName:"webgpu",kernelFunc:Os};function Gs(e){const{inputs:t,attrs:n,backend:s}=e,{dim:i}=n,{input:a}=t,o=a.shape.length,u=a.shape.slice();let l=i;return i<0&&(r.assert(-(o+1)<=i,(()=>`Axis must be in the interval [${-(o+1)}, ${o}]`)),l=o+i+1),u.splice(l,0,1),nn({inputs:{x:a},backend:s,attrs:{shape:u}})}const Us={kernelName:q,backendName:"webgpu",kernelFunc:Gs},Ls={kernelName:K,backendName:"webgpu",kernelFunc:fn({opType:mt.EXPM1,cpuKernelImpl:Kn})};class Ms{constructor(e){this.outputShape=[],this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="flipLeftRight"}getUserCode(){return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let coordX = uniforms.xShape[2] - coords[2] - 1;\n          let outputValue = getX(coords[0], coords[1], coordX, coords[3]);\n          setOutputAtIndex(index, outputValue);\n        }\n      }\n    `}}const Ds={kernelName:Y,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{image:n}=e,r=t,s=new Ms(n.shape);return r.runWebGPUProgram(s,[n],n.dtype)}},Ws={kernelName:j,backendName:"webgpu",kernelFunc:fn({opType:mt.FLOOR,cpuKernelImpl:Yn})},Vs={kernelName:Q,backendName:"webgpu",kernelFunc:mn({opType:ht.INT_DIV,dtype:"int32"})};class Hs{constructor(e,t,n=!1){this.isFromPixels=!0,this.outputShape=[0],this.variableNames=[],this.workGroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[t,1,1]),this.importVideo=n,this.shaderKey=`fromPixels_${this.importVideo}`}getUserCode(){const e=this.importVideo?"textureLoad(src, vec2<i32>(coords.yx));":"textureLoad(src, vec2<i32>(coords.yx), 0)";return`\n      @binding(1) @group(0) var src: ${this.importVideo?"texture_external":"texture_2d<f32>"};\n      ${vt()}\n        let flatIndex = index * uniforms.numChannels;\n        if (flatIndex < uniforms.size) {\n          let coords = getCoordsFromIndex(flatIndex);\n          let values = ${e};\n          for (var i = 0; i < uniforms.numChannels; i = i + 1) {\n            result[flatIndex + i] = i32(floor(255.0 * values[i]));\n          }\n        }\n      }\n  `}}const Xs={kernelName:Z,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:s,attrs:i}=e;let{pixels:a}=n;const{numChannels:o}=i;if(null==a)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");const u="undefined"!=typeof HTMLVideoElement&&a instanceof HTMLVideoElement,l="undefined"!=typeof HTMLImageElement&&a instanceof HTMLImageElement,h="undefined"!=typeof HTMLCanvasElement&&a instanceof HTMLCanvasElement||"undefined"!=typeof OffscreenCanvas&&a instanceof OffscreenCanvas,d="undefined"!=typeof ImageBitmap&&a instanceof ImageBitmap,[c,p]=u?[a.videoWidth,a.videoHeight]:[a.width,a.height],f=[p,c,o],m=t().getBool("WEBGPU_IMPORT_EXTERNAL_TEXTURE")&&u,g=u||l;if(d||h||g){let e;if(m){const t=a;if(!Ks.has(t)||Ks.get(t).expired){const e={source:t};Ks.set(t,s.device.importExternalTexture(e))}e={width:c,height:p,format:null,usage:null,texture:Ks.get(t)}}else{g&&(null==qs&&(qs=document.createElement("canvas").getContext("2d")),qs.canvas.width=c,qs.canvas.height=p,qs.drawImage(a,0,0,c,p),a=qs.canvas);const t=GPUTextureUsage.COPY_DST|GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.TEXTURE_BINDING,n="rgba8unorm",r=s.textureManager.acquireTexture(f[1],f[0],n,t);s.queue.copyExternalImageToTexture({source:a},{texture:r},[f[1],f[0]]),e={width:c,height:p,format:n,usage:t,texture:r}}const t=r.sizeFromShape(f),n=r.computeStrides(f),i=new Hs(f,o,m),u=[{type:"uint32",data:[t]},{type:"uint32",data:[o]},{type:"uint32",data:[...n]}],l=s.makeTensorInfo([p,c],"int32");s.tensorMap.get(l.dataId).resourceInfo=e;const h=s.runWebGPUProgram(i,[l],"int32",u);return s.disposeData(l.dataId),h}const b=a.data;let x=b;if(null!=o&&4!==o){x=new Uint8Array(a.width*a.height*o);const e=b.length;let t=0;for(let n=0;n<e;n++)n%4<o&&(x[t++]=b[n])}const w=s.makeTensorInfo(f,"int32",new Int32Array(x));return s.uploadToGPU(w.dataId),w}};let qs;const Ks=new Map;class Ys{constructor(e,t,r,s,i){this.uniforms="varianceEpsilon : f32,",this.workGroupSize=[128,1,1],this.size=!0,this.variableNames=["x","mean","variance"],n.assertAndGetBroadcastShape(e,t),n.assertAndGetBroadcastShape(e,r),this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),null!=s&&(n.assertAndGetBroadcastShape(e,s),this.variableNames.push("offset")),null!=i&&(n.assertAndGetBroadcastShape(e,i),this.variableNames.push("scale")),this.offsetShape=s,this.scaleShape=i,this.shaderKey="batchNorm"}getUserCode(){let e="0.0";null!=this.offsetShape&&(e="getOffsetByOutputIndex(index)");let t="1.0";null!=this.scaleShape&&(t="getScaleByOutputIndex(index)");return`\n      ${vt()}\n        if (index < uniforms.size)\n        {\n          let xValue = getXByOutputIndex(index);\n          let meanValue = getMeanByOutputIndex(index);\n          let varianValue = getVarianceByOutputIndex(index);\n          let offsetValue = ${e};\n          let scaleValue = ${t};\n          let inv = scaleValue * inverseSqrt(varianValue + f32(uniforms.varianceEpsilon));\n          setOutputAtIndex(index,dot(vec3<f32>(xValue, -meanValue, offsetValue), vec3<f32>(inv, inv, 1.0)));\n        }\n      }\n  `}}const js={kernelName:J,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:r,scale:s,offset:i,mean:a,variance:o}=e,{varianceEpsilon:u}=t,l=n,h=[r,a,o];let d=null;null!=i&&(d=i.shape,h.push(i));let c=null;null!=s&&(c=s.shape,h.push(s));const p=new Ys(r.shape,a.shape,o.shape,d,c),f=[{type:"float32",data:[u]}];return l.runWebGPUProgram(p,h,r.dtype,f)}};const Qs={kernelName:ee,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:i,filter:a,bias:o,preluActivationWeights:u}=t,{strides:l,pad:h,dataFormat:d,dilations:c,dimRoundingMode:p,activation:f,leakyreluAlpha:m}=s,g=n.convertConv2DDataFormat(d);return is({x:i,filter:a,convInfo:n.computeConv2DInfo(i.shape,a.shape,l,c,h,p,!1,g),backend:r,bias:o,preluActivationWeights:u,leakyreluAlpha:m,activation:f})}};const Zs={kernelName:te,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{x:a,filter:o,bias:u,preluActivationWeights:l}=t,{strides:h,pad:d,dilations:c,dimRoundingMode:p,activation:f,leakyreluAlpha:m}=i;let g=c;null==g&&(g=[1,1]),r.assert(n.eitherStridesOrDilationsAreOne(h,g),(()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${h} and dilations '${g}'`));const b=n.computeConv2DInfo(a.shape,o.shape,h,g,d,p,!0),x=[a,o],w=null!=u,I=null!=l;w&&x.push(u),I&&x.push(l);const y=[{type:"int32",data:[b.padInfo.top,b.padInfo.left]},{type:"int32",data:[b.inHeight,b.inWidth]}];let k;return b.inHeight>4&&b.inWidth>4&&1===b.strideHeight&&1===b.strideWidth&&b.inChannels===b.outChannels&&1===b.dilationHeight&&1===b.dilationWidth&&b.inChannels%4==0?k=new vs(b,w,f,I):(k=new Cs(b,w,f,I),y.push({type:"int32",data:[b.filterHeight]},{type:"int32",data:[b.filterWidth]},{type:"int32",data:[b.strideHeight,b.strideWidth]},{type:"int32",data:[b.dilationHeight,b.dilationWidth]})),"leakyrelu"===f&&(y.push({type:"float32",data:[m]}),k.uniforms+=" alpha : f32,"),s.runWebGPUProgram(k,x,"float32",y)}};class Js{constructor(e,t){this.variableNames=["A","indices"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey=`gathernd_${e}`,this.sliceDim=e,this.uniforms=`sliceDim : i32, strides : ${kt(e)},`}getUserCode(){let e;e=this.sliceDim>1?"uniforms.strides[j]":"uniforms.strides";return`\n        ${vt()}\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          var flattenIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexTemp = i32(round(getIndices(coords[0], j)));\n            let strideNum = ${e};\n            flattenIndex = flattenIndex + indexTemp * strideNum;\n          }\n\n          setOutputAtIndex(index, getA(flattenIndex, coords[1]));\n        }\n      }\n      `}}const ei={kernelName:ne,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s}=e,{params:i,indices:a}=t,o=a.shape,u=o[o.length-1],l=r.sizeFromShape(i.shape),[h,d,c,p]=n.prepareAndValidate(i,a),f=nn({inputs:{x:a},backend:s,attrs:{shape:[d,u]}}),m=nn({inputs:{x:i},backend:s,attrs:{shape:[r.sizeFromShape(i.shape)/c,c]}});if(s.shouldExecuteOnCPU([i,a])||"string"===i.dtype){const e=s.readSync(a.dataId),t=s.bufferSync(i),n=jn(e,t,i.dtype,d,u,c,p,i.shape,l);return s.makeTensorInfo(h,i.dtype,n.values)}const g=new Js(u,[d,c]),b=[{type:"int32",data:[u]},{type:"int32",data:p}],x=s.runWebGPUProgram(g,[m,f],m.dtype,b),w=nn({inputs:{x:x},backend:s,attrs:{shape:h}});return s.disposeData(f.dataId),s.disposeData(m.dataId),s.disposeData(x.dataId),w}};class ti{constructor(e,t){this.variableNames=["A","indices"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e.slice(),this.aShape=e,this.outputShape=t,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="gather"}getUserCode(){const e=function(e){const t=["resRC.x","resRC.y","resRC.z","resRC.w"],n=[];for(let r=0;r<e.length;r++)2===r?n.push("indexZ"):n.push(`${t[r]}`);return n.join()}(this.aShape);return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let indexZ = i32(getIndices(resRC.x, resRC.z));\n          let inBounds = select(0.0, 1.0, indexZ >= 0 && indexZ < uniforms.aShape[2]);\n          setOutputAtIndex(index, inBounds * getA(${e}));\n        }\n      }\n    `}}function ni(e){const{inputs:t,backend:s,attrs:i}=e,{x:a,indices:o}=t,{axis:u,batchDims:l}=i,h=r.parseAxisParam(u,a.shape)[0],c=n.segment_util.collectGatherOpShapeInfo(a,o,h,l),p=r.sizeFromShape(o.shape),f=[],m=nn({inputs:{x:a},backend:s,attrs:{shape:[c.batchSize,c.outerSize,c.dimSize,c.sliceSize]}}),g=nn({inputs:{x:o},backend:s,attrs:{shape:[c.batchSize,p/c.batchSize]}});f.push(m),f.push(g);const b=[c.batchSize,c.outerSize,p/c.batchSize,c.sliceSize];if(s.shouldExecuteOnCPU([a,o])){const e=s.tensorMap.get(g.dataId).values,t=d(g.shape,g.dtype,e),n=s.tensorMap.get(m.dataId).values,r=d(m.shape,m.dtype,n),i=Qn(r,t,b);return f.forEach((e=>s.disposeData(e.dataId))),s.makeTensorInfo(c.outputShape,i.dtype,i.values)}const x=new ti(m.shape,b),w=s.runWebGPUProgram(x,[m,g],m.dtype);f.push(w);const I=nn({inputs:{x:w},backend:s,attrs:{shape:c.outputShape}});return f.forEach((e=>s.disposeData(e.dataId))),I}const ri={kernelName:re,backendName:"webgpu",kernelFunc:ni},si={kernelName:se,backendName:"webgpu",kernelFunc:mn({opType:ht.GREATER,cpuKernelImpl:Jn,dtype:"bool"})},ii={kernelName:ie,backendName:"webgpu",kernelFunc:mn({opType:ht.GREATER_EQUAL,dtype:"bool",cpuKernelImpl:Zn})};const ai={kernelName:ae,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{alpha:i}=r,a=[{type:"float32",data:[i]}],o=new pn(s.shape,mt.LEAKYRELU);return o.uniforms="alpha : f32,",n.runWebGPUProgram(o,[s],"float32",a)}},oi={kernelName:oe,backendName:"webgpu",kernelFunc:mn({opType:ht.LESS,dtype:"bool",cpuKernelImpl:tr})},ui={kernelName:ue,backendName:"webgpu",kernelFunc:mn({opType:ht.LESS_EQUAL,dtype:"bool",cpuKernelImpl:er})},li={kernelName:le,backendName:"webgpu",kernelFunc:fn({opType:mt.LOG,cpuKernelImpl:nr})},hi={kernelName:he,backendName:"webgpu",kernelFunc:mn({opType:ht.LOGICAL_AND,dtype:"bool"})},di={kernelName:de,backendName:"webgpu",kernelFunc:fn({opType:mt.LOGICAL_NOT})};function ci(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{reductionIndices:i,keepDims:a}=r;return Ps(s,i,a,"max",n)}const pi={kernelName:ce,backendName:"webgpu",kernelFunc:ci},fi={kernelName:pe,backendName:"webgpu",kernelFunc:mn({opType:ht.MAX,cpuKernelImpl:sr})};const mi={kernelName:fe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{filterSize:o,strides:u,pad:l,dimRoundingMode:h}=i,d=n.computePool2DInfo(a.shape,o,u,1,l,h);let c;const p=[];if(1===d.filterHeight&&1===d.filterWidth){if(r.arraysEqual(d.inShape,d.outShape))return ln({inputs:{x:a},backend:s});c=new Nr(d),p.push({type:"int32",data:[d.strideHeight,d.strideWidth]})}else c=new Br(d,"max"),p.push({type:"int32",data:[d.strideHeight,d.strideWidth]},{type:"int32",data:[d.padInfo.top,d.padInfo.left]},{type:"int32",data:[d.dilationHeight,d.dilationWidth]},{type:"int32",data:[d.inHeight,d.inWidth]},{type:"int32",data:[d.effectiveFilterHeight,d.effectiveFilterWidth]});return s.runWebGPUProgram(c,[a],a.dtype,p)}};const gi={kernelName:me,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{keepDims:i,axis:a}=r;return Ps(s,a,i,"mean",n)}};const bi={kernelName:ge,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{axis:i,keepDims:a}=r;return Ps(s,i,a,"min",n)}},xi={kernelName:be,backendName:"webgpu",kernelFunc:mn({opType:ht.MIN,cpuKernelImpl:ir})};class wi{constructor(e,t,n){this.uniforms="",this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.xShape=e,t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.offset="reflect"===n?0:1,this.shaderKey=`mirrorPad_${n}`}getUserCode(){const e=this.xShape.length,t=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),n=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),r=1===e?"start":"start[i]",s=1===e?"end":"end[i]",i=1===e?"outC":"outC[i]",a=kt(e),o=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let start = ${a}(${t});\n          let end = ${a}(${n});\n          var outC = getCoordsFromIndex(index);\n          for (var i = 0; i < ${e}; i = i + 1) {\n            if (${i} < ${r}) {\n              ${i} = ${r} * 2 - ${i} - ${this.offset};\n            } else if(${i} >= ${s}) {\n              ${i} = (${s} - 1) * 2 - ${i} + ${this.offset};\n            }\n          }\n          let coords = outC - start;\n          setOutputAtIndex(index, getX(${o}));\n        }\n      }\n    `}}const Ii={kernelName:xe,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:r}=e,{paddings:s,mode:i}=t,a=n,o=s.map((e=>({type:"int32",data:[e[0],e[1]]}))),u=new wi(r.shape,s,i);return a.runWebGPUProgram(u,[r],r.dtype,o)}};const yi={kernelName:we,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:r}=t;if(n.shouldExecuteOnCPU([r])){const e=n.tensorMap.get(r.dataId),[t,s]=or(e.values,r.shape,r.dtype);return n.makeTensorInfo(s,r.dtype,t)}const s=new pn(r.shape,mt.NEG);return n.runWebGPUProgram(s,[r],r.dtype)}};const ki={kernelName:Ie,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:t,backend:n,attrs:r}=e,{boxes:s,scores:i}=t,{maxOutputSize:a,iouThreshold:o,scoreThreshold:u}=r,l=n.readSync(s.dataId),h=n.readSync(i.dataId),{selectedIndices:d}=ye.nonMaxSuppressionV3Impl(l,h,a,o,u);return n.makeTensorInfo([d.length],"int32",new Int32Array(d))}};const Si={kernelName:ke,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:t,backend:n,attrs:r}=e,{boxes:s,scores:i}=t,{maxOutputSize:a,iouThreshold:o,scoreThreshold:u,softNmsSigma:l}=r,h=n.readSync(s.dataId),d=n.readSync(i.dataId),c=a,p=o,f=u,m=l,{selectedIndices:g,selectedScores:b}=ye.nonMaxSuppressionV5Impl(h,d,c,p,f,m);return[n.makeTensorInfo([g.length],"int32",new Int32Array(g)),n.makeTensorInfo([b.length],"float32",new Float32Array(b))]}};function vi(e){const{inputs:t,backend:n}=e,{x:r}=t;if("complex64"===r.dtype){const e=Vr({inputs:{input:r},backend:n}),t=vi({inputs:{x:e},backend:n}),s=Zr({inputs:{input:r},backend:n}),i=vi({inputs:{x:s},backend:n}),a=dn({inputs:{real:t,imag:i},backend:n});return n.disposeData(e.dataId),n.disposeData(t.dataId),n.disposeData(s.dataId),n.disposeData(i.dataId),a}return en({attrs:{shape:r.shape,dtype:r.dtype,value:"string"===r.dtype?"":0},backend:n})}const Ci={kernelName:Se,backendName:"webgpu",kernelFunc:vi};const $i={kernelName:ve,backendName:"webgpu",kernelFunc:function e(t){const{inputs:n,backend:r}=t,{x:s}=n;if("string"===s.dtype)throw new Error("onesLike is not supported under string dtype");if("complex64"===s.dtype){const t=Vr({inputs:{input:s},backend:r}),n=e({inputs:{x:t},backend:r}),i=Zr({inputs:{input:s},backend:r}),a=vi({inputs:{x:i},backend:r}),o=dn({inputs:{real:n,imag:a},backend:r});return r.disposeData(t.dataId),r.disposeData(n.dataId),r.disposeData(i.dataId),r.disposeData(a.dataId),o}return en({attrs:{shape:s.shape,dtype:s.dtype,value:1},backend:r})}};const Ri={kernelName:Ce,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:s}=e,{axis:i}=s;if(1===t.length)return Gs({inputs:{input:t[0]},backend:n,attrs:{dim:i}});const a=t[0].shape,o=t[0].dtype;t.forEach((e=>{r.assertShapesMatch(a,e.shape,"All tensors passed to stack must have matching shapes"),r.assert(o===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const u=[],l=ts({inputs:t.map((e=>{const t=Gs({inputs:{input:e},backend:n,attrs:{dim:i}});return u.push(t),t})),backend:n,attrs:{axis:i}});return u.forEach((e=>n.disposeData(e.dataId))),l}};class Ai{constructor(e,t){this.variableNames=["x"],this.uniforms="constantValue : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.xShape=e,this.shaderKey="pad"}getUserCode(){const e=this.xShape.length,t=kt(e),n=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),r=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),s=e>1?`${t}(${n})`:`${n}`,i=e>1?`${t}(${r})`:`${r}`,a=e>1?"any(outC < start)":"outC < start",o=e>1?"any(outC >= end)":"outC >= end",u=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let start = ${s};\n          let end = ${i};\n          let outC = getCoordsFromIndex(index);\n\n          if (${a} || ${o}) {\n            setOutputAtIndex(index, uniforms.constantValue);\n          } else {\n            let coords = outC - start;\n            setOutputAtIndex(index, getX(${u}));\n          }\n        }\n      }\n    `}}const zi=e=>{const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{paddings:a,constantValue:o}=s;if(a.every((e=>r.arraysEqual(e,[0,0]))))return ln({inputs:{x:i},backend:n});if(0===r.sizeFromShape(i.shape)){return en({backend:n,attrs:{shape:a.map(((e,t)=>e[0]+i.shape[t]+e[1])),value:o,dtype:i.dtype}})}const u=[{type:"float32",data:[o]}];a.map((e=>u.push({type:"int32",data:[e[0],e[1]]})));const l=new Ai(i.shape,a);return n.runWebGPUProgram(l,[i],i.dtype,u)},Pi={kernelName:$e,backendName:"webgpu",kernelFunc:zi},Ti={kernelName:Re,backendName:"webgpu",kernelFunc:mn({opType:ht.POW})};const Ei={kernelName:Ae,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:r,alpha:s}=t,i=new un(ht.PRELU,r.shape,s.shape);return n.runWebGPUProgram(i,[r,s],"float32")}};const Bi={kernelName:ze,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{axis:i,keepDims:a}=r;return Ps(s,i,a,"prod",n)}},Ni={kernelName:Pe,backendName:"webgpu",kernelFunc:e=>{const{backend:t,attrs:n}=e,{start:r,stop:s,step:i,dtype:a}=n,o=hr(r,s,i,a);return t.makeTensorInfo([o.length],a,o)}},_i=mn({opType:ht.DIV}),Oi={kernelName:Te,backendName:"webgpu",kernelFunc:_i},Fi={kernelName:Ee,backendName:"webgpu",kernelFunc:fn({opType:mt.RELU})},Gi={kernelName:Be,backendName:"webgpu",kernelFunc:fn({opType:mt.RELU6})};class Ui{constructor(e,t,n){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, halfPixelCenters : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="resizeBilinear"}getUserCode(){return`\n      ${vt()}\n        if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC =\n            (vec2<f32>(rc) + vec2<f32>(uniforms.halfPixelCenters)) *\n            effectiveInputOverOutputRatioRC - vec2<f32>(uniforms.halfPixelCenters);\n\n          // Compute the four integer indices.\n          let sourceFloorRC = vec2<i32>(sourceFracIndexRC);\n          let sourceCeilRC = vec2<i32>(\n            min(vec2<f32>(uniforms.xShape.yz) - vec2<f32>(1.0), ceil(sourceFracIndexRC)));\n\n          let topLeft = getX(b, sourceFloorRC.x, sourceFloorRC.y, d);\n          let bottomLeft = getX(b, sourceCeilRC.x, sourceFloorRC.y, d);\n          let topRight = getX(b, sourceFloorRC.x, sourceCeilRC.y, d);\n          let bottomRight = getX(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n          let fracRC = sourceFracIndexRC - vec2<f32>(sourceFloorRC);\n\n          let top = topLeft + (topRight - topLeft) * fracRC.y;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n          let newValue = top + (bottom - top) * fracRC.x;\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const Li={kernelName:Ne,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{images:s}=t,{alignCorners:i,size:a,halfPixelCenters:o}=r,[u,l]=a,h=[{type:"float32",data:[i&&u>1?1:0,i&&l>1?1:0]},{type:"float32",data:[o?.5:0]}],d=new Ui(s.shape,u,l);return n.runWebGPUProgram(d,[s],"float32",h)}};class Mi{constructor(e,t,n,r){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, roundBase : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.halfPixelCenters=r,this.shaderKey=`resizeNearest_${r}`}getUserCode(){let e;e=this.halfPixelCenters?"max((vec2<f32>(rc) + vec2<f32>(0.5)) * effectiveInputOverOutputRatioRC, vec2<f32>(0.0))":"vec2<f32>(rc) * effectiveInputOverOutputRatioRC";return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC = ${e};\n\n          // Compute the coordinators of nearest neighbor point.\n          let inputShapeRC = vec2<f32>(f32(uniforms.xShape.y), f32(uniforms.xShape.z));\n          let sourceNearestRC = vec2<i32>(\n            min(inputShapeRC - 1.0, floor(sourceFracIndexRC + uniforms.roundBase)));\n          let newValue = getX(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const Di={kernelName:_e,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{images:s}=t,{alignCorners:i,halfPixelCenters:a,size:o}=r,[u,l]=o,h=[{type:"float32",data:[i&&u>1?1:0,i&&l>1?1:0]},{type:"float32",data:[i?.5:0]}],d=new Mi(s.shape,u,l,a);return n.runWebGPUProgram(d,[s],s.dtype,h)}};class Wi{constructor(e,t){this.outputShape=[],this.variableNames=["x"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="centerX : f32, centerY : f32, sinRadians : f32,\n          cosRadians : f32,",this.shaderKey="rotate",this.outputShape=e,"number"==typeof t?(this.uniforms+=" fillValue : f32,",this.fillSnippet="var outputValue = uniforms.fillValue;",this.shaderKey+="_float"):(this.uniforms+=" fillValue : vec3<f32>,",this.fillSnippet="var outputValue = uniforms.fillValue[coords[3]];",this.shaderKey+="_vec3")}getUserCode(){return`\n        ${vt()}\n\n          if (index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            let coordXFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.cosRadians - (f32(coords[1]) - uniforms.centerY) *\n                uniforms.sinRadians;\n            let coordYFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.sinRadians + (f32(coords[1]) - uniforms.centerY) *\n                uniforms.cosRadians;\n            let coordX = i32(round(coordXFloat + uniforms.centerX));\n            let coordY = i32(round(coordYFloat + uniforms.centerY));\n            ${this.fillSnippet}\n            if(coordX >= 0 && coordX < uniforms.xShape[2] && coordY >= 0 &&\n                coordY < uniforms.xShape[1]) {\n              outputValue = getX(coords[0], coordY, coordX, coords[3]);\n            }\n            setOutputAtIndex(index, outputValue);\n          }\n        }\n      `}}const Vi={kernelName:Oe,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:r})=>{const{image:s}=e,{radians:i,fillValue:a,center:o}=t,u=r,l=new Wi(s.shape,a),[h,d]=n.getImageCenter(o,s.shape[1],s.shape[2]),c=[{type:"float32",data:[h]},{type:"float32",data:[d]},{type:"float32",data:[Math.sin(i)]},{type:"float32",data:[Math.cos(i)]}];"number"==typeof a?c.push({type:"float32",data:[Number.parseFloat(a.toFixed(2))]}):c.push({type:"float32",data:a});return u.runWebGPUProgram(l,[s],s.dtype,c)}},Hi={kernelName:Fe,backendName:"webgpu",kernelFunc:fn({opType:mt.RSQRT,cpuKernelImpl:dr})};class Xi{constructor(e,t,n,r,s,i,a,o=!0){this.variableNames=["updates","indices"],this.workGroupSize=[64,1,1],this.atomic=!0,this.outputShape=i,this.type=a,this.sumDupeIndices=o,this.dispatchLayout=Ft(e),this.dispatch=Bt(this.dispatchLayout,e,this.workGroupSize),this.sliceDimGreaterThanOne=t>1,this.shaderKey=`scatter_${n}_${r}_${this.sliceDimGreaterThanOne}_${a}_${o}`;const u=kt(s.length);this.uniforms=`sliceDim : i32, strides: ${u}, size: i32,`,this.updatesRank=r,this.indicesRank=n}getUserCode(){let e="";1===this.indicesRank?e="coords[0]":2===this.indicesRank&&(e="coords[0], j");const t=`getIndices(${e})`,n=this.sliceDimGreaterThanOne?"uniforms.strides[j]":"uniforms.strides";let r="",s="";1===this.dispatchLayout.x.length?(r="flattenedIndex",s="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> i32 {\n        return index;\n      }\n      "):2===this.dispatchLayout.x.length&&(r="vec2<i32>(flattenedIndex, coords[1])",s="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> vec2<i32> {\n        // N.B. |updates| could be a scalar tensor, conceptually representing a\n        // 2D tensor with all values equal to that. By design, its size must be\n        // the same as |outShape[1]| in one dimension, and |indicesShape[0]|\n        // gives the other.\n        let sliceSize = uniforms.outShape[1];\n        let d0 = index / sliceSize;\n        let d1 = index - d0 * sliceSize;\n        return vec2<i32>(d0, d1);\n      }\n      ");const i=`getUpdates(${Array.from({length:this.updatesRank},((e,t)=>`coords[${t}]`)).join(", ")})`;return`\n    ${s}\n\n      ${vt()}\n\n        if (index < uniforms.size) {\n          let coords = getUpdatesCoordsFromFlatIndex(index);\n          var flattenedIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexInside = i32(round(${t}));\n            flattenedIndex = flattenedIndex + indexInside * ${n};\n          }\n          let updateValue =\n              ${Tt(this.type,!1)}(${i});\n          let flatIndex = getOutputIndexFromCoords(${r});\n\n          ${((e,t)=>{let n=`atomicAdd(${e}, bitcast<i32>(${t}))`;"float32"===this.type&&(n=`\n          {\n            var oldBits = 0;\n            var newBits = bitcast<i32>(${t});\n            loop {\n              let info = atomicCompareExchangeWeak(${e}, oldBits, newBits);\n              if (info.exchanged) {\n                break;\n              }\n              oldBits = info.old_value;\n              let oldValue = bitcast<f32>(oldBits);\n              let newValue = oldValue + (${t});\n              newBits = bitcast<i32>(newValue);\n            }\n          }\n        `);const r=`atomicStore(${e}, bitcast<i32>(${t}));`;return this.sumDupeIndices?n:r})("&result[flatIndex]","updateValue")};\n        }\n      }`}}const qi={kernelName:Ge,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{indices:a,updates:o}=t,{shape:u}=i,{sliceRank:l,numUpdates:h,sliceSize:d,strides:c,outputSize:p}=n.calculateShapes(o,a,u),f=[p/d,d];if(0===p)return s.makeTensorInfo(u,a.dtype);const m=nn({inputs:{x:a},backend:s,attrs:{shape:[h,l]}}),g=nn({inputs:{x:o},backend:s,attrs:{shape:[h,d]}}),b=g.dtype,x=en({backend:s,attrs:{shape:f,value:0,dtype:b}}),w=[{type:"int32",data:[l]},{type:"int32",data:c},{type:"int32",data:[r.sizeFromShape(g.shape)]}],I=new Xi(g.shape,l,m.shape.length,g.shape.length,c,f,b),y=s.runWebGPUProgram(I,[g,m],b,w,x),k=nn({inputs:{x:y},backend:s,attrs:{shape:u}});return s.disposeData(m.dataId),s.disposeData(g.dataId),s.disposeData(y.dataId),k}};class Ki{constructor(e,t,n){this.variableNames=["c","a","b"],this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.cRank=e,this.rank=n,this.shaderKey="select"}getUserCode(){let e,t;if(this.rank>4)throw Error(`Where for rank ${this.rank} is not yet supported`);if(1===this.rank)t="resRC",e="resRC";else{const n=["resRC.x","resRC.y","resRC.z","resRC.w"],r=[],s=[];for(let e=0;e<this.outputShape.length;e++)s.push(`${n[e]}`),e<this.cRank&&r.push(`${n[e]}`);e=r.join(),t=s.join()}return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let cVal = getC(${e});\n          if (cVal >= 1.0) {\n            setOutputAtIndex(index, getA(${t}));\n          } else {\n            setOutputAtIndex(index, getB(${t}));\n          }\n        }\n      }\n    `}}const Yi={kernelName:Ue,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{condition:r,t:s,e:i}=t,a=new Ki(r.shape.length,s.shape,s.shape.length);return n.runWebGPUProgram(a,[r,s,i],h(s.dtype,i.dtype))}},ji={kernelName:Le,backendName:"webgpu",kernelFunc:fn({opType:mt.SIGMOID})},Qi={kernelName:Me,backendName:"webgpu",kernelFunc:fn({opType:mt.SIN})},Zi={kernelName:De,backendName:"webgpu",kernelFunc:fn({opType:mt.SINH})},Ji=mn({opType:ht.SUB,cpuKernelImpl:br,supportsComplex:!0}),ea={kernelName:We,backendName:"webgpu",kernelFunc:Ji};const ta={kernelName:Ve,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{logits:a}=t,{dim:o}=i,u=r.parseAxisParam([o],a.shape),l=ci({inputs:{x:a},backend:s,attrs:{reductionIndices:u,keepDims:!1}}),h=n.expandShapeToKeepDim(l.shape,u),d=nn({inputs:{x:l},backend:s,attrs:{shape:h}}),c=Ji({inputs:{a:a,b:d},backend:s}),p=Os({inputs:{x:c},backend:s}),f=Ts({inputs:{x:p},backend:s,attrs:{axis:u,keepDims:!1}}),m=nn({inputs:{x:f},backend:s,attrs:{shape:h}}),g=_i({inputs:{a:p,b:m},backend:s});return s.disposeData(l.dataId),s.disposeData(d.dataId),s.disposeData(c.dataId),s.disposeData(p.dataId),s.disposeData(f.dataId),s.disposeData(m.dataId),g}},na={kernelName:He,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{blockShape:o,paddings:u}=i;r.assert(a.shape.length<=4,(()=>"spaceToBatchND for rank > 4 with a WebGPU backend not implemented yet"));const l=o.reduce(((e,t)=>e*t)),h=[[0,0]];h.push(...u);for(let e=1+o.length;e<a.shape.length;++e)h.push([0,0]);const d=[],c=zi({inputs:{x:a},backend:s,attrs:{paddings:h,constantValue:0}}),p=n.getReshaped(c.shape,o,l,!1),f=n.getPermuted(p.length,o.length,!1),m=n.getReshapedPermuted(c.shape,o,l,!1),g=nn({inputs:{x:c},backend:s,attrs:{shape:p}}),b=zr({inputs:{x:g},backend:s,attrs:{perm:f}}),x=nn({inputs:{x:b},backend:s,attrs:{shape:m}});return d.push(c),d.push(g),d.push(b),d.forEach((e=>s.disposeData(e.dataId))),x}};class ra{constructor(e,t){this.variableNames=["A"],this.workGroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let r=0;r<n.length;r++)n[r]=e[r]*t[r];this.outputShape=n,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.rank=this.outputShape.length,this.shaderKey="tile"}getUserCode(){const e=function(e,t=""){if(e>=5)throw Error(`Tile for rank ${e} is not yet supported`);if(1===e)return`(resRC % ${t}aShape)`;const n=["resRC.x","resRC.y","resRC.z","resRC.w"],r=[];for(let s=0;s<e;s++)r.push(`(${n[s]} % ${t}aShape[${s}])`);return r.join()}(this.rank,"uniforms.");return`\n      ${vt()}\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          setOutputAtIndex(index, getA(${e}));\n        }\n      }\n    `}}function sa(e){const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{reps:a}=s;if(n.shouldExecuteOnCPU([i])||"string"===i.dtype||i.shape.length>=5){const e=n.readSync(i.dataId),t="string"===i.dtype?e.map((e=>r.decodeString(e))):e,s=d(i.shape,i.dtype,t),o=xr(s,a);return n.makeTensorInfo(o.shape,o.dtype,o.values)}const o=new ra(i.shape,a);return n.runWebGPUProgram(o,[i],i.dtype)}const ia={kernelName:Xe,backendName:"webgpu",kernelFunc:sa};const aa={kernelName:qe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{sparseIndices:a,sparseValues:o,defaultValue:u}=t,{outputShape:l}=i,{sliceRank:h,numUpdates:d,sliceSize:c,strides:p,outputSize:f}=n.calculateShapes(o,a,l),m=!1;if("string"===o.dtype){const e=s.bufferSync(a),t=s.bufferSync(o),n=r.decodeString(s.readSync(u.dataId)[0]),i=cr(e,t,l,f,c,d,h,p,n,m);return s.makeTensorInfo(l,i.dtype,i.values)}const g=[f/c,c],b=nn({inputs:{x:a},backend:s,attrs:{shape:[d,h]}}),x=o.shape.length?nn({inputs:{x:o},backend:s,attrs:{shape:[d,c]}}):ln({inputs:{x:o},backend:s}),w=x.dtype,I=s.makeTensorInfo([],w,r.makeZerosTypedArray(1,w)),y=nn({inputs:{x:u},backend:s,attrs:{shape:Array(g.length).fill(1)}}),k=sa({inputs:{x:y},backend:s,attrs:{reps:g}}),S=[{type:"int32",data:[h]},{type:"int32",data:p},{type:"int32",data:[r.sizeFromShape([d,c])]}];switch(d){case 0:break;case 1:{const e=new Xi([d,c],h,b.shape.length,x.shape.length,p,g,w,m);s.runWebGPUProgram(e,[x,b],w,S,k)}break;default:{const e=new Xi([d,c],h,b.shape.length,I.shape.length,p,g,w,m);s.runWebGPUProgram(e,[I,b],w,S,k)}{const e=new Xi([d,c],h,b.shape.length,x.shape.length,p,g,w);s.runWebGPUProgram(e,[x,b],w,S,k)}}const v=nn({inputs:{x:k},backend:s,attrs:{shape:l}});return s.disposeData(b.dataId),s.disposeData(x.dataId),s.disposeData(y.dataId),s.disposeData(I.dataId),s.disposeData(k.dataId),v}};const oa={kernelName:Ke,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:s,attrs:i}=e,{x:a}=t,{numOrSizeSplits:o,axis:u}=i,l=r.parseAxisParam(u,a.shape)[0],h=n.prepareSplitSize(a,o,l),d=a.shape.length,c=new Array(d).fill(0),p=a.shape.slice();return h.map((e=>{const t=[...p];t[l]=e;const n=Ur({inputs:{x:a},backend:s,attrs:{begin:c,size:t}});return c[l]+=e,n}))}},ua={kernelName:Ye,backendName:"webgpu",kernelFunc:fn({opType:mt.SQRT})},la={kernelName:je,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{x:n}=e,r=t,s=new pn(n.shape,mt.SQUARE);return r.runWebGPUProgram(s,[n],n.dtype)}},ha={kernelName:Qe,backendName:"webgpu",kernelFunc:mn({opType:ht.SQUARED_DIFFERENCE})};class da{constructor(e){this.variableNames=["x"],this.workPerThread=1,this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize,[this.workPerThread,1,1]);const t=kt(this.outputShape.length);this.uniforms=`begin : ${t},  strides : ${t}, `,this.shaderKey="stridedSlice"}getUserCode(){let e="";if(1===this.outputShape.length)e="coords * uniforms.strides + uniforms.begin";else{let t=0;e=this.outputShape.map(((e,n)=>(t++,1===this.outputShape.length?`coords * uniforms.strides[${n}] + uniforms.begin[${n}]`:`coords[${t-1}] * uniforms.strides[${n}] + uniforms.begin[${n}]`))).join(",")}return`\n       ${vt()}\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index);\n           setOutputAtIndex(index, getX(${e}));\n         }\n       }\n     `}}const ca={kernelName:Ze,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{begin:a,end:o,strides:u,beginMask:l,endMask:h,ellipsisMask:p,newAxisMask:f,shrinkAxisMask:m}=s,{finalShapeSparse:g,finalShape:b,isIdentity:x,sliceDim0:w,isSimpleSlice:I,begin:y,end:k,strides:S}=c.sliceInfo(i.shape,a,o,u,l,h,p,f,m);let v;if(x)v=nn({inputs:{x:i},backend:n,attrs:{shape:b}});else if(w||I){r.assert(i.shape.length>=1,(()=>`Input must have rank at least 1, got: ${i.shape.length}`));const e=c.computeOutShape(y,k,S),t=Ur({inputs:{x:i},backend:n,attrs:{begin:y,size:e}});v=nn({inputs:{x:t},backend:n,attrs:{shape:b}}),n.disposeData(t.dataId)}else{if(n.shouldExecuteOnCPU([i])){const e=n.readSync(i.dataId),t=d(i.shape,i.dtype,e),r=mr(g,t,S,y);v=n.makeTensorInfo(b,i.dtype,r.values)}else{const e=new da(g),t=[{type:"int32",data:y},{type:"int32",data:S}],r=n.runWebGPUProgram(e,[i],i.dtype,t);v=nn({inputs:{x:r},backend:n,attrs:{shape:b}}),n.disposeData(r.dataId)}}return v}};const pa={kernelName:Je,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{separator:s,nGramWidths:i,leftPad:a,rightPad:o,padWidth:u,preserveShortSequences:l}=r,{data:h,dataSplits:d}=t,c=n.readSync(h.dataId),p=n.readSync(d.dataId),[f,m]=gr(c,p,s,i,a,o,u,l);return[n.makeTensorInfo([f.length],"string",f),n.makeTensorInfo(d.shape,"int32",m)]}},fa={kernelName:et,backendName:"webgpu",kernelFunc:fn({opType:mt.TANH})};class ma{constructor(e){this.variableNames=["x","indices"],this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="inputSize : i32, firstPass : i32, negativeInf : f32,\n        dir : i32, inc : i32,",this.shaderKey="swap"}getUserCode(){return`\n        ${vt()}\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // We compare elements pair-wise within a group of size 2 * inc.\n            // The comparing rule for each group alternates between ascending\n            // and descending. Within each group, we compare each pair at\n            // positions i and i+inc. To decide whether an element at position i\n            // is x0 or x1, we mod it by 2 * inc, if the result is smaller than\n            // inc, it is in the first half of the group, we denote it as x0,\n            // otherwise we denote it as x1.\n            // For example, as shown in the Bitonic top K paper referenced\n            // above, Figure5(a) shows that element[1] is in the second half of\n            // the group when group size is 2, but it is in the first half of\n            // the group when group size is 4.\n            let isFirstInPair = elemIdx % (2 * uniforms.inc) < uniforms.inc;\n            var i = 0;\n            if (isFirstInPair) {\n              i = elemIdx;\n            } else {\n              i = elemIdx - uniforms.inc;\n            }\n\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.inc;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.inc));\n            }\n\n            var x0 = f32(0.0);\n            var x1 = f32(0.0);\n            if (i0 < uniforms.inputSize) {\n              x0 = getX(batch, i0);\n            } else {\n              x0 = uniforms.negativeInf;\n            }\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = uniforms.negativeInf;\n            }\n\n            let reverse = elemIdx % (2 * uniforms.dir) >= uniforms.dir;\n            let isGreater = x0 > x1 || (x0 == x1 && i1 > i0);\n            if (reverse == isGreater) {\n              // Elements in opposite order of direction\n              let iTemp = i0;\n              i0 = i1;\n              i1 = iTemp;\n            }\n            if (isFirstInPair) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      `}}class ga{constructor(e){this.variableNames=["x","indices"],this.workGroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.uniforms="inputSize : i32, firstPass : i32, k : i32,",this.shaderKey="merge"}getUserCode(){return`\n        ${vt()}\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // The output size is half of the previous size.\n            // If the previous sequence is | | | | _ _ _ _  | | | |  _ _ _ _\n            // (k=4), we only need to output the indices at positions |, the\n            // indices at positions _ can be thrown away, see Figure5(b) After\n            // Phase 2 (Merge phase) in the Bitonic Top K paper referenced\n            // above.\n            // For example, the paper shows we only need to output the orange\n            // bars. The output sequence should look like this | | | | | | | |.\n            // Because the sequence is halved, to map the output index back to\n            // the previous sequence to find the corresponding value, we need\n            // to double the index. When we double the index, we basically\n            // interpolate a position, so 2i looks like\n            // | _ | _ | _ | _ | _ | _ | _. We move the | to the first k\n            // position of each 2k positions by - elemIdx % k. E.g. for output\n            // at index 4,5,6,7, we want to get the corresponding element at\n            // original index 8,9,10,11, for output at index 8,9,10,11,\n            // we want to get the corresponding element at original index\n            // 16,17,18,19, so on and so forth.\n\n            var i = 0;\n            if (elemIdx < uniforms.k) {\n              i = elemIdx;\n            } else {\n              i = elemIdx * 2 - elemIdx % uniforms.k;\n            }\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.k;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.k));\n            }\n\n            let x0 = getX(batch, i0);\n            var x1 = f32(0.0);\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = x0;\n            }\n\n            if (x0 >= x1) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      `}}function ba(e,t){null!==t&&e.disposeData(t.dataId)}function xa(e){let t=1;for(;t<e;)t*=2;return t}const wa={kernelName:tt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:s}=e,{x:i}=t,{k:a,sorted:o}=s,u=i.shape,l=u[u.length-1];if(n.shouldExecuteOnCPU([i])){const e=n.readSync(i.dataId),[t,r]=wr(e,u,i.dtype,a,o);return[n.makeTensorInfo(t.shape,t.dtype,t.values),n.makeTensorInfo(r.shape,r.dtype,r.values)]}if(0===a)return u[u.length-1]=0,[n.makeTensorInfo(u,i.dtype,[]),n.makeTensorInfo(u,"int32",[])];if(1===l)return[i,en({attrs:{shape:u,dtype:"int32",value:0},backend:n})];const h=r.sizeFromShape(u)/l,d=nn({inputs:{x:i},attrs:{shape:[h,l]},backend:n}),c=xa(a),p=xa(l);let f=null;const m=()=>null===f?[d,d]:[d,f],g=(e,t,r)=>{const s=m(),i=new ma(r),a=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"float32",data:[Number.NEGATIVE_INFINITY]},{type:"int32",data:[e]},{type:"int32",data:[t]}],o=f;f=n.runWebGPUProgram(i,s,"int32",a),ba(n,o)};for(let e=1;e<c;e*=2){const t=2*e;for(let n=e;n>=1;n/=2)g(t,n,[h,p])}for(let e=p;e>c;e/=2){const t=m(),r=new ga([h,e/2]),s=[{type:"int32",data:[l]},{type:"int32",data:[null===f?1:0]},{type:"int32",data:[c]}],i=f;f=n.runWebGPUProgram(r,t,"int32",s),ba(n,i);const a=c/2,o=2*a;for(let e=a;e>=1;e/=2)g(o,e,f.shape)}let b=f;f=Ur({inputs:{x:f},backend:n,attrs:{begin:0,size:[h,a]}}),ba(n,b);let x=ni({inputs:{x:d,indices:f},backend:n,attrs:{axis:1,batchDims:1}});ba(n,d);const w=u.slice(0,-1);w.push(a),b=f,f=nn({inputs:{x:f},attrs:{shape:w},backend:n}),ba(n,b);const I=x;return x=nn({inputs:{x:x},attrs:{shape:w},backend:n}),ba(n,I),[x,f]}};class Ia{constructor(e){this.variableNames=["Image","Transforms"],this.uniforms="interpolationModeId : i32, fillModeId : i32, fillValue : f32,",this.workGroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Ft(this.outputShape),this.dispatch=Bt(this.dispatchLayout,this.outputShape,this.workGroupSize),this.shaderKey="transform"}getUserCode(){return`\n          fn mapCoord(outCoord : f32, len : f32) -> f32{\n            var inCoord = outCoord;\n            if(uniforms.fillModeId == 2) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  if (inCoord < sz2) {\n                    inCoord = sz2 * f32(i32(f32(-inCoord / sz2))) +\n                    inCoord;\n                  }\n                  if (inCoord < -len) {\n                    inCoord = inCoord + sz2;\n                  } else {\n                    inCoord = -inCoord - 1.0;\n                  }\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  inCoord = inCoord - sz2 * f32(i32(f32(inCoord / sz2)));\n                  if (inCoord >= len) {\n                    inCoord = sz2 - inCoord - 1.0;\n                  }\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 3) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord + len * (f32(i32(f32(-inCoord / sz))) + 1.0);\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord - len * f32(i32(f32(inCoord / sz)));\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 4) {\n              return clamp(outCoord, 0.0, len - 1.0);\n            }\n            return outCoord;\n          }\n          fn readWithFillValue(batch : i32, coordY : i32, coordX : i32,\n            channel : i32) -> f32 {\n            var outputValue : f32;\n            if (0 <= coordY && coordY < uniforms.imageShape[1] && 0 <= coordX && coordX < uniforms.imageShape[2]) {\n                outputValue = getImage(batch, coordY, coordX, channel);\n            } else {\n              outputValue = uniforms.fillValue;\n            }\n            return outputValue;\n          }\n\n          ${vt()}\n            if (index < uniforms.size) {\n              let coords = getCoordsFromIndex(index);\n              var outputValue : f32;\n              let batch = coords[0];\n              let x = coords[2];\n              let y = coords[1];\n              let channel = coords[3];\n              let xf = f32(x);\n              let yf = f32(y);\n              let a1 = getTransforms(batch, 0);\n              let a2 = getTransforms(batch, 1);\n              let a3 = getTransforms(batch, 2);\n              let b1 = getTransforms(batch, 3);\n              let b2 = getTransforms(batch, 4);\n              let b3 = getTransforms(batch, 5);\n              let c1 = getTransforms(batch, 6);\n              let c2 = getTransforms(batch, 7);\n              let projection = c1 * xf + c2 * yf + 1.0;\n              if (projection == 0.0) {\n                outputValue = uniforms.fillValue;\n              } else {\n                let inX = (a1 * xf + a2 * yf + a3) / projection;\n                let inY = (b1 * xf + b2 * yf + b3) / projection;\n                let mapX = mapCoord(inX, f32(uniforms.imageShape[2]));\n                let mapY = mapCoord(inY, f32(uniforms.imageShape[1]));\n\n                if (uniforms.interpolationModeId == 1) {\n                  let coordY = i32(round(mapY));\n                  let coordX = i32(round(mapX));\n                  outputValue = readWithFillValue(batch, coordY, coordX,\n                    channel);\n                } else {\n                  let yFloor = floor(mapY);\n                  let xFloor = floor(mapX);\n                  let yCeil = yFloor + 1.0;\n                  let xCeil = xFloor + 1.0;\n                  let valueYFloor = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yFloor), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yFloor), i32(xCeil), channel);\n                  let valueYCeil = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yCeil), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yCeil), i32(xCeil), channel);\n                  outputValue = (yCeil - mapY) * valueYFloor +\n                  (mapY - yFloor) * valueYCeil;\n                }\n              }\n              setOutputAtIndex(index, outputValue);\n            }\n          }\n        `}}const ya=[an,kr,Sr,Cr,Tr,Er,_r,Or,Mr,Xr,qr,jr,cn,ns,as,ls,hs,ds,ps,ws,Is,ks,$s,Bs,Ns,_s,Fs,Us,Ls,tn,Ds,Xs,Ws,Vs,js,Qs,Zs,ei,ri,si,ii,hn,Jr,ai,oi,ui,li,hi,di,pi,fi,mi,gi,bi,xi,Ii,As,yi,ki,Si,Wr,$i,Ri,Pi,Ti,Ei,Bi,Ni,Hr,Oi,Fi,Gi,rn,Li,Di,Vi,Hi,qi,Yi,ji,Qi,Zi,Lr,ca,pa,ta,na,aa,oa,ua,la,ha,ea,Es,fa,ia,wa,{kernelName:nt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{image:s,transforms:i}=t,{interpolation:a,fillMode:o,fillValue:u,outputShape:l}=r,[h,d,c,p]=s.shape,[f,m]=null!=l?l:[d,c],g=new Ia([h,f,m,p]),b="nearest"===a?1:2;let x;switch(o){case"constant":default:x=1;break;case"reflect":x=2;break;case"wrap":x=3;break;case"nearest":x=4}const w=[{type:"int32",data:[b]},{type:"int32",data:[x]},{type:"float32",data:[u]}];return n.runWebGPUProgram(g,[s,i],"float32",w)}},Pr,{kernelName:rt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{value:s}=t;let{axis:i}=r;i<0&&(i+=s.shape.length);const a=s,o=a.shape.length,u=s.shape[i],l=new Array(o-1);let h=0;for(let e=0;e<o;e++)e!==i&&(l[h++]=a.shape[e]);const d=[],c=new Array(o).fill(0),p=a.shape.slice();p[i]=1;const f=new Array(u);for(let e=0;e<f.length;e++){c[i]=e;const t=Ur({inputs:{x:a},backend:n,attrs:{begin:c,size:p}}),r=nn({inputs:{x:t},backend:n,attrs:{shape:l}});f[e]=r,d.push(t)}return d.forEach((e=>n.disposeData(e.dataId))),f}},Ci];for(const e of ya)st(e);class ka{constructor(e){this.device=e,this.numUsedBuffers=0,this.numFreeBuffers=0,this.freeBuffers=new Map,this.usedBuffers=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireUploadBuffer(e,t){return this.acquireBuffer(e,t,!0)}acquireBuffer(e,t,n=!1){const r=Sa(e,t);if(this.freeBuffers.has(r)||this.freeBuffers.set(r,[]),this.usedBuffers.has(r)||this.usedBuffers.set(r,[]),this.numBytesUsed+=e,this.numUsedBuffers++,this.freeBuffers.get(r).length>0){this.numFreeBuffers--;const e=this.freeBuffers.get(r).shift();return this.usedBuffers.get(r).push(e),e}this.numBytesAllocated+=e;const s=this.device.createBuffer({size:e,usage:t,mappedAtCreation:n});return this.usedBuffers.get(r).push(s),s}releaseBuffer(e,t,n){if(0===this.freeBuffers.size)return;const r=Sa(t,n);this.freeBuffers.has(r)||this.freeBuffers.set(r,[]),this.freeBuffers.get(r).push(e),this.numFreeBuffers++,this.numUsedBuffers--;const s=this.usedBuffers.get(r),i=s.indexOf(e);if(i<0)throw new Error("Cannot release a buffer that was never provided by this buffer manager");s.splice(i,1),this.numBytesUsed-=t}releaseUploadBuffer(e,t,n){e.mapAsync(GPUMapMode.WRITE).then((()=>{this.releaseBuffer(e,t,n)}),(e=>{}))}getNumUsedBuffers(){return this.numUsedBuffers}getNumFreeBuffers(){return this.numFreeBuffers}dispose(){this.freeBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeBuffers=new Map,this.usedBuffers=new Map,this.numUsedBuffers=0,this.numFreeBuffers=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function Sa(e,t){return`${e}_${t}`}class va{constructor(e){this.device=e,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures=new Map,this.usedTextures=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireTexture(e,t,n,r){const s=e*t*$a(n),i=Ca(e,t,n,r);if(this.freeTextures.has(i)||this.freeTextures.set(i,[]),this.usedTextures.has(i)||this.usedTextures.set(i,[]),this.numBytesUsed+=s,this.numUsedTextures++,this.freeTextures.get(i).length>0){this.numFreeTextures--;const e=this.freeTextures.get(i).shift();return this.usedTextures.get(i).push(e),e}this.numBytesAllocated+=s;const a=this.device.createTexture({size:[e,t],format:n,usage:r});return this.usedTextures.get(i).push(a),a}releaseTexture(e,t,n,r,s){if(0===this.freeTextures.size)return;const i=Ca(t,n,r,s);this.freeTextures.has(i)||this.freeTextures.set(i,[]),this.freeTextures.get(i).push(e),this.numFreeTextures++,this.numUsedTextures--;const a=this.usedTextures.get(i),o=a.indexOf(e);if(o<0)throw new Error("Cannot release a texture that was never provided by this texture manager");a.splice(o,1);const u=t*n*$a(r);this.numBytesUsed-=u}getNumUsedTextures(){return this.numUsedTextures}getNumFreeTextures(){return this.numFreeTextures}dispose(){this.freeTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeTextures=new Map,this.usedTextures=new Map,this.numUsedTextures=0,this.numFreeTextures=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function Ca(e,t,n,r){return`${e}_${t}_${n}_${r}`}function $a(e){if("rgba8unorm"===e)return 16;throw new Error(`${e} is not supported!`)}const Ra=t().getNumber("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD");class Aa extends it{constructor(e,n=!1){if(super(),this.commandQueueOwnedIds=new WeakSet,this.dispatchNumberInEncoder=0,this.disposed=!1,this.downloadWaitMs=0,this.tensorDataPendingDisposal=[],this.stagingPendingDisposal=[],this.uniformPendingDisposal=[],this.uploadWaitMs=0,!Lt())throw new Error("WebGPU is not supported on this device");this.pipelineCache={},this.device=e,this.queue=e.queue,this.currentCommandEncoder=null,this.currentComputePass=null,this.supportTimeQuery=n,this.bufferManager=new ka(this.device),this.textureManager=new va(this.device),this.tensorMap=new at(this,ot()),this.supportTimeQuery&&(this.querySet=this.device.createQuerySet({type:"timestamp",count:2})),t().getBool("WEBGPU_USE_PROFILE_TOOL")&&(this.dummyCanvas=document.createElement("canvas"),this.dummyCanvas.width=1,this.dummyCanvas.height=1,this.dummyContext=this.dummyCanvas.getContext("webgpu"),this.dummyContext.configure({device:e,format:"bgra8unorm"}),document.body.appendChild(this.dummyCanvas))}nextDataId(){return Aa.nextDataId++}floatPrecision(){return 32}defaultGpuBufferUsage(){return GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST}disposeData(e,t=!1){if(this.tensorDataPendingDisposal.indexOf(e)>=0)return!1;if(!this.tensorMap.has(e))return!0;const n=this.tensorMap.get(e);if(this.decRef(e),!t&&n.refCount>0)return!1;if(this.commandQueueOwnedIds.has(e))return this.tensorDataPendingDisposal.push(e),!1;const{complexTensorInfos:r}=this.tensorMap.get(e);return null!=r&&(this.disposeData(r.real.dataId,t),this.disposeData(r.imag.dataId,t)),this.releaseResource(e),this.tensorMap.delete(e),!0}memory(){return{numBytesInGPU:this.bufferManager.numBytesUsed,numBytesAllocatedInGPU:this.bufferManager.numBytesAllocated,unreliable:!1}}releaseResource(e){const t=this.tensorMap.get(e);if(t&&t.resourceInfo){if("texture"in t.resourceInfo){const e=t.resourceInfo;e.texture instanceof GPUTexture&&this.textureManager.releaseTexture(e.texture,e.width,e.height,e.format,e.usage),e.texture=null}else{const e=t.resourceInfo;this.bufferManager.releaseBuffer(e.buffer,e.size,e.usage),e.buffer=null}t.resourceInfo=null}}refCount(e){if(this.tensorMap.has(e)){return this.tensorMap.get(e).refCount}return 0}incRef(e){this.tensorMap.get(e).refCount++}decRef(e){if(this.tensorMap.has(e)){this.tensorMap.get(e).refCount--}}write(e,t,n){if("complex64"===n&&null!=e)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const r={id:this.nextDataId()};return this.tensorMap.set(r,{dtype:n,shape:t,values:e,refCount:1}),r}move(e,t,n,r,s){if("complex64"===r)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");this.tensorMap.set(e,{dtype:r,shape:n,values:t,refCount:s})}submitQueue(){this.ensureComputePassEnded(),this.queue.submit([this.currentCommandEncoder.finish()]),this.currentCommandEncoder=null,this.dispatchNumberInEncoder=0,this.commandQueueOwnedIds=new WeakSet,this.tensorDataPendingDisposal.forEach((e=>{this.releaseResource(e),this.tensorMap.delete(e)})),this.uniformPendingDisposal.forEach((e=>this.bufferManager.releaseBuffer(e.buffer,e.size,e.usage))),this.stagingPendingDisposal.forEach((e=>this.bufferManager.releaseUploadBuffer(e.buffer,e.size,e.usage))),this.tensorDataPendingDisposal=[],this.uniformPendingDisposal=[],this.stagingPendingDisposal=[]}ensureCommandEncoderReady(){this.currentCommandEncoder||(this.currentCommandEncoder=this.device.createCommandEncoder())}ensureComputePassEnded(){this.currentComputePass&&(this.currentComputePass.end(),this.currentComputePass=null)}getComputePass(){return this.currentComputePass||(this.currentComputePass=this.currentCommandEncoder.beginComputePass()),this.currentComputePass}async getBufferData(e,n){const s=this.bufferManager.acquireBuffer(n,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,s,0,n),this.submitQueue(),await s.mapAsync(GPUMapMode.READ);const i=s.getMappedRange().slice(0);return s.unmap(),null!=s&&this.bufferManager.releaseBuffer(s,n,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ),t().getBool("WEBGPU_USE_PROFILE_TOOL")&&(r.assert(void 0!==this.dummyContext,(()=>"Fail to get context for profiling tool")),this.dummyContext.getCurrentTexture()),i}convertAndCacheOnCPU(e,t){const n=this.tensorMap.get(e);return this.releaseResource(e),n.values=t,n.values}readSync(e){const t=this.tensorMap.get(e),{values:n}=t;if(null==n)throw new Error("WebGPU readSync is only available for CPU-resident tensors.");return n}async read(e){if(!this.tensorMap.has(e))throw new Error(`Tensor ${e} was not registered!`);const t=this.tensorMap.get(e),{values:r}=t;if(null!=r)return this.convertAndCacheOnCPU(e,r);let s;if("complex64"===t.dtype){const e=await Promise.all([this.read(t.complexTensorInfos.real.dataId),this.read(t.complexTensorInfos.imag.dataId)]),r=e[0],i=e[1];s=n.mergeRealAndImagArrays(r,i)}else{const e=t.resourceInfo;s=Ut(await this.getBufferData(e.buffer,e.size),t.dtype)}return this.convertAndCacheOnCPU(e,s),s}readToGPU(e){const t=this.tensorMap.get(e),{values:n,dtype:r,shape:s,resourceInfo:i}=t;if("complex64"===r)throw new Error("Does not support reading buffer for complex64 dtype.");if(null==i)throw null!=n?new Error("Data is not on GPU but on CPU."):new Error("There is no data on GPU or CPU.");const a=i.size,o=this.bufferManager.acquireBuffer(a,i.usage);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(i.buffer,0,o,0,a),this.submitQueue();const u=this.makeTensorInfo(s,r),l=ot().makeTensorFromTensorInfo(u);return this.tensorMap.get(u.dataId).resourceInfo={size:a,usage:this.defaultGpuBufferUsage(),buffer:o},{tensorRef:l,buffer:o,bufSize:a}}bufferSync(e){const t=this.readSync(e.dataId);if("string"===e.dtype)try{const n=t.map((e=>r.decodeString(e)));return d(e.shape,e.dtype,n)}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8")}return d(e.shape,e.dtype,t)}async time(e){const t=this.activeTimers,n=[];let s=!1;null==this.programTimersStack?(this.programTimersStack=n,s=!0):this.activeTimers.push(n),this.activeTimers=n,e();const i=r.flatten(this.activeTimers.map((e=>e.query))).filter((e=>null!=e)),a=r.flatten(this.activeTimers.map((e=>e.name))).filter((e=>null!=e));this.activeTimers=t,s&&(this.programTimersStack=null);const o={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},u=await Promise.all(i);return o.kernelMs=r.sum(u),o.getExtraProfileInfo=()=>u.map(((e,t)=>({name:a[t],ms:e}))).map((e=>`${e.name}: ${e.ms}`)).join(", "),this.uploadWaitMs=0,this.downloadWaitMs=0,o}makeTensorInfo(e,t,n){"string"===t&&null!=n&&n.length>0&&r.isString(n[0])&&(n=n.map((e=>r.encodeString(e))));return{dataId:this.write(n,e,t),shape:e,dtype:t}}tensorToBinding(e){if(!e)return null;const t=this.tensorMap.get(e.dataId);if("texture"in t.resourceInfo){const e=t.resourceInfo;return e.texture instanceof GPUExternalTexture?e.texture:e.texture.createView()}const n=t.resourceInfo;return{offset:0,size:n.size,buffer:n.buffer}}async getQueryTime(e){return this.supportTimeQuery?this.getTimeFromQuerySet(e):0}uploadToGPU(e){const t=this.tensorMap.get(e);if(t.resourceInfo)return;const n=Gt(t.dtype)*r.sizeFromShape(t.shape),s=this.bufferManager.acquireBuffer(n,this.defaultGpuBufferUsage());if(t.resourceInfo={size:n,usage:this.defaultGpuBufferUsage(),buffer:s},t.values){const e=this.bufferManager.acquireUploadBuffer(n,GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC),r=e.getMappedRange();"int32"===t.dtype||"bool"===t.dtype?new Int32Array(r).set(t.values):new Float32Array(r).set(t.values),e.unmap(),this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.copyBufferToBuffer(e,0,s,0,n);const i={size:n,usage:GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC,buffer:e};this.stagingPendingDisposal.push(i)}}makeUniforms(e){let t=0,n=0;const s=[];e.forEach((e=>{let i;switch(0===e.data.length&&(e.data=[1]),e.data.length){case 1:i=4;break;case 2:i=8;break;case 3:case 4:case 5:case 6:i=16;break;default:r.assert(!1,(()=>`Unsupported ${e.data.length}D shape`))}5!==n&&6!==n||(i=16),t=Math.ceil(t/i)*i,n=e.data.length,s.push(t),t+=4*e.data.length}));const i=new ArrayBuffer(t);e.forEach(((e,t)=>{const n=s[t];"int32"===e.type?new Int32Array(i,n,e.data.length).set(e.data):"uint32"===e.type?new Uint32Array(i,n,e.data.length).set(e.data):new Float32Array(i,n,e.data.length).set(e.data)}));const a=this.bufferManager.acquireBuffer(t,GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM);this.queue.writeBuffer(a,0,i,0,t);const o={size:t,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM,buffer:a};return this.uniformPendingDisposal.push(o),{offset:0,size:t,buffer:a}}runWebGPUProgram(e,s,i,a,o){if(o||(o=this.makeTensorInfo(e.outputShape,i)),0===r.sizeFromShape(o.shape))return this.tensorMap.get(o.dataId).values=r.getTypedArrayFromDType(o.dtype,0),o;this.uploadToGPU(o.dataId),e.dispatch=((e,t)=>{const n=e.limits.maxComputeWorkgroupsPerDimension,s=t.dispatchLayout,i=t.dispatch;if(i.every((e=>e<=n)))return i;r.assert(i[0]>n&&void 0===s.y&&void 0===s.z,(()=>"Dispatch size exceeds WebGPU limits in Y or Z dimension."));let a=Math.ceil(Math.sqrt(i[0]));return a>n?(a=Math.ceil(Math.cbrt(i[0])),r.assert(a<=n,(()=>"Total dispatch size exceeds WebGPU maximum.")),[a,a,a]):[a,a,1]})(this.device,e);let u=[],l=[];if(!e.isFromPixels){u.push({type:"float32",data:[NaN]}),l=s.concat(o).map((e=>e.shape));const t="int32";l.map((e=>{u.push({type:t,data:e})}));const n=r.computeStrides(o.shape);if(u.push({type:t,data:n}),e.size){const n=r.sizeFromShape(e.outputShape);u.push({type:t,data:[e.isVec4?n/4:n]})}}const h=s.map(((t,n)=>{if("complex64"===t.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");return this.uploadToGPU(t.dataId),{dtype:this.tensorMap.get(t.dataId).dtype,shape:t.shape,name:e.variableNames[n]}})),d=function(e,t,s,i){let a=e.shaderKey;if(e.isFromPixels)return a;const o=s.map((e=>e.dtype)).concat(i.dtype),u=s.map((e=>n.getBroadcastDims(e.shape,i.shape))),l=s.map((e=>r.arraysEqual(e.shape,i.shape))).join("_"),h=u.map((e=>e.join("_"))).join(";"),d=Pt(e)?"flatDispatch":"";return a+="_"+(e.workGroupSize?e.workGroupSize.join(","):"")+t.map((e=>e.length)).join(",")+o.join(",")+e.variableNames.join(",")+h+l+d,a}(e,l,h,o);let c;d in this.pipelineCache?c=this.pipelineCache[d]:(c=yt(this.device,e,h,o),this.pipelineCache[d]=c),a&&(u=[...u,...a]);const p=[this.tensorToBinding(o),...s.map((e=>this.tensorToBinding(e))),this.makeUniforms(u)],f=this.device.createBindGroup({layout:c.getBindGroupLayout(0),entries:p.map(((e,t)=>({binding:t,resource:e})))});this.ensureCommandEncoderReady();const m=this.getComputePass(),g=null!=this.activeTimers;return g&&this.supportTimeQuery&&m.writeTimestamp(this.querySet,0),m.setPipeline(c),m.setBindGroup(0,f),m.dispatchWorkgroups(e.dispatch[0],e.dispatch[1],e.dispatch[2]),g&&this.supportTimeQuery&&m.writeTimestamp(this.querySet,1),this.dispatchNumberInEncoder++,s.forEach((e=>{this.commandQueueOwnedIds.add(e.dataId)})),this.commandQueueOwnedIds.add(o.dataId),t().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchNumberInEncoder&&this.submitQueue(),g&&this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime(this.querySet)}),o}async getTimeFromQuerySet(e){const t=this.bufferManager.acquireBuffer(16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),n=this.bufferManager.acquireBuffer(16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST);this.ensureCommandEncoderReady(),this.ensureComputePassEnded(),this.currentCommandEncoder.resolveQuerySet(e,0,2,t,0),this.currentCommandEncoder.copyBufferToBuffer(t,0,n,0,16),this.submitQueue(),await n.mapAsync(GPUMapMode.READ);const r=new BigUint64Array(n.getMappedRange()),s=Number(r[1]-r[0]);return n.unmap(),this.bufferManager.releaseBuffer(n,16,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST),this.bufferManager.releaseBuffer(t,16,GPUBufferUsage.COPY_SRC|GPUBufferUsage.QUERY_RESOLVE),s/1e6}shouldExecuteOnCPU(e,n=Ra){return t().getBool("WEBGPU_CPU_FORWARD")&&e.every((e=>null==this.tensorMap.get(e.dataId).resourceInfo&&r.sizeFromShape(e.shape)<n))}numDataIds(){return this.tensorMap.numDataIds()-this.tensorDataPendingDisposal.length}dispose(){this.disposed||(this.bufferManager.dispose(),this.textureManager.dispose(),this.disposed=!0)}}Aa.nextDataId=0;var za={__proto__:null,webgpu_util:Dt,WebGPUBackend:Aa};Lt()&&ut("webgpu",(async()=>{t().set("CHECK_COMPUTATION_FOR_ERRORS",!1);const e={powerPreference:t().get("WEBGPU_USE_LOW_POWER_GPU")?"low-power":"high-performance"},n=await navigator.gpu.requestAdapter(e),r=n.limits,s={},i=n.features.has("timestamp-query");s.requiredLimits={maxComputeWorkgroupStorageSize:r.maxComputeWorkgroupStorageSize,maxComputeWorkgroupsPerDimension:r.maxComputeWorkgroupsPerDimension,maxStorageBufferBindingSize:r.maxStorageBufferBindingSize},i?s.requiredFeatures=["timestamp-query"]:console.warn("This device doesn't support timestamp-query extension. Start Chrome browser with flag --disable-dawn-features=disallow_unsafe_apis then try again. Or zero will shown for the kernel time when profiling mode isenabled. Using performance.now is not workable for webgpu sinceit doesn't support synchronously to read data from GPU.");const a=await n.requestDevice(s);return new Aa(a,i)}),3);export{za as webgpu};
//# sourceMappingURL=tf-backend-webgpu.fesm.min.js.map
